﻿-- HuntBars by Nikaas/Dirik of Neptulon EU
-- This program is distributed under the terms of
-- the GNU General Public License version 3 or later.
-- For more info look at README.txt and COPYING.txt

HuntBars = LibStub("AceAddon-3.0"):NewAddon("HuntBars", "AceConsole-3.0", "AceEvent-3.0")
local AceConfig = LibStub("AceConfig-3.0")
local AceConfigDialog = LibStub("AceConfigDialog-3.0")
local AceConfigRegistry = LibStub("AceConfigRegistry-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("HuntBars", false)
local SharedMedia = LibStub("LibSharedMedia-3.0")
local LDB = LibStub:GetLibrary("LibDataBroker-1.1")

local OnUpdateFrame = CreateFrame("Frame", UIParent)
local HBAddonGeneralFrame = CreateFrame("Frame", "HBFEAddonGeneral", UIParent)

-- To Do: (1) These variables to be placed in sub-table within HB table
local HB_durConst, HB_durConst2, HB_durConst3, HB_durConst4, HB_durConst5, HB_durConst6, HB_durConst7, HB_durConst8 = 0, 0, 0, 0, 0, 0, 0, 0
local HB_startConst, HB_startConst2, HB_startConst3, HB_startConst4, HB_startConst5, HB_startConst6, HB_startConst7, HB_startConst8 = 0, 0, 0, 0, 0, 0, 0, 0



-- Initializing and assigning default values for variables and options not part of Ace options table
local HB = {
	Slots = {},
	Text = {},
	SpellInfo = { 
		Chimera = GetSpellInfo(53209),
		ReadySetAim = GetSpellInfo(82925),
		ImprovedSteady = GetSpellInfo(53220),
		KillCommand = GetSpellInfo(34026),
		Fire = GetSpellInfo(82926),
		Frenzy = GetSpellInfo(19615),
		FocusFire = GetSpellInfo(82692),
		ExplosiveShot = GetSpellInfo(53301),
		BlackArrow = GetSpellInfo(3674),
		LocknLoad = GetSpellInfo(56453),
		SerpentSting = GetSpellInfo(1978),
		KillShot = GetSpellInfo(53351),
		RapidFire = GetSpellInfo(3045),
	},
	Spec = 0,
	ConfigMode = false,
	FramesCreated = false,
	InitialLoad = false,
	UpdateInterval = 0.06,
	SteadyCobra = false,
	FocusExtended = false,
	FocusGain = 0,
    BarsGeneralFrame = CreateFrame("Frame", "HBGeneral", HBAddonGeneralFrame),
    SAFocusGeneralFrame = CreateFrame("Frame", "SAFocusGeneral", HBAddonGeneralFrame),
	cust1filter = true,	
	cust2filter = true,	
	cust3filter = true,
}

-- LibDataBroker button
local ldbObj = {
	type = "data source",
	icon = "Interface\\AddOns\\HuntBars\\Images\\hb32.tga",
	label = "HuntBars",
	text = "HuntBars",
	OnTooltipShow = function(self)
		self:AddLine("HuntBars")
		self:AddLine("Left Click to open Options panel")
		self:AddLine("Shift-Right Click to enable/disable Configuration mode")
	end,
	OnClick = function(clickframe, ldbbutton)
		clickframe:SetScript("OnMouseUp", function(frame, button)
			if (button == "LeftButton") and (not IsShiftKeyDown() and not IsControlKeyDown() and not IsAltKeyDown()) then
				AceConfigDialog:Open("HuntBars")
			end
			if (button == "RightButton") and (IsShiftKeyDown() and not IsControlKeyDown() and not IsAltKeyDown()) then
				if not HB.ConfigMode then
					HB.ConfigMode = true
					HuntBars:ConfigMode()
				else
					HB.ConfigMode = false
					HuntBars:ConfigMode()
				end
			end
		end)
	end,
}




-- Default values for the options(HuntBarsOptions table) that are still not changed by the user
local HuntBarsDefaults = {
	profile = {
		['*'] = {
		barswidth = 230,
		barsheight = 15,
		barsdistance = 2,
		barstext = "text1",
		fontsize = 12,
		clamped = true,
		hidefocus = false,
		additmode = true,
		focusonlymode = false,
		strata = "MEDIUM",
		backtransparency = 1,
		incombatonly = false,
		amountadditbars = 3,
		sspos = 1,
		kspos = 2,
		rfpos = 3,
		amountsurvbars = 3,
		espos = 1,
		lnlpos = 3,
		bapos = 2,
		amountmarksbars = 3,
		cspos = 1,
		isspos = 2,
		rsapos = 3,
		amountbmbars = 3,
		kcpos = 1,
		frpos =2,
		ffpos = 3,
		cust1pos = 4,
		cust2pos = 5,
		cust3pos = 6,
		c1type = "debuff",
		c2type = "buff",
		c3type = "cooldown",
		c1ID = "Hunter's Mark",
		c2ID = "Misdirection",
		c3ID = "Silencing Shot",
		c1name = "",
		c2name = "",
		c3name = "",
		killcolor = {r=170/255, g=10/255, b=130/255}, -- purple
		frenzycolor = {r=10/255, g=10/255, b=170/255}, -- blue
		frenzyextracolor = {r=170/255, g=10/255, b=10/255}, -- red
		focusfirecolor = {r=170/255, g=10/255, b=130/255}, -- purple
		chimeracolor = {r=170/255, g=10/255, b=130/255}, -- purple
		improvedsscolor = {r=170/255, g=10/255, b=130/255}, -- purple
		readysetaimcolor = {r=10/255, g=10/255, b=170/255}, -- blue
		readysetaimextracolor = {r=170/255, g=10/255, b=10/255}, -- red
		explosivecolor = {r=170/255, g=10/255, b=130/255}, -- purple
		explosiveextracolor = {r=170/255, g=10/255, b=10/255}, -- red
		blackarrowcolor = {r=170/255, g=10/255, b=130/255}, -- purple
		locknloadcolor = {r=170/255, g=10/255, b=130/255}, -- purple
		serpentcolor = {r=170/255, g=10/255, b=130/255}, -- purple
		killshotcolor = {r=170/255, g=10/255, b=130/255}, -- purple
		rapidfirecolor = {r=170/255, g=10/255, b=10/255}, -- red
		rapidfireextracolor = {r=255/255, g=200/255, b=1/255}, -- yellow
		cust1color = {r=255/255, g=200/255, b=1/255}, -- yellow
		cust2color = {r=255/255, g=200/255, b=1/255}, -- yellow
		cust3color = {r=255/255, g=200/255, b=1/255}, -- yellow
		killtime = 10,
		frenzytime = 10, -- stacks bar, time variable is used ONLY at default value
		focusfiretime = 10,
		chimeratime = 10,
		improvedsstime = 10,
		readysetaimtime = 10, -- stacks bar, time variable is used ONLY at default value
		explosivetime = 10,
		blackarrowtime = 10,
		locknloadtime = 10,
		serpenttime = 10,
		killshottime = 10,
		rapidfiretime = 10,
		cust1time = 10,
		cust2time = 10,
		cust3time = 10,
		cust1otherscast = true,		
		cust2otherscast = false,		
		cust3otherscast = false,
		}
	}
}

-- Configuration panel. This table is used by Ace to create the options dialog.
local HuntBarsOptions = {
	type = "group",
	handler = HuntBars,
	args = {
		--[ Command for showing options panel from the command prompt(chat), to activate type: /huntbars gconf
		gconf = {
			name = "Config",
			desc = "Opens configuration window",
			order = 0,
			guiHidden = true,
			type = "execute",
			func = function(info, val) AceConfigDialog:Open("HuntBars") end,
		},	--]]
		general = {
			name = "General Options",
			type = "group",
			childGroups = "tab",
			order = 1,
			args = {
				configmode = {
					name = L["Configuration mode"],
					desc = L["Toggles the inactive frames to see the results of changing an appearance options."],
					type = "toggle",
					order = 0,
					set = function (info,val) HB.ConfigMode = val HuntBars:ConfigMode() end,
					get = function(info) return HB.ConfigMode end,
				},
				additmode = {
					name = L["Extended mode"],
					desc = L["Toggles the frame with additional bars."],
					type = "toggle",
					order = 1,
					set = function (info,val) HuntBars.db.profile.addit.additmode = val
						if HuntBars.db.profile.addit.additmode == true then
							HuntBars.AdditFrame:Show()
						else
							HuntBars.AdditFrame:Hide()
						end
					end,
					get = function(info) return HuntBars.db.profile.addit.additmode end,
				},
				hidefocus = {
					name = L["Hide Focus"],
					desc = L["Removes Focus bar from the frames (Not recommended because it contains important additional info)."],
					type = "toggle",
					order = 2,
					set = function(info, val) HuntBars.db.profile.general.hidefocus = val HuntBars:DrawAllBars() end,
					get = function(info) return HuntBars.db.profile.general.hidefocus end,
				},
				focusonlymode = {
					name = L["Focus bar only mode"],
					desc = L["Toggles between focus bar only and full mode. To adjust this bar use Extended mode controls."],
					type = "toggle",
					order = 3,
					set = function (info,val) HuntBars.db.profile.general.focusonlymode = val
						if HuntBars.db.profile.general.focusonlymode == true then
							HB.BarsGeneralFrame:Hide()
							HB.SAFocusGeneralFrame:Show()
						else
							HB.BarsGeneralFrame:Show()
							HB.SAFocusGeneralFrame:Hide()
						end								
					end,
					get = function(info) return HuntBars.db.profile.general.focusonlymode end,
				},
				mainheader = {
					name = L["General Preferences"],
					type = "header",
					order = 10,
				},
				texture = {
					name = L["Bars Texture"],
					desc = L["Selects the texture to use for the bars."],
					type = "select",
					order = 11,
					dialogControl = "LSM30_Statusbar",
					values = AceGUIWidgetLSMlists.statusbar,
					set = function(info, val) HuntBars.db.profile.general.texture = val
											  HuntBars:DrawAllBars()
											  end,
					get = function(info) return HuntBars.db.profile.general.texture end,
				},
				combatonly = {
					name = L["Show in combat only"],
					desc = L["Frames are shown only during combat."],
					type = "toggle",
					order = 12,
					set = function(info, val) HuntBars.db.profile.general.incombatonly = val 
						if HuntBars.db.profile.general.incombatonly == true and not InCombatLockdown() and not HB.ConfigMode then
							HBAddonGeneralFrame:Hide()
						else
							HBAddonGeneralFrame:Show()
						end
					end,
					get = function(info) return HuntBars.db.profile.general.incombatonly end,
				},
				clamp = {
					name = L["Clamp Frames"],
					desc = L["Clamps the frames so they can't get out of the screen borders."],
					type = "toggle",
					order = 13,
					set = function(info, val) HuntBars.db.profile.general.clamped = val HuntBars:DrawAllBars() end,
					get = function(info) return HuntBars.db.profile.general.clamped end,
				},
				clickthrough = {
					name = L["Click Through"],
					desc = L["Makes the frames non-interactive. This works only when not in Configuration mode."],
					type = "toggle",
					order = 14,
					set = function(info, val) HuntBars.db.profile.general.clickthrough = val HuntBars:DrawAllBars() end,
					get = function(info) return HuntBars.db.profile.general.clickthrough end,
				},
				strata = {
					name = L["Frames Strata"],
					desc = L["Changes how the addon frames are drawn - below or on top compared to the other interface elements."],
					type = "select",
					values = {strata1="TOOLTIP (Highest)", strata2="FULLSCREEN_DIALOG", strata3="FULLSCREEN", strata4="DIALOG", strata5="HIGH", strata6="MEDIUM (Default)", strata7="LOW", strata8="BACKGROUND (Lowest)"},
					order = 15,
					set = function (info,val) HuntBars.db.profile.general.stratadropdown = val
						if val == "strata1" then HuntBars.db.profile.general.strata = "TOOLTIP"
						elseif val == "strata2" then HuntBars.db.profile.general.strata = "FULLSCREEN_DIALOG"
						elseif val == "strata3" then HuntBars.db.profile.general.strata = "FULLSCREEN"
						elseif val == "strata4" then HuntBars.db.profile.general.strata = "DIALOG"
						elseif val == "strata5" then HuntBars.db.profile.general.strata = "HIGH"
						elseif val == "strata6" then HuntBars.db.profile.general.strata = "MEDIUM"
						elseif val == "strata7" then HuntBars.db.profile.general.strata = "LOW"
						elseif val == "strata8" then HuntBars.db.profile.general.strata = "BACKGROUND"
						end
						HB.BarsGeneralFrame:SetFrameStrata(HuntBars.db.profile.general.strata)
						HB.SAFocusGeneralFrame:SetFrameStrata(HuntBars.db.profile.general.strata)
						--HuntBars:DrawAllBars()
					end,
					get = function(info) return HuntBars.db.profile.general.stratadropdown end,
				},
				backtransparency = {
					name = L["Background Transparency"],
					desc = L["Changes the transparency of the backgrounds."],
					order = 16,
					type = "range",
					min = 0,
					max = 1,
					softMin = 0,
					softMax = 1,
					step = 0.05,
					set = function (info, val) HuntBars.db.profile.general.backtransparency = val HuntBars:DrawAllBars() end,
					get = function (info) return HuntBars.db.profile.general.backtransparency end,
				},
				versionheader = {
					name = "HuntBars 1.3.5",
					type = "header",
					order = 100,
				},
				lastnewstext = {
					name = "v1.3.4 - Focus Fire bar now have different colors for buff and cooldown. Added LibDataBroker(TitanPanel/FuBar) button.\nv1.3.5 - Updated for Patch 4.3 Hour of Twilight",
					type = "description",
					order = 101,
				},
				feedbacktext = {
					name = "\nPlease report bugs at addon's pages at Curse.com/CurseForge.com/WoWInterface.com.",
					type = "description",
					order = 102,
				},
				framemovetext = {
					name = "\nTo move a frame when not in config mode use Ctrl+Shift+Left Mouse Button. For this to work \"Click Through\" option must be disabled.",
					type = "description",
					order = 103,
				},
				translatorstext = {
					name = "\nTranslations:\nGerman(deDE) - Translator needed\nSpanish(esES) - Translator needed\nFrench(frFR) - Translator needed\nRussian(ruRU) - Transltor needed\nLatin American Spanish(esMX) - Translator needed\nKorean(koKR) - Translator needed\nSimplified Chinese(zhCN) - Translator needed\nPartial Traditional Chinese(zhTW) by silentworld",
					type = "description",
					order = 104,
				},
			},
		},
		beastmastery = {
			name = "Beast Mastery",
			type = "group",
			childGroups = "tab",
			order = 2,
			args = {
				visuals = {
					name = L["Visuals"],
					desc = L["Options to adjust frame's visual preferences."],
					order = 50,
					type = "group",
					args = {
						configmode = {
							name = L["Configuration mode"],
							desc = L["Toggles the inactive frames to see the results of changing an appearance options."],
							type = "toggle",
							order = 0,
							set = function (info,val) HB.ConfigMode = val HuntBars:ConfigMode() end,
							get = function(info) return HB.ConfigMode end,
						},
						additmode = {
							name = L["Extended mode"],
							desc = L["Toggles the frame with additional bars."],
							type = "toggle",
							order = 1,
							set = function (info,val) HuntBars.db.profile.addit.additmode = val
								if HuntBars.db.profile.addit.additmode == true then
									HuntBars.AdditFrame:Show()
								else
									HuntBars.AdditFrame:Hide()
								end
							end,
							get = function(info) return HuntBars.db.profile.addit.additmode end,
						},
						hidefocus = {
							name = L["Hide Focus"],
							desc = L["Removes Focus bar from the frames (Not recommended because it contains important additional info)."],
							type = "toggle",
							order = 2,
							set = function(info, val) HuntBars.db.profile.general.hidefocus = val HuntBars:DrawAllBars() end,
							get = function(info) return HuntBars.db.profile.general.hidefocus end,
						},
						apearheader = {
							name = L["Beast Mastery Bars Size Preferences"],
							type = "header",
							order = 50,
						},
						barswidth = {
							name = L["Width"],
							desc = L["Changes the width of the bars (Manual set range 10 - 1200)."],
							order = 51,
							type = "range",
							min = 10,
							max = 1200,
							softMin = 100,
							softMax = 600,
							step = 5,
							set = function (info, val) HuntBars.db.profile.beastmastery.barswidth = val HuntBars:DrawBMBars() end,
							get = function (info) return HuntBars.db.profile.beastmastery.barswidth end,
						},
						barsheight = {
							name = L["Height"],
							desc = L["Changes the height of the bars (Manual set range 5 - 250)."],
							order = 52,
							type = "range",
							min = 5,
							max = 250,
							softMin = 5,
							softMax = 100,
							step = 1,
							set = function (info, val) HuntBars.db.profile.beastmastery.barsheight = val HuntBars:DrawBMBars() end,
							get = function (info) return HuntBars.db.profile.beastmastery.barsheight end,
						},
						barsdistance = {
							name = L["Distance"],
							desc = L["Changes the distance between the bars (Manual set range 0 - 250)."],
							order = 53,
							type = "range",
							min = 0,
							max = 250,
							softMin = 0,
							softMax = 100,
							step = 1,
							set = function (info, val) HuntBars.db.profile.beastmastery.barsdistance = val HuntBars:DrawBMBars() end,
							get = function (info) return HuntBars.db.profile.beastmastery.barsdistance end,
						},
						--[[barstime = {
							name = L["Bars Time"],
							desc = L["Changes how much time is covered by a bar. The bars start to drop after the amount set here (Manual set range 2sec - 600sec)."],
							order = 54,
							type = "range",
							min = 2,
							max = 600,
							softMin = 2,
							softMax = 120,
							step = 1,
							set = function (info, val) HuntBars.db.profile.beastmastery.barstime = val HuntBars:DrawBMBars() end,
							get = function (info) return HuntBars.db.profile.beastmastery.barstime end,
						},]]
						textheader = {
							name = L["Beast Mastery Text Preferences"],
							type = "header",
							order = 60,
						},
						barsfont = {
							name = L["Font Type"],
							desc = L["Changes the font of the bars\' text."],
							order = 61,
							type = "select",
							dialogControl = "LSM30_Font",
							values = AceGUIWidgetLSMlists.font,
							set = function(info, val) HuntBars.db.profile.beastmastery.barsfont = val HuntBars:DrawBMBars() end,
							get = function(info) return HuntBars.db.profile.beastmastery.barsfont end,
						},
						fontsize = {
							name = L["Font Size"],
							desc = L["Changes the size of the selected font (Manual set range 4 - 32)."],
							order = 62,
							type = "range",
							min = 4,
							max = 32,
							softMin = 4,
							softMax = 32,
							step = 1,
							set = function (info, val) HuntBars.db.profile.beastmastery.fontsize = val HuntBars:DrawBMBars() end,
							get = function (info) return HuntBars.db.profile.beastmastery.fontsize end,
						},
						barstext = {
							name = L["Bars Text"],
							desc = L["Toggles how text (like shot names) is shown on top of the bars."],
							order = 63,
							type = "select",
							values = {text1="Full Text", text2="Short Text", text3="Disabled"},
							set = function (info, val) HuntBars.db.profile.beastmastery.barstext = val
								HuntBars:AssignSpellNames()
								HuntBars:DrawBMBars()
							end,
							get = function (info) return HuntBars.db.profile.beastmastery.barstext end,
						},
						selectheader = {
							name = L["Beast Mastery Visual Preferences"],
							type = "header",
							order = 70,
						},								
						activebar = {
							name = L["Bar Select"],
							desc = L["Selects the bar that preferences will be applied to."],
							order = 71,
							type = "select",
							values = {kill="Kill Command", frenzy="Frenzy Stacks", focusfire="Focus Fire"},
							set = function (info, val) HuntBars.db.profile.beastmastery.activebar = val end,
							get = function (info) return HuntBars.db.profile.beastmastery.activebar end,
						},
						barcolor = {
							name = L["Bar Color"],
							desc = L["Changes the color of the bar."],
							type = "color",
							order = 72,
							hasAlpha = false,
							set = function(info, r, g, b)
								if HuntBars.db.profile.beastmastery.activebar == "kill" then
									HuntBars.db.profile.beastmastery.killcolor = {}
									HuntBars.db.profile.beastmastery.killcolor["r"] = r
									HuntBars.db.profile.beastmastery.killcolor["g"] = g
									HuntBars.db.profile.beastmastery.killcolor["b"] = b
								elseif HuntBars.db.profile.beastmastery.activebar == "frenzy" then
									HuntBars.db.profile.beastmastery.frenzycolor = {}
									HuntBars.db.profile.beastmastery.frenzycolor["r"] = r
									HuntBars.db.profile.beastmastery.frenzycolor["g"] = g
									HuntBars.db.profile.beastmastery.frenzycolor["b"] = b
								elseif HuntBars.db.profile.beastmastery.activebar == "focusfire" then
									HuntBars.db.profile.beastmastery.focusfirecolor = {}
									HuntBars.db.profile.beastmastery.focusfirecolor["r"] = r
									HuntBars.db.profile.beastmastery.focusfirecolor["g"] = g
									HuntBars.db.profile.beastmastery.focusfirecolor["b"] = b
								end
								HuntBars:DrawBMBars()
							end,
							get = function(info)
								if HuntBars.db.profile.beastmastery.activebar == "kill" then
									return HuntBars.db.profile.beastmastery.killcolor["r"], HuntBars.db.profile.beastmastery.killcolor["g"], HuntBars.db.profile.beastmastery.killcolor["b"]
								elseif HuntBars.db.profile.beastmastery.activebar == "frenzy" then
									return HuntBars.db.profile.beastmastery.frenzycolor["r"], HuntBars.db.profile.beastmastery.frenzycolor["g"], HuntBars.db.profile.beastmastery.frenzycolor["b"]
								elseif HuntBars.db.profile.beastmastery.activebar == "focusfire" then
									return HuntBars.db.profile.beastmastery.focusfirecolor["r"], HuntBars.db.profile.beastmastery.focusfirecolor["g"], HuntBars.db.profile.beastmastery.focusfirecolor["b"]
								end
							end
						},
						bartime = {
							name = L["Bar Max Duration"],
							desc = L["Changes how much time is covered by the bar. The bar start to drop after the amount set here (Manual set range 2sec - 600sec)."],
							order = 73,
							type = "range",
							hidden = "checkstacktypeBM",
							min = 2,
							max = 600,
							softMin = 2,
							softMax = 120,
							step = 1,
							set = function (info, val)
								if HuntBars.db.profile.beastmastery.activebar == "kill" then
									HuntBars.db.profile.beastmastery.killtime = val
								elseif HuntBars.db.profile.beastmastery.activebar == "frenzy" then
									HuntBars.db.profile.beastmastery.frenzytime = val
								elseif HuntBars.db.profile.beastmastery.activebar == "focusfire" then
									HuntBars.db.profile.beastmastery.focusfiretime = val
								end
								HuntBars:DrawBMBars()
							end,
							get = function (info)
								if HuntBars.db.profile.beastmastery.activebar == "kill" then
									return HuntBars.db.profile.beastmastery.killtime
								elseif HuntBars.db.profile.beastmastery.activebar == "frenzy" then
									return HuntBars.db.profile.beastmastery.frenzytime
								elseif HuntBars.db.profile.beastmastery.activebar == "focusfire" then
									return HuntBars.db.profile.beastmastery.focusfiretime
								end
							end
						},
						frenzycolor2 = {
							name = L["Bar Color at Frenzy x5"],
							desc = L["Color used when pet has 5 stacks of Frenzy."],
							type = "color",
							hidden = "notcheckstacktypeBM",
							order = 74,
							hasAlpha = false,
							set = function(info, r, g, b)
								HuntBars.db.profile.beastmastery.frenzyextracolor = {}
								HuntBars.db.profile.beastmastery.frenzyextracolor["r"] = r
								HuntBars.db.profile.beastmastery.frenzyextracolor["g"] = g
								HuntBars.db.profile.beastmastery.frenzyextracolor["b"] = b
								HuntBars:DrawBMBars()
							end,
							get = function(info)
								return HuntBars.db.profile.beastmastery.frenzyextracolor["r"], HuntBars.db.profile.beastmastery.frenzyextracolor["g"], HuntBars.db.profile.beastmastery.frenzyextracolor["b"]
							end,
						},
					},
				},
				barorder = {
					name = L["Bars order"],
					desc = L["Options to set bars' order and amount."],
					order = 60,
					type = "group",
					args = {
						configmode = {
							name = L["Configuration mode"],
							desc = L["Toggles the inactive frames to see the results of changing an appearance options."],
							type = "toggle",
							order = 0,
							set = function (info,val) HB.ConfigMode = val HuntBars:ConfigMode() end,
							get = function(info) return HB.ConfigMode end,
						},
						additmode = {
							name = L["Extended mode"],
							desc = L["Toggles the frame with additional bars."],
							type = "toggle",
							order = 1,
							set = function (info,val) HuntBars.db.profile.addit.additmode = val
								if HuntBars.db.profile.addit.additmode == true then
									HuntBars.AdditFrame:Show()
								else
									HuntBars.AdditFrame:Hide()
								end
							end,
							get = function(info) return HuntBars.db.profile.addit.additmode end,
						},
						hidefocus = {
							name = L["Hide Focus"],
							desc = L["Removes Focus bar from the frames (Not recommended because it contains important additional info)."],
							type = "toggle",
							order = 2,
							set = function(info, val) HuntBars.db.profile.general.hidefocus = val HuntBars:DrawAllBars() end,
							get = function(info) return HuntBars.db.profile.general.hidefocus end,
						},
						mainheader = {
							name = L["Beast Mastery bars"],
							type = "header",
							order = 10,
						},
						totalbars = {
							name = L["Amount of bars"],
							desc = L["Changes the amount of bars inside the frame."],
							type = "select",
							values = {total1="1 Bar", total2="2 Bars", total3="3 Bars"},
							order = 11,
							set = function (info,val) HuntBars.db.profile.beastmastery.totalbars = val
								if val == "total1" then HuntBars.db.profile.beastmastery.amountbmbars = 1
								elseif val == "total2" then HuntBars.db.profile.beastmastery.amountbmbars = 2
								elseif val == "total3" then HuntBars.db.profile.beastmastery.amountbmbars = 3 end
								if HuntBars.db.profile.beastmastery.kcpos > HuntBars.db.profile.beastmastery.amountbmbars then
									HuntBars.KillCommandCDBar:Hide()
								elseif HuntBars.db.profile.beastmastery.kcpos ~= 0 then
									HuntBars.KillCommandCDBar:Show()
								end
								if HuntBars.db.profile.beastmastery.frpos > HuntBars.db.profile.beastmastery.amountbmbars then
									HuntBars.FrenzyBar:Hide()
								elseif HuntBars.db.profile.beastmastery.frpos ~= 0 then
									HuntBars.FrenzyBar:Show()
								end
								if HuntBars.db.profile.beastmastery.ffpos > HuntBars.db.profile.beastmastery.amountbmbars then
									HuntBars.FocusFireCDBar:Hide()
								elseif HuntBars.db.profile.beastmastery.ffpos ~= 0 then
									HuntBars.FocusFireCDBar:Show()
								end
								HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.beastmastery.totalbars end,
						},
						killcommand = {
							name = GetSpellInfo(34026),
							desc = L["Changes the position of the bar."],
							type = "select",
							values = {pos1="Position 1", pos2="Position 2", pos3="Position 3"},
							order = 12,
							set = function (info,val) HuntBars.db.profile.beastmastery.kcposmenu = val
								--if val == "off" then HuntBars.db.profile.beastmastery.kcpos = 0 HuntBars.KillCommandCDBar:Hide()
								if val == "pos1" then HuntBars.db.profile.beastmastery.kcpos=1 HuntBars.KillCommandCDBar:Show()
								elseif val == "pos2" then HuntBars.db.profile.beastmastery.kcpos=2 HuntBars.KillCommandCDBar:Show()
								elseif val == "pos3" then HuntBars.db.profile.beastmastery.kcpos=3 HuntBars.KillCommandCDBar:Show() end

								HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.beastmastery.kcposmenu end,
						},
						frenzy = {
							name = GetSpellInfo(19615),
							desc = L["Changes the position of the bar."],
							type = "select",
							values = {pos1="Position 1", pos2="Position 2", pos3="Position 3"},
							order = 13,
							set = function (info,val) HuntBars.db.profile.beastmastery.frposmenu = val
								--if val == "off" then HuntBars.db.profile.beastmastery.frpos = 0 HuntBars.FrenzyBar:Hide()
								if val == "pos1" then HuntBars.db.profile.beastmastery.frpos=1 HuntBars.FrenzyBar:Show()
								elseif val == "pos2" then HuntBars.db.profile.beastmastery.frpos=2 HuntBars.FrenzyBar:Show()
								elseif val == "pos3" then HuntBars.db.profile.beastmastery.frpos=3 HuntBars.FrenzyBar:Show() end

								HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.beastmastery.frposmenu end,
						},
						focusfire = {
							name = GetSpellInfo(82692),
							desc = L["Changes the position of the bar."],
							type = "select",
							values = {pos1="Position 1", pos2="Position 2", pos3="Position 3"},
							order = 14,
							set = function (info,val) HuntBars.db.profile.beastmastery.ffposmenu = val
								--if val == "off" then HuntBars.db.profile.beastmastery.ffpos = 0 HuntBars.FocusFireCDBar:Hide()
								if val == "pos1" then HuntBars.db.profile.beastmastery.ffpos=1 HuntBars.FocusFireCDBar:Show()
								elseif val == "pos2" then HuntBars.db.profile.beastmastery.ffpos=2 HuntBars.FocusFireCDBar:Show()
								elseif val == "pos3" then HuntBars.db.profile.beastmastery.ffpos=3 HuntBars.FocusFireCDBar:Show() end

								HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.beastmastery.ffposmenu end,
						},
					},
				},
			},
		},
		marksmanship = {
			name = "Marksmanship",
			type = "group",
			childGroups = "tab",
			order = 3,
			args = {
				visuals = {
					name = L["Visuals"],
					desc = L["Options to adjust frame's visual preferences."],
					order = 50,
					type = "group",
					args = {
						configmode = {
							name = L["Configuration mode"],
							desc = L["Toggles the inactive frames to see the results of changing an appearance options."],
							type = "toggle",
							order = 0,
							set = function (info,val) HB.ConfigMode = val HuntBars:ConfigMode() end,
							get = function(info) return HB.ConfigMode end,
						},
						additmode = {
							name = L["Extended mode"],
							desc = L["Toggles the frame with additional bars."],
							type = "toggle",
							order = 1,
							set = function (info,val) HuntBars.db.profile.addit.additmode = val
								if HuntBars.db.profile.addit.additmode == true then
									HuntBars.AdditFrame:Show()
								else
									HuntBars.AdditFrame:Hide()
								end
							end,
							get = function(info) return HuntBars.db.profile.addit.additmode end,
						},
						hidefocus = {
							name = L["Hide Focus"],
							desc = L["Removes Focus bar from the frames (Not recommended because it contains important additional info)."],
							type = "toggle",
							order = 2,
							set = function(info, val) HuntBars.db.profile.general.hidefocus = val HuntBars:DrawAllBars() end,
							get = function(info) return HuntBars.db.profile.general.hidefocus end,
						},
						apearheader = {
							name = L["Marksmanship Bars Size Preferences"],
							type = "header",
							order =50,
						},
						barswidth = {
							name = L["Width"],
							desc = L["Changes the width of the bars (Manual set range 10 - 1200)."],
							order = 51,
							type = "range",
							min = 10,
							max = 1200,
							softMin = 100,
							softMax = 600,
							step = 5,
							set = function (info, val) HuntBars.db.profile.marksmanship.barswidth = val HuntBars:DrawMarksBars() end,
							get = function (info) return HuntBars.db.profile.marksmanship.barswidth end,
						},
						barsheight = {
							name = L["Height"],
							desc = L["Changes the height of the bars (Manual set range 5 - 250)."],
							order = 52,
							type = "range",
							min = 5,
							max = 250,
							softMin = 5,
							softMax = 100,
							step = 1,
							set = function (info, val) HuntBars.db.profile.marksmanship.barsheight = val HuntBars:DrawMarksBars() end,
							get = function (info) return HuntBars.db.profile.marksmanship.barsheight end,
						},
						barsdistance = {
							name = L["Distance"],
							desc = L["Changes the distance between the bars (Manual set range 0 - 250)."],
							order = 53,
							type = "range",
							min = 0,
							max = 250,
							softMin = 0,
							softMax = 100,
							step = 1,
							set = function (info, val) HuntBars.db.profile.marksmanship.barsdistance = val HuntBars:DrawMarksBars() end,
							get = function (info) return HuntBars.db.profile.marksmanship.barsdistance end,
						},
						--[[barstime = {
							name = L["Bars Time"],
							desc = L["Changes how much time is covered by a bar. The bars start to drop after the amount set here (Manual set range 2sec - 600sec)."],
							order = 54,
							type = "range",
							min = 2,
							max = 600,
							softMin = 2,
							softMax = 120,
							step = 1,
							set = function (info, val) HuntBars.db.profile.marksmanship.barstime = val HuntBars:DrawMarksBars() end,
							get = function (info) return HuntBars.db.profile.marksmanship.barstime end,
						},]]
						textheader = {
							name = L["Marksmanship Text Preferences"],
							type = "header",
							order =60,
						},
						barsfont = {
							name = L["Font Type"],
							desc = L["Changes the font of the bars\' text."],
							order = 61,
							type = "select",
							dialogControl = "LSM30_Font",
							values = AceGUIWidgetLSMlists.font,
							set = function(info, val) HuntBars.db.profile.marksmanship.barsfont = val HuntBars:DrawMarksBars() end,
							get = function(info) return HuntBars.db.profile.marksmanship.barsfont end,
						},
						fontsize = {
							name = L["Font Size"],
							desc = L["Changes the size of the selected font (Manual set range 4 - 32)."],
							order = 62,
							type = "range",
							min = 4,
							max = 32,
							softMin = 4,
							softMax = 32,
							step = 1,
							set = function (info, val) HuntBars.db.profile.marksmanship.fontsize = val HuntBars:DrawMarksBars() end,
							get = function (info) return HuntBars.db.profile.marksmanship.fontsize end,
						},
						barstext = {
							name = L["Bars Text"],
							desc = L["Toggles how text (like shot names) is shown on top of the bars."],
							order = 63,
							values = {text1="Full Text", text2="Short Text", text3="Disabled"},
							type = "select",
							set = function (info, val) HuntBars.db.profile.marksmanship.barstext = val
								HuntBars:AssignSpellNames()
								HuntBars:DrawMarksBars()
							end,
							get = function (info) return HuntBars.db.profile.marksmanship.barstext end,
						},
						selectheader = {
							name = L["Marksmanship Visual Preferences"],
							type = "header",
							order = 70,
						},								
						activebar = {
							name = L["Bar Select"],
							desc = L["Selects the bar that preferences will be applied to."],
							order = 71,
							type = "select",
							values = {chimera="Chimera Shot", improvedss="Improved Steady Shot", readysetaim="Ready, Set, Aim"},
							set = function (info, val) HuntBars.db.profile.marksmanship.activebar = val end,
							get = function (info) return HuntBars.db.profile.marksmanship.activebar end,
						},
						barcolor = {
							name = L["Bar Color"],
							desc = L["Changes the color of the bar."],
							type = "color",
							order = 72,
							hasAlpha = false,
							set = function(info, r, g, b)
								if HuntBars.db.profile.marksmanship.activebar == "chimera" then
									HuntBars.db.profile.marksmanship.chimeracolor = {}
									HuntBars.db.profile.marksmanship.chimeracolor["r"] = r
									HuntBars.db.profile.marksmanship.chimeracolor["g"] = g
									HuntBars.db.profile.marksmanship.chimeracolor["b"] = b
								elseif HuntBars.db.profile.marksmanship.activebar == "improvedss" then
									HuntBars.db.profile.marksmanship.improvedsscolor = {}
									HuntBars.db.profile.marksmanship.improvedsscolor["r"] = r
									HuntBars.db.profile.marksmanship.improvedsscolor["g"] = g
									HuntBars.db.profile.marksmanship.improvedsscolor["b"] = b
								elseif HuntBars.db.profile.marksmanship.activebar == "readysetaim" then
									HuntBars.db.profile.marksmanship.readysetaimcolor = {}
									HuntBars.db.profile.marksmanship.readysetaimcolor["r"] = r
									HuntBars.db.profile.marksmanship.readysetaimcolor["g"] = g
									HuntBars.db.profile.marksmanship.readysetaimcolor["b"] = b
								end
								HuntBars:DrawMarksBars()
							end,
							get = function(info)
								if HuntBars.db.profile.marksmanship.activebar == "chimera" then
									return HuntBars.db.profile.marksmanship.chimeracolor["r"], HuntBars.db.profile.marksmanship.chimeracolor["g"], HuntBars.db.profile.marksmanship.chimeracolor["b"]
								elseif HuntBars.db.profile.marksmanship.activebar == "improvedss" then
									return HuntBars.db.profile.marksmanship.improvedsscolor["r"], HuntBars.db.profile.marksmanship.improvedsscolor["g"], HuntBars.db.profile.marksmanship.improvedsscolor["b"]
								elseif HuntBars.db.profile.marksmanship.activebar == "readysetaim" then
									return HuntBars.db.profile.marksmanship.readysetaimcolor["r"], HuntBars.db.profile.marksmanship.readysetaimcolor["g"], HuntBars.db.profile.marksmanship.readysetaimcolor["b"]
								end
							end
						},
						bartime = {
							name = L["Bar Max Duration"],
							desc = L["Changes how much time is covered by the bar. The bar start to drop after the amount set here (Manual set range 2sec - 600sec)."],
							order = 74,
							type = "range",
							hidden = "checkstacktypeMM",
							min = 2,
							max = 600,
							softMin = 2,
							softMax = 120,
							step = 1,
							set = function (info, val)
								if HuntBars.db.profile.marksmanship.activebar == "chimera" then
									HuntBars.db.profile.marksmanship.chimeratime = val
								elseif HuntBars.db.profile.marksmanship.activebar == "improvedss" then
									HuntBars.db.profile.marksmanship.improvedsstime = val
								elseif HuntBars.db.profile.marksmanship.activebar == "readysetaim" then
									HuntBars.db.profile.marksmanship.readysetaimtime = val
								end
								HuntBars:DrawMarksBars()
							end,
							get = function (info)
								if HuntBars.db.profile.marksmanship.activebar == "chimera" then
									return HuntBars.db.profile.marksmanship.chimeratime
								elseif HuntBars.db.profile.marksmanship.activebar == "improvedss" then
									return HuntBars.db.profile.marksmanship.improvedsstime
								elseif HuntBars.db.profile.marksmanship.activebar == "readysetaim" then
									return HuntBars.db.profile.marksmanship.readysetaimtime
								end
							end,
						},
						aimedcolor2 = {
							name = L["Bar Color at Fire!"],
							desc = L["Color used when you have Fire! buff (at 5 stacks of Ready, Set, Aim...) and gain free Aimed Shot."],
							type = "color",
							hidden = "notcheckstacktypeMM",
							order = 73,
							hasAlpha = false,
							set = function(info, r, g, b)
								HuntBars.db.profile.marksmanship.readysetaimextracolor = {}
								HuntBars.db.profile.marksmanship.readysetaimextracolor["r"] = r
								HuntBars.db.profile.marksmanship.readysetaimextracolor["g"] = g
								HuntBars.db.profile.marksmanship.readysetaimextracolor["b"] = b
								HuntBars:DrawMarksBars()
							end,
							get = function(info)
								return HuntBars.db.profile.marksmanship.readysetaimextracolor["r"], HuntBars.db.profile.marksmanship.readysetaimextracolor["g"], HuntBars.db.profile.marksmanship.readysetaimextracolor["b"]
							end
						},
					},
				},
				barorder = {
					name = L["Bars order"],
					desc = L["Options to set bars' order and amount."],
					order = 60,
					type = "group",
					args = {
						configmode = {
							name = L["Configuration mode"],
							desc = L["Toggles the inactive frames to see the results of changing an appearance options."],
							type = "toggle",
							order = 0,
							set = function (info,val) HB.ConfigMode = val HuntBars:ConfigMode() end,
							get = function(info) return HB.ConfigMode end,
						},
						additmode = {
							name = L["Extended mode"],
							desc = L["Toggles the frame with additional bars."],
							type = "toggle",
							order = 1,
							set = function (info,val) HuntBars.db.profile.addit.additmode = val
								if HuntBars.db.profile.addit.additmode == true then
									HuntBars.AdditFrame:Show()
								else
									HuntBars.AdditFrame:Hide()
								end
							end,
							get = function(info) return HuntBars.db.profile.addit.additmode end,
						},
						hidefocus = {
							name = L["Hide Focus"],
							desc = L["Removes Focus bar from the frames (Not recommended because it contains important additional info)."],
							type = "toggle",
							order = 2,
							set = function(info, val) HuntBars.db.profile.general.hidefocus = val HuntBars:DrawAllBars() end,
							get = function(info) return HuntBars.db.profile.general.hidefocus end,
						},
						mainheader = {
							name = L["Marksmanship bars"],
							type = "header",
							order = 10,
						},
						totalbars = {
							name = L["Amount of bars"],
							desc = L["Changes the amount of bars inside the frame."],
							type = "select",
							values = {total1="1 Bar", total2="2 Bars", total3="3 Bars"},
							order = 11,
							set = function (info,val) HuntBars.db.profile.marksmanship.totalbars = val
								if val == "total1" then HuntBars.db.profile.marksmanship.amountmarksbars = 1
								elseif val == "total2" then HuntBars.db.profile.marksmanship.amountmarksbars = 2
								elseif val == "total3" then HuntBars.db.profile.marksmanship.amountmarksbars = 3 end
								if HuntBars.db.profile.marksmanship.cspos > HuntBars.db.profile.marksmanship.amountmarksbars then
									HuntBars.ChimeraCDBar:Hide()
								elseif HuntBars.db.profile.marksmanship.cspos ~= 0 then
									HuntBars.ChimeraCDBar:Show()
								end
								if HuntBars.db.profile.marksmanship.isspos > HuntBars.db.profile.marksmanship.amountmarksbars then
									HuntBars.ImprovedSteadyBar:Hide()
								elseif HuntBars.db.profile.marksmanship.isspos ~= 0 then
									HuntBars.ImprovedSteadyBar:Show()
								end
								if HuntBars.db.profile.marksmanship.rsapos > HuntBars.db.profile.marksmanship.amountmarksbars then
									HuntBars.ReadySetAimBar:Hide()
								elseif HuntBars.db.profile.marksmanship.rsapos ~= 0 then
									HuntBars.ReadySetAimBar:Show()
								end
								HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.marksmanship.totalbars end,
						},
						chimerashot = {
							name = GetSpellInfo(53209),
							desc = L["Changes the position of the bar."],
							type = "select",
							values = {pos1="Position 1", pos2="Position 2", pos3="Position 3"},
							order = 12,
							set = function (info,val) HuntBars.db.profile.marksmanship.csposmenu = val
								--if val == "off" then HuntBars.db.profile.marksmanship.cspos = 0 HuntBars.ChimeraCDBar:Hide()
								if val == "pos1" then HuntBars.db.profile.marksmanship.cspos=1 HuntBars.ChimeraCDBar:Show()
								elseif val == "pos2" then HuntBars.db.profile.marksmanship.cspos=2 HuntBars.ChimeraCDBar:Show()
								elseif val == "pos3" then HuntBars.db.profile.marksmanship.cspos=3 HuntBars.ChimeraCDBar:Show() end

								HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.marksmanship.csposmenu end,
						},
						impsteady = {
							name = GetSpellInfo(53220),
							desc = L["Changes the position of the bar."],
							type = "select",
							values = {pos1="Position 1", pos2="Position 2", pos3="Position 3"},
							order = 13,
							set = function (info,val) HuntBars.db.profile.marksmanship.issposmenu = val
								--if val == "off" then HuntBars.db.profile.marksmanship.isspos = 0 HuntBars.ImprovedSteadyBar:Hide()
								if val == "pos1" then HuntBars.db.profile.marksmanship.isspos=1 HuntBars.ImprovedSteadyBar:Show()
								elseif val == "pos2" then HuntBars.db.profile.marksmanship.isspos=2 HuntBars.ImprovedSteadyBar:Show()
								elseif val == "pos3" then HuntBars.db.profile.marksmanship.isspos=3 HuntBars.ImprovedSteadyBar:Show() end

								HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.marksmanship.issposmenu end,
						},
						readysetaim = {
							name = GetSpellInfo(82925),
							desc = L["Changes the position of the bar."],
							type = "select",
							values = {pos1="Position 1", pos2="Position 2", pos3="Position 3"},
							order = 14,
							set = function (info,val) HuntBars.db.profile.marksmanship.rsaposmenu = val
								--if val == "off" then HuntBars.db.profile.marksmanship.rsapos = 0 HuntBars.ReadySetAimBar:Hide()
								if val == "pos1" then HuntBars.db.profile.marksmanship.rsapos=1 HuntBars.ReadySetAimBar:Show()
								elseif val == "pos2" then HuntBars.db.profile.marksmanship.rsapos=2 HuntBars.ReadySetAimBar:Show()
								elseif val == "pos3" then HuntBars.db.profile.marksmanship.rsapos=3 HuntBars.ReadySetAimBar:Show() end

								HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.marksmanship.rsaposmenu end,
						},
					},
				},			
				
				
			},
		},
		survival = {
			name = "Survival",
			type = "group",
			childGroups = "tab",
			order = 4,
			args = {
				visuals = {
					name = L["Visuals"],
					desc = L["Options to adjust frame's visual preferences."],
					order = 50,
					type = "group",
					args = {
						configmode = {
							name = L["Configuration mode"],
							desc = L["Toggles the inactive frames to see the results of changing an appearance options."],
							type = "toggle",
							order = 0,
							set = function (info,val) HB.ConfigMode = val HuntBars:ConfigMode() end,
							get = function(info) return HB.ConfigMode end,
						},
						additmode = {
							name = L["Extended mode"],
							desc = L["Toggles the frame with additional bars."],
							type = "toggle",
							order = 1,
							set = function (info,val) HuntBars.db.profile.addit.additmode = val
								if HuntBars.db.profile.addit.additmode == true then
									HuntBars.AdditFrame:Show()
								else
									HuntBars.AdditFrame:Hide()
								end
							end,
							get = function(info) return HuntBars.db.profile.addit.additmode end,
						},
						hidefocus = {
							name = L["Hide Focus"],
							desc = L["Removes Focus bar from the frames (Not recommended because it contains important additional info)."],
							type = "toggle",
							order = 2,
							set = function(info, val) HuntBars.db.profile.general.hidefocus = val HuntBars:DrawAllBars() end,
							get = function(info) return HuntBars.db.profile.general.hidefocus end,
						},
						apearheader = {
							name = L["Survival Bars Size Preferences"],
							type = "header",
							order =50,
						},
						barswidth = {
							name = L["Width"],
							desc = L["Changes the width of the bars (Manual set range 10 - 1200)."],
							order = 51,
							type = "range",
							min = 10,
							max = 1200,
							softMin = 100,
							softMax = 600,
							step = 5,
							set = function (info, val) HuntBars.db.profile.survival.barswidth = val HuntBars:DrawSurvBars() end,
							get = function (info) return HuntBars.db.profile.survival.barswidth end,
						},
						barsheight = {
							name = L["Height"],
							desc = L["Changes the height of the bars (Manual set range 5 - 250)."],
							order = 52,
							type = "range",
							min = 5,
							max = 250,
							softMin = 5,
							softMax = 100,
							step = 1,
							set = function (info, val) HuntBars.db.profile.survival.barsheight = val HuntBars:DrawSurvBars() end,
							get = function (info) return HuntBars.db.profile.survival.barsheight end,
						},
						barsdistance = {
							name = L["Distance"],
							desc = L["Changes the distance between the bars (Manual set range 0 - 250)."],
							order = 53,
							type = "range",
							min = 0,
							max = 250,
							softMin = 0,
							softMax = 100,
							step = 1,
							set = function (info, val) HuntBars.db.profile.survival.barsdistance = val HuntBars:DrawSurvBars() end,
							get = function (info) return HuntBars.db.profile.survival.barsdistance end,
						},
						--[[barstime = {
							name = L["Bars Time"],
							desc = L["Changes how much time is covered by a bar. The bars start to drop after the amount set here (Manual set range 2sec - 600sec)."],
							order = 54,
							type = "range",
							min = 2,
							max = 600,
							softMin = 2,
							softMax = 120,
							step = 1,
							set = function (info, val) HuntBars.db.profile.survival.barstime = val HuntBars:DrawSurvBars() end,
							get = function (info) return HuntBars.db.profile.survival.barstime end,
						},]]
						textheader = {
							name = L["Survival Text Preferences"],
							type = "header",
							order = 60,
						},
						barsfont = {
							name = L["Font Type"],
							desc = L["Changes the font of the bars\' text."],
							order = 61,
							type = "select",
							dialogControl = "LSM30_Font",
							values = AceGUIWidgetLSMlists.font,
							set = function(info, val) HuntBars.db.profile.survival.barsfont = val HuntBars:DrawSurvBars() end,
							get = function(info) return HuntBars.db.profile.survival.barsfont end,
						},
						fontsize = {
							name = L["Font Size"],
							desc = L["Changes the size of the selected font (Manual set range 4 - 32)."],
							order = 62,
							type = "range",
							min = 4,
							max = 32,
							softMin = 4,
							softMax = 32,
							step = 1,
							set = function (info, val) HuntBars.db.profile.survival.fontsize = val HuntBars:DrawSurvBars() end,
							get = function (info) return HuntBars.db.profile.survival.fontsize end,
						},
						barstext = {
							name = L["Bars Text"],
							desc = L["Toggles how text (like shot names) is shown on top of the bars."],
							order = 63,
							type = "select",
							values = {text1="Full Text", text2="Short Text", text3="Disabled"},
							set = function (info, val) HuntBars.db.profile.survival.barstext = val
								HuntBars:AssignSpellNames()
								HuntBars:DrawSurvBars()
							end,
							get = function (info) return HuntBars.db.profile.survival.barstext end,
						},
						selectheader = {
							name = L["Survival Visual Preferences"],
							type = "header",
							order = 70,
						},								
						activebar = {
							name = L["Bar Select"],
							desc = L["Selects the bar that preferences will be applied to."],
							order = 71,
							type = "select",
							values = {explosive="Explosive Shot", blackarrow="Black Arrow", locknload="Lock and Load"},
							set = function (info, val) HuntBars.db.profile.survival.activebar = val end,
							get = function (info) return HuntBars.db.profile.survival.activebar end,
						},
						barcolor = {
							name = L["Bar Color"],
							desc = L["Changes the color of the bar."],
							type = "color",
							order = 72,
							hasAlpha = false,
							set = function(info, r, g, b)
								if HuntBars.db.profile.survival.activebar == "explosive" then
									HuntBars.db.profile.survival.explosivecolor = {}
									HuntBars.db.profile.survival.explosivecolor["r"] = r
									HuntBars.db.profile.survival.explosivecolor["g"] = g
									HuntBars.db.profile.survival.explosivecolor["b"] = b
								elseif HuntBars.db.profile.survival.activebar == "blackarrow" then
									HuntBars.db.profile.survival.blackarrowcolor = {}
									HuntBars.db.profile.survival.blackarrowcolor["r"] = r
									HuntBars.db.profile.survival.blackarrowcolor["g"] = g
									HuntBars.db.profile.survival.blackarrowcolor["b"] = b
								elseif HuntBars.db.profile.survival.activebar == "locknload" then
									HuntBars.db.profile.survival.locknloadcolor = {}
									HuntBars.db.profile.survival.locknloadcolor["r"] = r
									HuntBars.db.profile.survival.locknloadcolor["g"] = g
									HuntBars.db.profile.survival.locknloadcolor["b"] = b
								end
								HuntBars:DrawSurvBars()
							end,
							get = function(info)
								if HuntBars.db.profile.survival.activebar == "explosive" then
									return HuntBars.db.profile.survival.explosivecolor["r"], HuntBars.db.profile.survival.explosivecolor["g"], HuntBars.db.profile.survival.explosivecolor["b"]
								elseif HuntBars.db.profile.survival.activebar == "blackarrow" then
									return HuntBars.db.profile.survival.blackarrowcolor["r"], HuntBars.db.profile.survival.blackarrowcolor["g"], HuntBars.db.profile.survival.blackarrowcolor["b"]
								elseif HuntBars.db.profile.survival.activebar == "locknload" then
									return HuntBars.db.profile.survival.locknloadcolor["r"], HuntBars.db.profile.survival.locknloadcolor["g"], HuntBars.db.profile.survival.locknloadcolor["b"]
								end
							end
						},
						bartime = {
							name = L["Bar Max Duration"],
							desc = L["Changes how much time is covered by the bar. The bar start to drop after the amount set here (Manual set range 2sec - 600sec)."],
							order = 74,
							type = "range",
							min = 2,
							max = 600,
							softMin = 2,
							softMax = 120,
							step = 1,
							set = function (info, val)
								if HuntBars.db.profile.survival.activebar == "explosive" then
									HuntBars.db.profile.survival.explosivetime = val
								elseif HuntBars.db.profile.survival.activebar == "blackarrow" then
									HuntBars.db.profile.survival.blackarrowtime = val
								elseif HuntBars.db.profile.survival.activebar == "locknload" then
									HuntBars.db.profile.survival.locknloadtime = val
								end
								HuntBars:DrawSurvBars()
							end,
							get = function (info)
								if HuntBars.db.profile.survival.activebar == "explosive" then
									return HuntBars.db.profile.survival.explosivetime
								elseif HuntBars.db.profile.survival.activebar == "blackarrow" then
									return HuntBars.db.profile.survival.blackarrowtime
								elseif HuntBars.db.profile.survival.activebar == "locknload" then
									return HuntBars.db.profile.survival.locknloadtime
								end
							end,
						},
						explosivecolor2 = {
							name = L["Bar Color at LnL"],
							desc = L["Color used for Explosive Shot bar when you have Lock and Load buff."],
							type = "color",
							order = 73,
							hidden = "checkexplosiveSV",
							hasAlpha = false,
							set = function(info, r, g, b)
								HuntBars.db.profile.survival.explosiveextracolor = {}
								HuntBars.db.profile.survival.explosiveextracolor["r"] = r
								HuntBars.db.profile.survival.explosiveextracolor["g"] = g
								HuntBars.db.profile.survival.explosiveextracolor["b"] = b
								HuntBars:DrawSurvBars()
							end,
							get = function(info)
								--if HuntBars.db.profile.survival.explosiveextracolor then
									return HuntBars.db.profile.survival.explosiveextracolor["r"], HuntBars.db.profile.survival.explosiveextracolor["g"], HuntBars.db.profile.survival.explosiveextracolor["b"]
								--[[else
									HuntBars.db.profile.survival.explosiveextracolor = {}
									HuntBars.db.profile.survival.explosiveextracolor["r"] = defcol["r"]
									HuntBars.db.profile.survival.explosiveextracolor["g"] = defcol["g"]
									HuntBars.db.profile.survival.explosiveextracolor["b"] = defcol["b"]
									return defcol["r"], defcol["g"], defcol["b"]
								end --]]
							end
						},
					},
				},
				barorder = {
					name = L["Bars order"],
					desc = L["Options to set bars' order and amount."],
					order = 60,
					type = "group",
					args = {
						configmode = {
							name = L["Configuration mode"],
							desc = L["Toggles the inactive frames to see the results of changing an appearance options."],
							type = "toggle",
							order = 0,
							set = function (info,val) HB.ConfigMode = val HuntBars:ConfigMode() end,
							get = function(info) return HB.ConfigMode end,
						},
						additmode = {
							name = L["Extended mode"],
							desc = L["Toggles the frame with additional bars."],
							type = "toggle",
							order = 1,
							set = function (info,val) HuntBars.db.profile.addit.additmode = val
									if HuntBars.db.profile.addit.additmode == true then
										HuntBars.AdditFrame:Show()
									else
										HuntBars.AdditFrame:Hide()
									end
								  end,
							get = function(info) return HuntBars.db.profile.addit.additmode end,
						},
						hidefocus = {
							name = L["Hide Focus"],
							desc = L["Removes Focus bar from the frames (Not recommended because it contains important additional info)."],
							type = "toggle",
							order = 2,
							set = function(info, val) HuntBars.db.profile.general.hidefocus = val HuntBars:DrawAllBars() end,
							get = function(info) return HuntBars.db.profile.general.hidefocus end,
						},
						mainheader = {
							name = L["Survival bars"],
							type = "header",
							order = 10,
						},
						totalbars = {
							name = L["Amount of bars"],
							desc = L["Changes the amount of bars inside the frame."],
							type = "select",
							values = {total1="1 Bar", total2="2 Bars", total3="3 Bars"},
							order = 11,
							set = function (info,val) HuntBars.db.profile.survival.totalbars = val
									if val == "total1" then HuntBars.db.profile.survival.amountsurvbars = 1
									elseif val == "total2" then HuntBars.db.profile.survival.amountsurvbars = 2
									elseif val == "total3" then HuntBars.db.profile.survival.amountsurvbars = 3 end
									if HuntBars.db.profile.survival.espos > HuntBars.db.profile.survival.amountsurvbars then
										HuntBars.ExpShotCDBar:Hide()
									elseif HuntBars.db.profile.survival.espos ~= 0 then
										HuntBars.ExpShotCDBar:Show()
									end
									if HuntBars.db.profile.survival.lnlpos > HuntBars.db.profile.survival.amountsurvbars then
										HuntBars.LocknLoadCDBar:Hide()
									elseif HuntBars.db.profile.survival.lnlpos ~= 0 then
										HuntBars.LocknLoadCDBar:Show()
									end
									if HuntBars.db.profile.survival.bapos > HuntBars.db.profile.survival.amountsurvbars then
										HuntBars.BlackArrowCDBar:Hide()
									elseif HuntBars.db.profile.survival.bapos ~= 0 then
										HuntBars.BlackArrowCDBar:Show()
									end
									HuntBars:DrawAllBars()
								end,
							get = function(info) return HuntBars.db.profile.survival.totalbars end,
						},
						explosiveshot = {
							name = GetSpellInfo(53301),
							desc = L["Changes the position of the bar."],
							type = "select",
							values = {pos1="Position 1", pos2="Position 2", pos3="Position 3"},
							order = 12,
							set = function (info,val) HuntBars.db.profile.survival.esposmenu = val
									--if val == "off" then HuntBars.db.profile.survival.espos = 0 HuntBars.ExpShotCDBar:Hide()
									if val == "pos1" then HuntBars.db.profile.survival.espos=1 HuntBars.ExpShotCDBar:Show()
									elseif val == "pos2" then HuntBars.db.profile.survival.espos=2 HuntBars.ExpShotCDBar:Show()
									elseif val == "pos3" then HuntBars.db.profile.survival.espos=3 HuntBars.ExpShotCDBar:Show() end

									HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.survival.esposmenu end,
						},
						locknload = {
							name = GetSpellInfo(56453),
							desc = L["Changes the position of the bar."],
							type = "select",
							values = {pos1="Position 1", pos2="Position 2", pos3="Position 3"},
							order = 13,
							set = function (info,val) HuntBars.db.profile.survival.lnlposmenu = val
									--if val == "off" then HuntBars.db.profile.survival.lnlpos = 0 HuntBars.LocknLoadCDBar:Hide()
									if val == "pos1" then HuntBars.db.profile.survival.lnlpos=1 HuntBars.LocknLoadCDBar:Show()
									elseif val == "pos2" then HuntBars.db.profile.survival.lnlpos=2 HuntBars.LocknLoadCDBar:Show()
									elseif val == "pos3" then HuntBars.db.profile.survival.lnlpos=3 HuntBars.LocknLoadCDBar:Show() end

									HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.survival.lnlposmenu end,
						},
						blackarrow = {
							name = GetSpellInfo(3674),
							desc = L["Changes the position of the bar."],
							type = "select",
							values = {pos1="Position 1", pos2="Position 2", pos3="Position 3"},
							order = 14,
							set = function (info,val) HuntBars.db.profile.survival.baposmenu = val
									--if val == "off" then HuntBars.db.profile.survival.bapos = 0 HuntBars.BlackArrowCDBar:Hide()
									if val == "pos1" then HuntBars.db.profile.survival.bapos=1 HuntBars.BlackArrowCDBar:Show()
									elseif val == "pos2" then HuntBars.db.profile.survival.bapos=2 HuntBars.BlackArrowCDBar:Show()
									elseif val == "pos3" then HuntBars.db.profile.survival.bapos=3 HuntBars.BlackArrowCDBar:Show() end

									HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.survival.baposmenu end,
						},
					},
				},
			},
		},
		addit = {
			name = "Additional Bars",
			type = "group",
			childGroups = "tab",
			order = 5,
			args = {
				visuals = {
					name = L["Visuals"],
					desc = L["Options to adjust frame's visual preferences."],
					order = 50,
					type = "group",
					args = {
						configmode = {
							name = L["Configuration mode"],
							desc = L["Toggles the inactive frames to see the results of changing an appearance options."],
							type = "toggle",
							order = 0,
							set = function (info,val) HB.ConfigMode = val HuntBars:ConfigMode() end,
							get = function(info) return HB.ConfigMode end,
						},
						additmode = {
							name = L["Extended mode"],
							desc = L["Toggles the frame with additional bars."],
							type = "toggle",
							order = 1,
							set = function (info,val) HuntBars.db.profile.addit.additmode = val
								if HuntBars.db.profile.addit.additmode == true then
									HuntBars.AdditFrame:Show()
								else
									HuntBars.AdditFrame:Hide()
								end
							end,
							get = function(info) return HuntBars.db.profile.addit.additmode end,
						},
						hidefocus = {
							name = L["Hide Focus"],
							desc = L["Removes Focus bar from the frames (Not recommended because it contains important additional info)."],
							type = "toggle",
							order = 2,
							set = function(info, val) HuntBars.db.profile.general.hidefocus = val HuntBars:DrawAllBars() end,
							get = function(info) return HuntBars.db.profile.general.hidefocus end,
						},
						focusonlymode = {
							name = L["Focus bar only mode"],
							desc = L["Toggles between focus bar only and full mode. To adjust this bar use Extended mode controls."],
							type = "toggle",
							order = 3,
							set = function (info,val) HuntBars.db.profile.general.focusonlymode = val
								if HuntBars.db.profile.general.focusonlymode == true then
									HB.BarsGeneralFrame:Hide()
									HB.SAFocusGeneralFrame:Show()
								else
									HB.BarsGeneralFrame:Show()
									HB.SAFocusGeneralFrame:Hide()
								end								
							end,
							get = function(info) return HuntBars.db.profile.general.focusonlymode end,
						},
						apearheader = {
							name = L["Extended Mode/Focus Bar Size Preferences"],
							type = "header",
							order =50,
						},
						barswidth = {
							name = L["Width"],
							desc = L["Changes the width of the bars (Manual set range 10 - 1200)."],
							order = 51,
							type = "range",
							min = 10,
							max = 1200,
							softMin = 100,
							softMax = 600,
							step = 5,
							set = function (info, val) HuntBars.db.profile.addit.barswidth = val HuntBars:DrawAllBars() end,
							get = function (info) return HuntBars.db.profile.addit.barswidth end,
						},
						barsheight = {
							name = L["Height"],
							desc = L["Changes the height of the bars (Manual set range 5 - 250)."],
							order = 52,
							type = "range",
							min = 5,
							max = 250,
							softMin = 5,
							softMax = 100,
							step = 1,
							set = function (info, val) HuntBars.db.profile.addit.barsheight = val HuntBars:DrawAllBars() end,
							get = function (info) return HuntBars.db.profile.addit.barsheight end,
						},
						barsdistance = {
							name = L["Distance"],
							desc = L["Changes the distance between the bars (Manual set range 0 - 250)."],
							order = 53,
							type = "range",
							min = 0,
							max = 250,
							softMin = 0,
							softMax = 100,
							step = 1,
							set = function (info, val) HuntBars.db.profile.addit.barsdistance = val HuntBars:DrawAllBars() end,
							get = function (info) return HuntBars.db.profile.addit.barsdistance end,
						},
						--[[barstime = {
							name = L["Bars Time"],
							desc = L["Changes how much time is covered by a bar. The bars start to drop after the amount set here (Manual set range 2sec - 600sec)."],
							order = 54,
							type = "range",
							min = 2,
							max = 600,
							softMin = 2,
							softMax = 120,
							step = 1,
							set = function (info, val) HuntBars.db.profile.addit.barstime = val HuntBars:DrawAllBars() end,
							get = function (info) return HuntBars.db.profile.addit.barstime end,
						},]]
						textheader = {
							name = L["Extended Mode/Focus Bar Text Preferences"],
							type = "header",
							order = 60,
						},
						barsfont = {
							name = L["Font Type"],
							desc = L["Changes the font of the bars\' text."],
							order = 61,
							type = "select",
							dialogControl = "LSM30_Font",
							values = AceGUIWidgetLSMlists.font,
							set = function(info, val) HuntBars.db.profile.addit.barsfont = val HuntBars:DrawAllBars() end,
							get = function(info) return HuntBars.db.profile.addit.barsfont end,
						},
						fontsize = {
							name = L["Font Size"],
							desc = L["Changes the size of the selected font (Manual set range 4 - 32)."],
							order = 62,
							type = "range",
							min = 4,
							max = 32,
							softMin = 4,
							softMax = 32,
							step = 1,
							set = function (info, val) HuntBars.db.profile.addit.fontsize = val HuntBars:DrawAllBars() end,
							get = function (info) return HuntBars.db.profile.addit.fontsize end,
						},
						barstext = {
							name = L["Bars Text"],
							desc = L["Toggles how text (like shot names) is shown on top of the bars."],
							order = 63,
							type = "select",
							values = {text1="Full Text", text2="Short Text", text3="Disabled"},
							set = function (info, val) HuntBars.db.profile.addit.barstext = val
								HuntBars:AssignSpellNames()
								HuntBars:DrawAllBars()
							end,
							get = function (info) return HuntBars.db.profile.addit.barstext end,
						},
						selectheader = {
							name = L["Extended Mode/Focus Bar Visual Preferences"],
							type = "header",
							order = 70,
						},								
						activebar = {
							name = L["Bar Select"],
							desc = L["Selects the bar that preferences will be applied to."],
							order = 71,
							type = "select",
							values = {serpent="Serpent Sting", killshot="Kill Shot", rapidfire="Rapid Fire", custom1="Custom Bar 1", custom2="Custom Bar 2", custom3="Custom Bar 3"},
							set = function (info, val) HuntBars.db.profile.addit.activebar = val end,
							get = function (info) return HuntBars.db.profile.addit.activebar end,
						},
						barcolor = {
							name = L["Bar Color"],
							desc = L["Changes the color of the bar."],
							type = "color",
							order = 72,
							hasAlpha = false,
							set = function(info, r, g, b)
								if HuntBars.db.profile.addit.activebar == "serpent" then
									HuntBars.db.profile.addit.serpentcolor = {}
									HuntBars.db.profile.addit.serpentcolor["r"] = r
									HuntBars.db.profile.addit.serpentcolor["g"] = g
									HuntBars.db.profile.addit.serpentcolor["b"] = b
								elseif HuntBars.db.profile.addit.activebar == "killshot" then
									HuntBars.db.profile.addit.killshotcolor = {}
									HuntBars.db.profile.addit.killshotcolor["r"] = r
									HuntBars.db.profile.addit.killshotcolor["g"] = g
									HuntBars.db.profile.addit.killshotcolor["b"] = b
								elseif HuntBars.db.profile.addit.activebar == "rapidfire" then
									HuntBars.db.profile.addit.rapidfirecolor = {}
									HuntBars.db.profile.addit.rapidfirecolor["r"] = r
									HuntBars.db.profile.addit.rapidfirecolor["g"] = g
									HuntBars.db.profile.addit.rapidfirecolor["b"] = b
								elseif HuntBars.db.profile.addit.activebar == "custom1" then
									HuntBars.db.profile.addit.cust1color = {}
									HuntBars.db.profile.addit.cust1color["r"] = r
									HuntBars.db.profile.addit.cust1color["g"] = g
									HuntBars.db.profile.addit.cust1color["b"] = b
								elseif HuntBars.db.profile.addit.activebar == "custom2" then
									HuntBars.db.profile.addit.cust2color = {}
									HuntBars.db.profile.addit.cust2color["r"] = r
									HuntBars.db.profile.addit.cust2color["g"] = g
									HuntBars.db.profile.addit.cust2color["b"] = b
								elseif HuntBars.db.profile.addit.activebar == "custom3" then
									HuntBars.db.profile.addit.cust3color = {}
									HuntBars.db.profile.addit.cust3color["r"] = r
									HuntBars.db.profile.addit.cust3color["g"] = g
									HuntBars.db.profile.addit.cust3color["b"] = b
									end
								HuntBars:DrawAdditBars()
							end,
							get = function(info)
								if HuntBars.db.profile.addit.activebar == "serpent" then
									return HuntBars.db.profile.addit.serpentcolor["r"], HuntBars.db.profile.addit.serpentcolor["g"], HuntBars.db.profile.addit.serpentcolor["b"]
								elseif HuntBars.db.profile.addit.activebar == "killshot" then
									return HuntBars.db.profile.addit.killshotcolor["r"], HuntBars.db.profile.addit.killshotcolor["g"], HuntBars.db.profile.addit.killshotcolor["b"]
								elseif HuntBars.db.profile.addit.activebar == "rapidfire" then
									return HuntBars.db.profile.addit.rapidfirecolor["r"], HuntBars.db.profile.addit.rapidfirecolor["g"], HuntBars.db.profile.addit.rapidfirecolor["b"]
								elseif HuntBars.db.profile.addit.activebar == "custom1" then
									return HuntBars.db.profile.addit.cust1color["r"], HuntBars.db.profile.addit.cust1color["g"], HuntBars.db.profile.addit.cust1color["b"]
								elseif HuntBars.db.profile.addit.activebar == "custom2" then
									return HuntBars.db.profile.addit.cust2color["r"], HuntBars.db.profile.addit.cust2color["g"], HuntBars.db.profile.addit.cust2color["b"]
								elseif HuntBars.db.profile.addit.activebar == "custom3" then
									return HuntBars.db.profile.addit.cust3color["r"], HuntBars.db.profile.addit.cust3color["g"], HuntBars.db.profile.addit.cust3color["b"]
								end
							end
						},
						bartime = {
							name = L["Bar Max Duration"],
							desc = L["Changes how much time is covered by the bar. The bar start to drop after the amount set here (Manual set range 2sec - 600sec)."],
							order = 74,
							type = "range",
							min = 2,
							max = 600,
							softMin = 2,
							softMax = 120,
							step = 1,
							set = function (info, val)
								if HuntBars.db.profile.addit.activebar == "serpent" then
									HuntBars.db.profile.addit.serpenttime = val
								elseif HuntBars.db.profile.addit.activebar == "killshot" then
									HuntBars.db.profile.addit.killshottime = val
								elseif HuntBars.db.profile.addit.activebar == "rapidfire" then
									HuntBars.db.profile.addit.rapidfiretime = val
								elseif HuntBars.db.profile.addit.activebar == "custom1" then
									HuntBars.db.profile.addit.cust1time = val
								elseif HuntBars.db.profile.addit.activebar == "custom2" then
									HuntBars.db.profile.addit.cust2time = val
								elseif HuntBars.db.profile.addit.activebar == "custom3" then
									HuntBars.db.profile.addit.cust3time = val
								end
								HuntBars:DrawAdditBars()
							end,
							get = function (info)
								if HuntBars.db.profile.addit.activebar == "serpent" then
									return HuntBars.db.profile.addit.serpenttime
								elseif HuntBars.db.profile.addit.activebar == "killshot" then
									return HuntBars.db.profile.addit.killshottime
								elseif HuntBars.db.profile.addit.activebar == "rapidfire" then
									return HuntBars.db.profile.addit.rapidfiretime
								elseif HuntBars.db.profile.addit.activebar == "custom1" then
									return HuntBars.db.profile.addit.cust1time
								elseif HuntBars.db.profile.addit.activebar == "custom2" then
									return HuntBars.db.profile.addit.cust2time
								elseif HuntBars.db.profile.addit.activebar == "custom3" then
									return HuntBars.db.profile.addit.cust3time
								end
							end,
						},
						rapidfirecolor2 = {
							name = "Bar Color at Rapid Fire Cooldown",
							desc = "Color used for Rapid Fire cooldown as opposed to Rapid Fire buff.",
							type = "color",
							hidden = "checkextracolorRF",
							order = 73,
							hasAlpha = false,
							set = function(info, r, g, b)
								HuntBars.db.profile.addit.rapidfireextracolor = {}
								HuntBars.db.profile.addit.rapidfireextracolor["r"] = r
								HuntBars.db.profile.addit.rapidfireextracolor["g"] = g
								HuntBars.db.profile.addit.rapidfireextracolor["b"] = b
								HuntBars:DrawMarksBars()
							end,
							get = function(info)
								return HuntBars.db.profile.addit.rapidfireextracolor["r"], HuntBars.db.profile.addit.rapidfireextracolor["g"], HuntBars.db.profile.addit.rapidfireextracolor["b"]
							end
						},
					},
				},
				barorder = {
					name = L["Bars order"],
					desc = L["Options to set bars' order and amount."],
					order = 60,
					type = "group",
					args = {
						configmode = {
							name = L["Configuration mode"],
							desc = L["Toggles the inactive frames to see the results of changing an appearance options."],
							type = "toggle",
							order = 0,
							set = function (info,val) HB.ConfigMode = val HuntBars:ConfigMode() end,
							get = function(info) return HB.ConfigMode end,
						},
						additmode = {
							name = L["Extended mode"],
							desc = L["Toggles the frame with additional bars."],
							type = "toggle",
							order = 1,
							set = function (info,val) HuntBars.db.profile.addit.additmode = val
								if HuntBars.db.profile.addit.additmode == true then
									HuntBars.AdditFrame:Show()
								else
									HuntBars.AdditFrame:Hide()
								end
							end,
							get = function(info) return HuntBars.db.profile.addit.additmode end,
						},
						hidefocus = {
							name = L["Hide Focus"],
							desc = L["Removes Focus bar from the frames (Not recommended because it contains important additional info)."],
							type = "toggle",
							order = 2,
							set = function(info, val) HuntBars.db.profile.general.hidefocus = val HuntBars:DrawAllBars() end,
							get = function(info) return HuntBars.db.profile.general.hidefocus end,
						},
						focusonlymode = {
							name = L["Focus bar only mode"],
							desc = L["Toggles between focus bar only and full mode. To adjust this bar use Extended mode controls."],
							type = "toggle",
							order = 3,
							set = function (info,val) HuntBars.db.profile.general.focusonlymode = val
								if HuntBars.db.profile.general.focusonlymode == true then
									HB.BarsGeneralFrame:Hide()
									HB.SAFocusGeneralFrame:Show()
								else
									HB.BarsGeneralFrame:Show()
									HB.SAFocusGeneralFrame:Hide()
								end								
							end,
							get = function(info) return HuntBars.db.profile.general.focusonlymode end,
						},
						mainheader = {
							name = L["Extended mode bars"],
							type = "header",
							order = 10,
						},
						totalbars = {
							name = L["Amount of bars"],
							desc = L["Changes the amount of bars inside the frame."],
							type = "select",
							values = {total1="1 Bar", total2="2 Bars", total3="3 Bars", total4="4 Bars", total5="5 Bars", total6="6 Bars"},
							order = 11,
							set = function (info,val) HuntBars.db.profile.addit.totalbars = val
								if val == "total1" then HuntBars.db.profile.addit.amountadditbars = 1
								elseif val == "total2" then HuntBars.db.profile.addit.amountadditbars = 2
								elseif val == "total3" then HuntBars.db.profile.addit.amountadditbars = 3
								elseif val == "total4" then HuntBars.db.profile.addit.amountadditbars = 4
								elseif val == "total5" then HuntBars.db.profile.addit.amountadditbars = 5
								elseif val == "total6" then HuntBars.db.profile.addit.amountadditbars = 6 end
								if HuntBars.db.profile.addit.sspos > HuntBars.db.profile.addit.amountadditbars then
									HuntBars.SerpentBar:Hide()
								elseif HuntBars.db.profile.addit.sspos ~= 0 then
									HuntBars.SerpentBar:Show()
								end
								if HuntBars.db.profile.addit.kspos > HuntBars.db.profile.addit.amountadditbars then
									HuntBars.KillShotBar:Hide()
								elseif HuntBars.db.profile.addit.kspos ~= 0 then
									HuntBars.KillShotBar:Show()
								end
								if HuntBars.db.profile.addit.rfpos > HuntBars.db.profile.addit.amountadditbars then
									HuntBars.RapidFireBar:Hide()
								elseif HuntBars.db.profile.addit.rfpos ~= 0 then
									HuntBars.RapidFireBar:Show()
								end
								if HuntBars.db.profile.addit.cust1pos > HuntBars.db.profile.addit.amountadditbars then
									HuntBars.CustomBar1:Hide()
								elseif HuntBars.db.profile.addit.cust1pos ~= 0 then
									HuntBars.CustomBar1:Show()
								end
								if HuntBars.db.profile.addit.cust2pos > HuntBars.db.profile.addit.amountadditbars then
									HuntBars.CustomBar2:Hide()
								elseif HuntBars.db.profile.addit.cust2pos ~= 0 then
									HuntBars.CustomBar2:Show()
								end
								if HuntBars.db.profile.addit.cust3pos > HuntBars.db.profile.addit.amountadditbars then
									HuntBars.CustomBar3:Hide()
								elseif HuntBars.db.profile.addit.cust3pos ~= 0 then
									HuntBars.CustomBar3:Show()
								end
								HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.addit.totalbars end,
						},
						serpentsting = {
							name = GetSpellInfo(1978),
							desc = L["Changes the position of the bar."],
							type = "select",
							values = {pos1="Position 1", pos2="Position 2", pos3="Position 3", pos4="Position 4", pos5="Position 5", pos6="Position 6"},
							order = 12,
							set = function (info,val) HuntBars.db.profile.addit.ssposmenu = val
								--if val == "off" then HuntBars.db.profile.addit.sspos = 0 HuntBars.SerpentBar:Hide()
								if val == "pos1" then HuntBars.db.profile.addit.sspos=1 HuntBars.SerpentBar:Show()
								elseif val == "pos2" then HuntBars.db.profile.addit.sspos=2 HuntBars.SerpentBar:Show()
								elseif val == "pos3" then HuntBars.db.profile.addit.sspos=3 HuntBars.SerpentBar:Show()
								elseif val == "pos4" then HuntBars.db.profile.addit.sspos=4 HuntBars.SerpentBar:Show()
								elseif val == "pos5" then HuntBars.db.profile.addit.sspos=5 HuntBars.SerpentBar:Show()
								elseif val == "pos6" then HuntBars.db.profile.addit.sspos=6 HuntBars.SerpentBar:Show() end

								HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.addit.ssposmenu end,
						},
						killshot = {
							name = GetSpellInfo(53351),
							desc = L["Changes the position of the bar."],
							type = "select",
							values = {pos1="Position 1", pos2="Position 2", pos3="Position 3", pos4="Position 4", pos5="Position 5", pos6="Position 6"},
							order = 13,
							set = function (info,val) HuntBars.db.profile.addit.ksposmenu = val
								--if val == "off" then HuntBars.db.profile.addit.kspos = 0 HuntBars.KillShotBar:Hide()
								if val == "pos1" then HuntBars.db.profile.addit.kspos=1 HuntBars.KillShotBar:Show()
								elseif val == "pos2" then HuntBars.db.profile.addit.kspos=2 HuntBars.KillShotBar:Show()
								elseif val == "pos3" then HuntBars.db.profile.addit.kspos=3 HuntBars.KillShotBar:Show()
								elseif val == "pos4" then HuntBars.db.profile.addit.kspos=4 HuntBars.KillShotBar:Show()
								elseif val == "pos5" then HuntBars.db.profile.addit.kspos=5 HuntBars.KillShotBar:Show()
								elseif val == "pos6" then HuntBars.db.profile.addit.kspos=6 HuntBars.KillShotBar:Show() end

								HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.addit.ksposmenu end,
						},
						rapidfire = {
							name = GetSpellInfo(3045),
							desc = L["Changes the position of the bar."],
							type = "select",
							values = {pos1="Position 1", pos2="Position 2", pos3="Position 3", pos4="Position 4", pos5="Position 5", pos6="Position 6"},
							order = 14,
							set = function (info,val) HuntBars.db.profile.addit.rfposmenu = val
								--if val == "off" then HuntBars.db.profile.addit.rfpos = 0 HuntBars.RapidFireBar:Hide()
								if val == "pos1" then HuntBars.db.profile.addit.rfpos=1 HuntBars.RapidFireBar:Show()
								elseif val == "pos2" then HuntBars.db.profile.addit.rfpos=2 HuntBars.RapidFireBar:Show()
								elseif val == "pos3" then HuntBars.db.profile.addit.rfpos=3 HuntBars.RapidFireBar:Show()
								elseif val == "pos4" then HuntBars.db.profile.addit.rfpos=4 HuntBars.RapidFireBar:Show()
								elseif val == "pos5" then HuntBars.db.profile.addit.rfpos=5 HuntBars.RapidFireBar:Show()
								elseif val == "pos6" then HuntBars.db.profile.addit.rfpos=6 HuntBars.RapidFireBar:Show() end

								HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.addit.rfposmenu end,
						},
						custom1 = {
							name = L["Custom Bar 1"],
							desc = L["Changes the position of the bar."],
							type = "select",
							values = {pos1="Position 1", pos2="Position 2", pos3="Position 3", pos4="Position 4", pos5="Position 5", pos6="Position 6"},
							order = 15,
							set = function (info,val) HuntBars.db.profile.addit.cust1posmenu = val
								--if val == "off" then HuntBars.db.profile.addit.cust1pos = 0 HuntBars.CustomBar1:Hide()
								if val == "pos1" then HuntBars.db.profile.addit.cust1pos=1 HuntBars.CustomBar1:Show()
								elseif val == "pos2" then HuntBars.db.profile.addit.cust1pos=2 HuntBars.CustomBar1:Show()
								elseif val == "pos3" then HuntBars.db.profile.addit.cust1pos=3 HuntBars.CustomBar1:Show()
								elseif val == "pos4" then HuntBars.db.profile.addit.cust1pos=4 HuntBars.CustomBar1:Show()
								elseif val == "pos5" then HuntBars.db.profile.addit.cust1pos=5 HuntBars.CustomBar1:Show()
								elseif val == "pos6" then HuntBars.db.profile.addit.cust1pos=6 HuntBars.CustomBar1:Show() end

								HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.addit.cust1posmenu end,
						},
						custom2 = {
							name = L["Custom Bar 2"],
							desc = L["Changes the position of the bar."],
							type = "select",
							values = {pos1="Position 1", pos2="Position 2", pos3="Position 3", pos4="Position 4", pos5="Position 5", pos6="Position 6"},
							order = 16,
							set = function (info,val) HuntBars.db.profile.addit.cust2posmenu = val
								--if val == "off" then HuntBars.db.profile.addit.cust1pos = 0 HuntBars.CustomBar2:Hide()
								if val == "pos1" then HuntBars.db.profile.addit.cust2pos=1 HuntBars.CustomBar2:Show()
								elseif val == "pos2" then HuntBars.db.profile.addit.cust2pos=2 HuntBars.CustomBar2:Show()
								elseif val == "pos3" then HuntBars.db.profile.addit.cust2pos=3 HuntBars.CustomBar2:Show()
								elseif val == "pos4" then HuntBars.db.profile.addit.cust2pos=4 HuntBars.CustomBar2:Show()
								elseif val == "pos5" then HuntBars.db.profile.addit.cust2pos=5 HuntBars.CustomBar2:Show()
								elseif val == "pos6" then HuntBars.db.profile.addit.cust2pos=6 HuntBars.CustomBar2:Show() end

								HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.addit.cust2posmenu end,
						},
						custom3 = {
							name = L["Custom Bar 3"],
							desc = L["Changes the position of the bar."],
							type = "select",
							values = {pos1="Position 1", pos2="Position 2", pos3="Position 3", pos4="Position 4", pos5="Position 5", pos6="Position 6"},
							order = 17,
							set = function (info,val) HuntBars.db.profile.addit.cust3posmenu = val
								--if val == "off" then HuntBars.db.profile.addit.cust3pos = 0 HuntBars.CustomBar3:Hide()
								if val == "pos1" then HuntBars.db.profile.addit.cust3pos=1 HuntBars.CustomBar3:Show()
								elseif val == "pos2" then HuntBars.db.profile.addit.cust3pos=2 HuntBars.CustomBar3:Show()
								elseif val == "pos3" then HuntBars.db.profile.addit.cust3pos=3 HuntBars.CustomBar3:Show()
								elseif val == "pos4" then HuntBars.db.profile.addit.cust3pos=4 HuntBars.CustomBar3:Show()
								elseif val == "pos5" then HuntBars.db.profile.addit.cust3pos=5 HuntBars.CustomBar3:Show()
								elseif val == "pos6" then HuntBars.db.profile.addit.cust3pos=6 HuntBars.CustomBar3:Show() end

								HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.addit.cust3posmenu end,
						},
					},
				},
				custombars = {
					name = L["Custom bars"],
					desc = L["Options to set what spells a custom bar tracks."],
					order = 70,
					type = "group",
					args = {
						configmode = {
							name = L["Configuration mode"],
							desc = L["Toggles the inactive frames to see the results of changing an appearance options."],
							type = "toggle",
							order = 0,
							set = function (info,val) HB.ConfigMode = val HuntBars:ConfigMode() end,
							get = function(info) return HB.ConfigMode end,
						},
						additmode = {
							name = L["Extended mode"],
							desc = L["Toggles the frame with additional bars."],
							type = "toggle",
							order = 1,
							set = function (info,val) HuntBars.db.profile.addit.additmode = val
									if HuntBars.db.profile.addit.additmode == true then
										HuntBars.AdditFrame:Show()
									else
										HuntBars.AdditFrame:Hide()
									end
								  end,
							get = function(info) return HuntBars.db.profile.addit.additmode end,
						},
						hidefocus = {
							name = L["Hide Focus"],
							desc = L["Removes Focus bar from the frames (Not recommended because it contains important additional info)."],
							type = "toggle",
							order = 2,
							set = function(info, val) HuntBars.db.profile.general.hidefocus = val HuntBars:DrawAllBars() end,
							get = function(info) return HuntBars.db.profile.general.hidefocus end,
						},
						focusonlymode = {
							name = L["Focus bar only mode"],
							desc = L["Toggles between focus bar only and full mode. To adjust this bar use Extended mode controls."],
							type = "toggle",
							order = 3,
							set = function (info,val) HuntBars.db.profile.general.focusonlymode = val
								if HuntBars.db.profile.general.focusonlymode == true then
									HB.BarsGeneralFrame:Hide()
									HB.SAFocusGeneralFrame:Show()
								else
									HB.BarsGeneralFrame:Show()
									HB.SAFocusGeneralFrame:Hide()
								end								
							end,
							get = function(info) return HuntBars.db.profile.general.focusonlymode end,
						},
						cust1header = {
							name = L["Custom Bar 1"],
							type = "header",
							order = 10,
						},
						cust1type = {
							name = L["Ability Type"],
							desc = L["Changes what type of ability the bar tracks - cooldown, self buff or target debuff."],
							type = "select",
							values = {pos1="Cooldown", pos2="Debuff/DOT on target", pos3="Buff on self"},
							order = 11,
							set = function (info,val) HuntBars.db.profile.addit.c1typemenu = val
									if val == "pos1" then HuntBars.db.profile.addit.c1type = "cooldown"
									elseif val == "pos2" then HuntBars.db.profile.addit.c1type = "debuff"
									elseif val == "pos3" then HuntBars.db.profile.addit.c1type = "buff" end
									HuntBars:DrawAllBars()
								end,
							get = function(info) return HuntBars.db.profile.addit.c1typemenu end,
						},
						cust1ID = {
							name = L["Spell Name/ID"],
							desc = L["Type in the name or numerical ID of the ability that you want to track."],
							type = "input",
							order = 12,
							set = function (info,val) HuntBars.db.profile.addit.c1ID = val
								HuntBars:AssignSpellNames()
								HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.addit.c1ID end,
						},
						cust1otherscast = {
							name = L["Track others' (de)buffs"],
							desc = L["Check this option if you want the bar to track (de)buffs no matter who cast them. Uncheck to track only (de)buffs you cast."],
							type = "toggle",
							order = 13,
							set = function(info, val) HuntBars.db.profile.addit.cust1otherscast = val end,
							get = function(info) return HuntBars.db.profile.addit.cust1otherscast end,
						},
						cust1name = {
							name = L["Custom bar name"],
							desc = L["Type in a custom text you prefer to be displayed for the tracked ability. If you want to use the default name leave this field blank."],
							type = "input",
							order = 14,
							set = function (info,val) HuntBars.db.profile.addit.c1name = val
								HuntBars:AssignSpellNames()
								HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.addit.c1name end,
						},
						cust2header = {
							name = L["Custom Bar 2"],
							type = "header",
							order = 20,
						},
						cust2type = {
							name = L["Ability Type"],
							desc = L["Changes what type of ability the bar tracks - cooldown, self buff or target debuff."],
							type = "select",
							values = {pos1="Cooldown", pos2="Debuff/DOT on target", pos3="Buff on self"},
							order = 21,
							set = function (info,val) HuntBars.db.profile.addit.c2typemenu = val
								if val == "pos1" then HuntBars.db.profile.addit.c2type = "cooldown"
								elseif val == "pos2" then HuntBars.db.profile.addit.c2type = "debuff"
								elseif val == "pos3" then HuntBars.db.profile.addit.c2type = "buff" end
								HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.addit.c2typemenu end,
						},
						cust2ID = {
							name = L["Spell Name/ID"],
							desc = L["Type in the name or numerical ID of the ability that you want to track."],
							type = "input",
							order = 22,
							set = function (info,val) HuntBars.db.profile.addit.c2ID = val
								HuntBars:AssignSpellNames()
								HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.addit.c2ID end,
						},
						cust2otherscast = {
							name = L["Track others' (de)buffs"],
							desc = L["Check this option if you want the bar to track (de)buffs no matter who cast them. Uncheck to track only (de)buffs you cast."],
							type = "toggle",
							order = 23,
							set = function(info, val) HuntBars.db.profile.addit.cust2otherscast = val end,
							get = function(info) return HuntBars.db.profile.addit.cust2otherscast end,
						},
						cust2name = {
							name = L["Custom bar name"],
							desc = L["Type in a custom text you prefer to be displayed for the tracked ability. If you want to use the default name leave this field blank."],
							type = "input",
							order = 24,
							set = function (info,val) HuntBars.db.profile.addit.c2name = val
								HuntBars:AssignSpellNames()
								HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.addit.c2name end,
						},
						cust3header = {
							name = L["Custom Bar 3"],
							type = "header",
							order = 30,
						},
						cust3type = {
							name = L["Ability Type"],
							desc = L["Changes what type of ability the bar tracks - cooldown, self buff or target debuff."],
							type = "select",
							values = {pos1="Cooldown", pos2="Debuff/DOT on target", pos3="Buff on self"},
							order = 31,
							set = function (info,val) HuntBars.db.profile.addit.c3typemenu = val
								if val == "pos1" then HuntBars.db.profile.addit.c3type = "cooldown"
								elseif val == "pos2" then HuntBars.db.profile.addit.c3type = "debuff"
								elseif val == "pos3" then HuntBars.db.profile.addit.c3type = "buff" end
								HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.addit.c3typemenu end,
						},
						cust3ID = {
							name = L["Spell Name/ID"],
							desc = L["Type in the name or numerical ID of the ability that you want to track."],
							type = "input",
							order = 32,
							set = function (info,val) HuntBars.db.profile.addit.c3ID = val
								HuntBars:AssignSpellNames()
								HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.addit.c3ID end,
						},
						cust3otherscast = {
							name = L["Track others' (de)buffs"],
							desc = L["Check this option if you want the bar to track (de)buffs no matter who cast them. Uncheck to track only (de)buffs you cast."],
							type = "toggle",
							order = 33,
							set = function(info, val) HuntBars.db.profile.addit.cust3otherscast = val end,
							get = function(info) return HuntBars.db.profile.addit.cust3otherscast end,
						},
						cust3name = {
							name = L["Custom bar name"],
							desc = L["Type in a custom text you prefer to be displayed for the tracked ability. If you want to use the default name leave this field blank."],
							type = "input",
							order = 34,
							set = function (info,val) HuntBars.db.profile.addit.c3name = val
								HuntBars:AssignSpellNames()
								HuntBars:DrawAllBars()
							end,
							get = function(info) return HuntBars.db.profile.addit.c3name end,
						},
					},
				},
			},
		},
	},
}

-- Next few funcions are used for options table(HuntBarsOptions) to determine if an option should be hidden/shown
function HuntBars:checkstacktypeMM(info)
	if HuntBars.db.profile.marksmanship.activebar == "readysetaim" then return true
	else return false end
end

function HuntBars:checkstacktypeBM(info)
	if HuntBars.db.profile.beastmastery.activebar == "frenzy" then return true
	else return false end
end

function HuntBars:notcheckstacktypeMM(info)
	if HuntBars.db.profile.marksmanship.activebar == "readysetaim" then return false
	else return true end
end

function HuntBars:notcheckstacktypeBM(info)
	if HuntBars.db.profile.beastmastery.activebar == "frenzy" then return false
	else return true end
end

function HuntBars:checkexplosiveSV(info)
	if HuntBars.db.profile.survival.activebar == "explosive" then return false
	else return true end
end

function HuntBars:checkextracolorRF(info)
	if HuntBars.db.profile.addit.activebar == "rapidfire" then return false
	else return true end
end




-- Enables/Disables Configuration mode (Based on current spec shows/hides bars of the two not active specs)
function HuntBars:ConfigMode()
	if HB.ConfigMode == true then
		if HuntBars.db.profile.general.incombatonly == true and not InCombatLockdown() then
			HBAddonGeneralFrame:Show()
		end
		self:DrawAllBars()
	else
		if HuntBars.db.profile.general.incombatonly == true and not InCombatLockdown() then
			HBAddonGeneralFrame:Hide()
		end
		self:DrawAllBars()
		if HB.Spec == 1 then
			self.MarksFrame:Hide()
			self.SurvFrame:Hide()
		elseif HB.Spec == 2 then
			self.BMFrame:Hide()
			self.SurvFrame:Hide()
		elseif HB.Spec == 3 then
			self.BMFrame:Hide()
			self.MarksFrame:Hide()
		end
	end
end

-- Draws/Updates all 3 specs with filled bars for when ConfigMode is enabled
function HuntBars:DrawConfigMode()
	-- Beast Mastery Frame 
	HuntBars.BMFocusBar:SetMinMaxValues(0, 110)
	HuntBars.BMFocusBar:SetValue(110)
	HuntBars.BMFocusBarText:SetText(110)
	HuntBars.KillCommandCDBar:SetValue(HuntBars.db.profile.beastmastery.killtime)
	HuntBars.KillCommandCDBarTextValue:SetText(HuntBars.db.profile.beastmastery.killtime)
	HuntBars.FrenzyBar:SetStatusBarColor(HuntBars.db.profile.beastmastery.frenzycolor["r"], HuntBars.db.profile.beastmastery.frenzycolor["g"], HuntBars.db.profile.beastmastery.frenzycolor["b"])
	HuntBars.FrenzyBar:SetValue(HuntBars.db.profile.beastmastery.frenzytime)
	HuntBars.FrenzyBarTextCD:SetText(HuntBars.db.profile.beastmastery.frenzytime)
	HuntBars.FrenzyBarTextStacks:SetPoint("LEFT", HuntBars.FrenzyBar, "LEFT", 5, 0)
	HuntBars.FrenzyBarTextStacks:SetText(HB.Text.noFrenzy)
	HuntBars.FocusFireCDBar:SetValue(HuntBars.db.profile.beastmastery.focusfiretime)
	HuntBars.FocusFireCDBarTextValue:SetText(HuntBars.db.profile.beastmastery.focusfiretime)
	HuntBars.BMFrame:Show()
	-- Marksmanship Frame Draw
	HuntBars.MarksFocusBar:SetMinMaxValues(0, 100)
	HuntBars.MarksFocusBar:SetValue(100)
	HuntBars.MarksFocusBarText:SetText(100)
	HuntBars.ChimeraCDBar:SetValue(HuntBars.db.profile.marksmanship.chimeratime)
	HuntBars.ChimeraCDBarTextValue:SetText(HuntBars.db.profile.marksmanship.chimeratime)
	HuntBars.ImprovedSteadyBar:SetValue(HuntBars.db.profile.marksmanship.improvedsstime)
	HuntBars.ImprovedSteadyBarTextValue:SetText(HuntBars.db.profile.marksmanship.improvedsstime)
	HuntBars.ReadySetAimBar:SetStatusBarColor(HuntBars.db.profile.marksmanship.readysetaimcolor["r"], HuntBars.db.profile.marksmanship.readysetaimcolor["g"], HuntBars.db.profile.marksmanship.readysetaimcolor["b"])
	HuntBars.ReadySetAimBar:SetValue(HuntBars.db.profile.marksmanship.readysetaimtime)
	HuntBars.ReadySetAimBarTextCD:SetText(HuntBars.db.profile.marksmanship.readysetaimtime)
	HuntBars.ReadySetAimBarTextStacks:SetPoint("LEFT", HuntBars.ReadySetAimBar, "LEFT", 5, 0)
	HuntBars.ReadySetAimBarTextStacks:SetText(HB.Text.noReadySetAim)
	HuntBars.MarksFrame:Show()
	-- Survival Frame Draw
	HuntBars.SurvFocusBar:SetMinMaxValues(0, 100)
	HuntBars.SurvFocusBar:SetValue(100)
	HuntBars.SurvFocusBarText:SetText(100)
	HuntBars.ExpShotCDBar:SetMinMaxValues(0, HuntBars.db.profile.survival.explosivetime)
	HuntBars.ExpShotCDBar:SetValue(HuntBars.db.profile.survival.explosivetime)
	HuntBars.ExpShotCDBarTextValue:SetText(HuntBars.db.profile.survival.explosivetime)
	HuntBars.LocknLoadCDBar:SetValue(HuntBars.db.profile.survival.locknloadtime)
	HuntBars.LocknLoadCDBarTextValue:SetText(HuntBars.db.profile.survival.locknloadtime)
	HuntBars.BlackArrowCDBar:SetValue(HuntBars.db.profile.survival.blackarrowtime)
	HuntBars.BlackArrowCDBarTextValue:SetText(HuntBars.db.profile.survival.blackarrowtime)
    HuntBars.SurvFrame:Show()
	-- Additional Frame Draw
	HuntBars.SerpentBar:SetValue(HuntBars.db.profile.addit.serpenttime)
	HuntBars.SerpentBarTextValue:SetText(HuntBars.db.profile.addit.serpenttime)
	HuntBars.KillShotBar:SetValue(HuntBars.db.profile.addit.killshottime)
	HuntBars.KillShotBarTextValue:SetText(HuntBars.db.profile.addit.killshottime)
	HuntBars.RapidFireBar:SetValue(HuntBars.db.profile.addit.rapidfiretime)
	HuntBars.RapidFireBarTextValue:SetText(HuntBars.db.profile.addit.rapidfiretime)
	HuntBars.CustomBar1:SetValue(HuntBars.db.profile.addit.cust1time)
	HuntBars.CustomBar1TextValue:SetText(HuntBars.db.profile.addit.cust1time)
	HuntBars.CustomBar2:SetValue(HuntBars.db.profile.addit.cust2time)
	HuntBars.CustomBar2TextValue:SetText(HuntBars.db.profile.addit.cust2time)
	HuntBars.CustomBar3:SetValue(HuntBars.db.profile.addit.cust3time)
	HuntBars.CustomBar3TextValue:SetText(HuntBars.db.profile.addit.cust3time)
	-- Standalone Focus Frame Draw
	HuntBars.SAFocusBar:SetMinMaxValues(0, UnitPowerMax("player"))
	HuntBars.SAFocusBar:SetValue(UnitPowerMax("player"))
	HuntBars.SAFocusBarText:SetText(UnitPowerMax("player"))
end

-- Assigns text for abilities tracked by the bars
function HuntBars:AssignSpellNames()
	-- Beast Mastery Bars Text
	if self.db.profile.beastmastery.barstext == "text1" then
		HB.Text.KillCommand = GetSpellInfo(34026)
		HB.Text.Fire = GetSpellInfo(82926)
		HB.Text.Frenzy = GetSpellInfo(19615)
		HB.Text.noFrenzy = L["Frenzy - 0 Stacks"]
		HB.Text.FocusFire = GetSpellInfo(82692)
		HB.Text.FocusFire5 = L["Focus Fire(x5), use NOW!"]
	elseif self.db.profile.beastmastery.barstext == "text2" then
		HB.Text.KillCommand = L["KC"]
		HB.Text.Fire = GetSpellInfo(82926)
		HB.Text.Frenzy = GetSpellInfo(19615)
		HB.Text.noFrenzy = L["F 0"]
		HB.Text.FocusFire = L["FF"]
		HB.Text.FocusFire5 = L["FF 5"]
	elseif self.db.profile.beastmastery.barstext == "text3" then
		HB.Text.KillCommand = ""
		HB.Text.Fire = ""
		HB.Text.Frenzy = ""
		HB.Text.noFrenzy = ""
		HB.Text.FocusFire = ""
		HB.Text.FocusFire5 = ""
	end
	-- Marksmanship Bars Text
	if self.db.profile.marksmanship.barstext == "text1" then
		HB.Text.Chimera = GetSpellInfo(53209)
		HB.Text.ReadySetAim = GetSpellInfo(82925)
		HB.Text.noReadySetAim = L["Ready, Set, Aim - 0 Stacks"]
		HB.Text.ImprovedSteady = GetSpellInfo(53220)
		HB.Text.FireAimed = L["Fire Aimed Shot NOW!"]
	elseif self.db.profile.marksmanship.barstext == "text2" then
		HB.Text.Chimera = L["CS"]
		HB.Text.ReadySetAim = L["RSA"]
		HB.Text.noReadySetAim = L["RSA 0"]
		HB.Text.ImprovedSteady = L["ISS"]
		HB.Text.FireAimed = L["AS"]
	elseif self.db.profile.marksmanship.barstext == "text3" then
		HB.Text.Chimera = ""
		HB.Text.ReadySetAim = ""
		HB.Text.noReadySetAim = ""
		HB.Text.ImprovedSteady = ""
		HB.Text.FireAimed = ""
	end
	-- Survival Bars Text
	if self.db.profile.survival.barstext == "text1" then
		HB.Text.ExplosiveShot = GetSpellInfo(53301)
		HB.Text.BlackArrow = GetSpellInfo(3674)
		HB.Text.LocknLoad = GetSpellInfo(56453)
		HB.Text.procLocknLoad = L["Lock n Load x"] HB.Text.NOW = L[" NOW!"]
	elseif self.db.profile.survival.barstext == "text2" then
		HB.Text.ExplosiveShot = L["ES"]
		HB.Text.BlackArrow = L["BA"]
		HB.Text.LocknLoad = L["LnL"]
		HB.Text.procLocknLoad = L["LnL "] HB.Text.NOW = ""
	elseif self.db.profile.survival.barstext == "text3" then
		HB.Text.ExplosiveShot = ""
		HB.Text.BlackArrow = ""
		HB.Text.LocknLoad = ""
		HB.Text.procLocknLoad = "" HB.Text.NOW = ""
	end
	-- Additional Bars Text
	if self.db.profile.addit.barstext == "text1" then
		HB.Text.Serpent = GetSpellInfo(1978)
		HB.Text.KillShot = GetSpellInfo(53351)
		HB.Text.RapidFire = GetSpellInfo(3045)
	elseif self.db.profile.addit.barstext == "text2" then
		HB.Text.Serpent = L["SS"]
		HB.Text.KillShot = L["KS"]
		HB.Text.RapidFire = L["RF"]
	elseif self.db.profile.addit.barstext == "text3" then
		HB.Text.Serpent = ""
		HB.Text.KillShot = ""
		HB.Text.RapidFire = ""
	end
	-- Custom Bars Text
	if HuntBars.db.profile.addit.c1name == "" then
		HB.Text.CustomBar1=HuntBars.db.profile.addit.c1ID
	else
		HB.Text.CustomBar1=HuntBars.db.profile.addit.c1name
	end
	if HuntBars.db.profile.addit.c2name == "" then
		HB.Text.CustomBar2=HuntBars.db.profile.addit.c2ID
	else
		HB.Text.CustomBar2=HuntBars.db.profile.addit.c2name
	end
	if HuntBars.db.profile.addit.c3name == "" then
		HB.Text.CustomBar3=HuntBars.db.profile.addit.c3ID
	else
		HB.Text.CustomBar3=HuntBars.db.profile.addit.c3name
	end
	--[[if GetSpellInfo(HuntBars.db.profile.addit.c1ID) then HB.Text.CustomBar1=GetSpellInfo(HuntBars.db.profile.addit.c1ID)
	else HB.Text.CustomBar1="No such ability" end
	if GetSpellInfo(HuntBars.db.profile.addit.c2ID) then HB.Text.CustomBar2=GetSpellInfo(HuntBars.db.profile.addit.c2ID)
	else HB.Text.CustomBar2="No such ability" end
	if GetSpellInfo(HuntBars.db.profile.addit.c3ID) then HB.Text.CustomBar3=GetSpellInfo(HuntBars.db.profile.addit.c3ID)
	else HB.Text.CustomBar3="No such ability" end
	--]]
end

-- Used to pass the selected bar positions from options to the frames
function HuntBars:Slots()
	local FocusHidden
	if self.db.profile.general.hidefocus == true then FocusHidden = 1
		else FocusHidden = 0 end
	-- Beast Mastery
	HB.Slots.BMTotal = ((HuntBars.db.profile.beastmastery.amountbmbars+1) - FocusHidden)
	HB.Slots.KC = -(HuntBars.db.profile.beastmastery.kcpos - FocusHidden)
	HB.Slots.Frenzy = -(HuntBars.db.profile.beastmastery.frpos - FocusHidden)
	HB.Slots.FFire = -(HuntBars.db.profile.beastmastery.ffpos - FocusHidden) ----old(half-sized) slot was ->  HB.Slots.Frenzy - 1
	-- Marksmanship
	HB.Slots.MarksTotal = ((HuntBars.db.profile.marksmanship.amountmarksbars+1)- FocusHidden)
	HB.Slots.CS = -(HuntBars.db.profile.marksmanship.cspos - FocusHidden)
	HB.Slots.ISS = -(HuntBars.db.profile.marksmanship.isspos - FocusHidden)
	HB.Slots.RSA = -(HuntBars.db.profile.marksmanship.rsapos - FocusHidden)
	-- Survival
	HB.Slots.SurvTotal = ((HuntBars.db.profile.survival.amountsurvbars+1) - FocusHidden)
	HB.Slots.ES = -(HuntBars.db.profile.survival.espos - FocusHidden)
	HB.Slots.LnL = -(HuntBars.db.profile.survival.lnlpos - FocusHidden) --old(half-sized) slot was ->  HB.Slots.ES - 1
	HB.Slots.BA = -(HuntBars.db.profile.survival.bapos - FocusHidden)
	-- Extended Mode
	HB.Slots.AdditTotal = HuntBars.db.profile.addit.amountadditbars
	HB.Slots.SS = -(HuntBars.db.profile.addit.sspos - 1)
	--if HuntBars.db.profile.addit.sspos == 0 then HuntBars.SerpentBar:Hide() else HuntBars.SerpentBar:Show() end
	HB.Slots.KS = -(HuntBars.db.profile.addit.kspos - 1)
	--if HuntBars.db.profile.addit.kspos == 0 then HuntBars.KillShotBar:Hide() else HuntBars.KillShotBar:Show() end	
	HB.Slots.RF = -(HuntBars.db.profile.addit.rfpos - 1)
	--if HuntBars.db.profile.addit.rfpos == 0 then HuntBars.RapidFireBar:Hide() else HuntBars.RapidFireBar:Show() end	
	HB.Slots.CUST1 = -(HuntBars.db.profile.addit.cust1pos - 1)
	--if HuntBars.db.profile.addit.cust1pos == 0 then HuntBars.CustomBar1:Hide() else HuntBars.CustomBar1:Show() end
	HB.Slots.CUST2 = -(HuntBars.db.profile.addit.cust2pos - 1)
	--if HuntBars.db.profile.addit.cust2pos == 0 then HuntBars.CustomBar2:Hide() else HuntBars.CustomBar2:Show() end
	HB.Slots.CUST3 = -(HuntBars.db.profile.addit.cust3pos - 1)
	--if HuntBars.db.profile.addit.cust3pos == 0 then HuntBars.CustomBar3:Hide() else HuntBars.CustomBar3:Show() end
end

-- Draws/Updates Stand-Alone Focus bar frame (runs mainly on option change)
function HuntBars:DrawSAFocusBar()
	-- Create SAFocus main frame begin
	if not HB.FramesCreated then self.SAFocusFrame = CreateFrame("Frame", "SAFocus", HB.SAFocusGeneralFrame) end
	self.SAFocusFrame:SetClampedToScreen(HuntBars.db.profile.general.clamped)
	if HB.ConfigMode then self.SAFocusFrame:EnableMouse(true)
		else self.SAFocusFrame:EnableMouse(not self.db.profile.general.clickthrough) end
	self.SAFocusFrame:SetHeight(self.db.profile.addit.barsheight)
	self.SAFocusFrame:SetWidth(self.db.profile.addit.barswidth)
	if not HB.FramesCreated then self.SAFocusFrame:SetPoint("CENTER", UIParent, "CENTER", 0,0) end
	self.SAFocusFrame:SetMovable(true)
	self.SAFocusFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background",
										edgeFile =nil, -- "Interface/Tooltips/UI-Tooltip-Border", 
										tile = true, tileSize = 16, edgeSize = 16,
										insets = { left = -2, right = -2, top = -2, bottom = -2 }})
	self.SAFocusFrame:SetBackdropColor(0,0,0, HuntBars.db.profile.general.backtransparency)
	

	if not HB.FramesCreated then self.SAFocusEst = CreateFrame("StatusBar", "SAFocusEst", self.SAFocusFrame) end
	if not HB.FramesCreated then self.SAFocusBar = CreateFrame("StatusBar", "SAFocusBar", self.SAFocusEst) end
	if not HB.FramesCreated then self.SAFocusBarText = self.SAFocusBar:CreateFontString("SAFocusBarText", "PARENT", "GameFontNormal") end
	if not HB.FramesCreated then self.SAFocusMain = CreateFrame("StatusBar", "SAFocusMain", self.SAFocusBar) end
	-- Create SAFocus main frame end
	-- Create SAFocusEst Begin	
	self.SAFocusEst:SetParent("SAFocus")
	self.SAFocusEst:SetHeight(self.db.profile.addit.barsheight)
	self.SAFocusEst:SetWidth(self.db.profile.addit.barswidth)
	--self.SAFocusEst:SetFrameStrata("PARENT")
	self.SAFocusEst:SetStatusBarTexture(SharedMedia:Fetch("statusbar", self.db.profile.general.texture))
	self.SAFocusEst:SetStatusBarColor(96/255, 96/255, 96/255, 1)
	self.SAFocusEst:SetOrientation("HORIZONTAL")
	self.SAFocusEst:SetPoint("TOPLEFT", "SAFocus", "TOPLEFT", 0,0)
	self.SAFocusEst:SetMinMaxValues(0, UnitPowerMax("player"))
	self.SAFocusEst:Show()
	-- Create SAFocusEst End
	-- Create SAFocusBar Begin
	self.SAFocusBar:SetParent("SAFocusEst")
	self.SAFocusBar:SetHeight(self.db.profile.addit.barsheight)
	self.SAFocusBar:SetWidth(self.db.profile.addit.barswidth)
	--self.SAFocusBar:SetFrameStrata("PARENT")
	self.SAFocusBar:SetStatusBarTexture(SharedMedia:Fetch("statusbar", self.db.profile.general.texture))
	self.SAFocusBar:SetStatusBarColor(255/255, 125/255, 10/255)
	self.SAFocusBar:SetOrientation("HORIZONTAL")
	self.SAFocusBar:SetPoint("TOPLEFT", "SAFocusEst", "TOPLEFT", 0,0)
	self.SAFocusMain:SetMinMaxValues(0, UnitPowerMax("player"))
	self.SAFocusBar:Show()
	-- Create SAFocusBar End
	-- Create Main Ability minimum focus amount Begin
	self.SAFocusMain:SetParent("SAFocusBar")
	self.SAFocusMain:SetHeight(self.db.profile.addit.barsheight)
	self.SAFocusMain:SetWidth(self.db.profile.addit.barswidth)
	--self.SAFocusMain:SetFrameStrata("PARENT")
	self.SAFocusMain:SetStatusBarTexture("Interface\\AddOns\\HuntBars\\Images\\Flat.tga")
	self.SAFocusMain:SetStatusBarColor(96/255, 96/255, 96/255, 0.5)
	self.SAFocusMain:SetOrientation("HORIZONTAL")
	self.SAFocusMain:SetPoint("TOPLEFT", "SAFocusBar", "TOPLEFT", 0,0)
	self.SAFocusMain:SetMinMaxValues(0, UnitPowerMax("player"))
	if HB.Spec == 1 then MainAmount = 40 else MainAmount = 44 end
	self.SAFocusMain:SetValue(MainAmount)
	self.SAFocusMain:Show()
	-- Create Main Ability minimum focus amount End
	-- Create SAFocusBar Number Begin
	self.SAFocusBarText:SetFont(SharedMedia:Fetch("font", self.db.profile.addit.barsfont), self.db.profile.addit.fontsize)
	self.SAFocusBarText:SetTextColor(1, 1, 1)
	-- self.FocusText:SetJustifyH("LEFT")
	self.SAFocusBarText:SetPoint("CENTER", self.SAFocusBar, "CENTER", 0,0)
	self.SAFocusBarText:Show()
	-- Create SAFocusBar Number End
	-- SAFocusFrame Moving Begin
	if not HB.FramesCreated then
		self.SAFocusFrame:SetScript("OnMouseDown", function(frame, button)
			if (button == "LeftButton") and ((IsShiftKeyDown() and IsControlKeyDown()) or HB.ConfigMode == true) then
				frame:StartMoving()
			end
		end)
		self.SAFocusFrame:SetScript("OnMouseUp", function(frame, button)
			if (button == "LeftButton") then
				frame:StopMovingOrSizing()
			end
		end)
	end
	-- SAFocusFrame Moving End
	if HB.ConfigMode then self:DrawConfigMode() end -- Draws filled bars if ConfigMode is enabled	
end

-- Draws/Updates Beast Mastery bars frame (runs mainly on option change)
function HuntBars:DrawBMBars()
	-- Create MainFrame Begin
	if not HB.FramesCreated then self.BMFrame = CreateFrame("Frame", "HBBM", HB.BarsGeneralFrame) end
	self.BMFrame:SetClampedToScreen(HuntBars.db.profile.general.clamped)
	if HB.ConfigMode then self.BMFrame:EnableMouse(true)
		else self.BMFrame:EnableMouse(not self.db.profile.general.clickthrough) end
	self.BMFrame:SetHeight((HB.Slots.BMTotal * self.db.profile.beastmastery.barsheight) +
						  ((HB.Slots.BMTotal - 1) * self.db.profile.beastmastery.barsdistance))
	self.BMFrame:SetWidth(self.db.profile.beastmastery.barswidth)
	if not HB.FramesCreated then self.BMFrame:SetPoint("CENTER", UIParent, "CENTER", 0,0) end
	self.BMFrame:SetMovable(true)
	self.BMFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
										edgeFile =nil, -- "Interface/Tooltips/UI-Tooltip-Border", 
										tile = true, tileSize = 16, edgeSize = 16, 
										insets = { left = -2, right = -2, top = -2, bottom = -2 }})
	self.BMFrame:SetBackdropColor(0,0,0,HuntBars.db.profile.general.backtransparency)
	-- Create MainFrame End
	if not HB.FramesCreated then self.BMFocusEst = CreateFrame("StatusBar", "BMFocusEst", self.BMFrame) end
	if not HB.FramesCreated then self.BMFocusBar = CreateFrame("StatusBar", "BMFocusBar", self.BMFocusEst) end
	if not HB.FramesCreated then self.BMFocusBarText = self.BMFocusBar:CreateFontString("BMFocusBarText", "PARENT", "GameFontNormal") end
	if not HB.FramesCreated then self.BMFocusKillComm = CreateFrame("StatusBar", "BMFocusKillComm", self.BMFocusBar) end
	self.BMFocusBar:Hide()
	if self.db.profile.general.hidefocus == false then
		-- Create BMFocusEst Begin	
		self.BMFocusEst:SetParent("HBBM")
		self.BMFocusEst:SetHeight(self.db.profile.beastmastery.barsheight)
		self.BMFocusEst:SetWidth(self.db.profile.beastmastery.barswidth)
		--self.BMFocusEst:SetFrameStrata("PARENT")
		self.BMFocusEst:SetStatusBarTexture(SharedMedia:Fetch("statusbar", self.db.profile.general.texture))
		self.BMFocusEst:SetStatusBarColor(96/255, 96/255, 96/255, 1)
		self.BMFocusEst:SetOrientation("HORIZONTAL")
		self.BMFocusEst:SetPoint("TOPLEFT", "HBBM", "TOPLEFT",0,0)
		self.BMFocusEst:SetMinMaxValues(0, 110)
		self.BMFocusEst:Show()
	-- Create BMFocusEst End
	-- Create BMFocusBar Begin
		self.BMFocusBar:SetParent("BMFocusEst")
		self.BMFocusBar:SetHeight(self.db.profile.beastmastery.barsheight)
		self.BMFocusBar:SetWidth(self.db.profile.beastmastery.barswidth)
		--self.BMFocusBar:SetFrameStrata("PARENT")
		self.BMFocusBar:SetStatusBarTexture(SharedMedia:Fetch("statusbar", self.db.profile.general.texture))
		self.BMFocusBar:SetStatusBarColor(255/255, 125/255, 10/255)
		self.BMFocusBar:SetOrientation("HORIZONTAL")
		self.BMFocusBar:SetPoint("TOPLEFT", "BMFocusEst", "TOPLEFT", 0, 0)
		self.BMFocusBar:Show()
	-- Create BMFocusBar End
	-- Create Kill Command minimum focus amount Begin
		self.BMFocusKillComm:SetParent("BMFocusBar")
		self.BMFocusKillComm:SetHeight(self.db.profile.beastmastery.barsheight)
		self.BMFocusKillComm:SetWidth(self.db.profile.beastmastery.barswidth)
		--self.BMFocusKillComm:SetFrameStrata("PARENT")
		self.BMFocusKillComm:SetStatusBarTexture("Interface\\AddOns\\HuntBars\\Images\\Flat.tga")
		self.BMFocusKillComm:SetStatusBarColor(96/255, 96/255, 96/255, 0.5)
		self.BMFocusKillComm:SetOrientation("HORIZONTAL")
		self.BMFocusKillComm:SetPoint("TOPLEFT", "BMFocusBar", "TOPLEFT",0,0)
		self.BMFocusKillComm:SetMinMaxValues(0, 110)
		self.BMFocusKillComm:SetValue(40)
		self.BMFocusKillComm:Show()
	-- Create Kill Command minimum focus amount End
	-- Create BMFocusBar Number Begin
		self.BMFocusBarText:SetFont(SharedMedia:Fetch("font", self.db.profile.beastmastery.barsfont), self.db.profile.beastmastery.fontsize)
		self.BMFocusBarText:SetTextColor(1, 1, 1)
		-- self.FocusText:SetJustifyH("LEFT")
		self.BMFocusBarText:SetPoint("CENTER", self.BMFocusBar, "CENTER", 0, 0)
		self.BMFocusBarText:Show()
	end
	-- Create BMFocusBar Number End
	-- Create KillCommandCDBar Begin
	if not HB.FramesCreated then self.KillCommandCDBar = CreateFrame("StatusBar", "KillCommandCDBar", self.BMFrame) end
	self.KillCommandCDBar:SetParent("HBBM")
	self.KillCommandCDBar:SetHeight(self.db.profile.beastmastery.barsheight)
	self.KillCommandCDBar:SetWidth(self.db.profile.beastmastery.barswidth)
	--self.KillCommandCDBar:SetFrameStrata("PARENT")
	self.KillCommandCDBar:SetStatusBarTexture(SharedMedia:Fetch("statusbar", self.db.profile.general.texture))
	self.KillCommandCDBar:SetStatusBarColor(HuntBars.db.profile.beastmastery.killcolor["r"], HuntBars.db.profile.beastmastery.killcolor["g"], HuntBars.db.profile.beastmastery.killcolor["b"])
	self.KillCommandCDBar:SetOrientation("HORIZONTAL")
	self.KillCommandCDBar:SetPoint("TOPLEFT", "HBBM", "TOPLEFT",
									0, HB.Slots.KC * (self.db.profile.beastmastery.barsheight + self.db.profile.beastmastery.barsdistance))
	--self.KillCommandCDBar:Show()
	self.KillCommandCDBar:SetMinMaxValues(0, self.db.profile.beastmastery.killtime)
	-- Create KillCommandCDBar End
	-- Create KillCommandCDBar Number Begin
	if not HB.FramesCreated then
		self.KillCommandCDBarTextValue = self.KillCommandCDBar:CreateFontString("KillCommandCDBarTextValue", "PARENT", "GameFontNormal") end
	self.KillCommandCDBarTextValue:SetFont(SharedMedia:Fetch("font", self.db.profile.beastmastery.barsfont), self.db.profile.beastmastery.fontsize)
	self.KillCommandCDBarTextValue:SetTextColor(1, 1, 1)
	self.KillCommandCDBarTextValue:SetPoint("LEFT", self.KillCommandCDBar, "LEFT", 5, 0)
	self.KillCommandCDBarTextValue:Show()
	if not HB.FramesCreated then
		self.KillCommandCDBarTextName = self.KillCommandCDBar:CreateFontString("KillCommandCDBarTextName", "PARENT", "GameFontNormal") end
	self.KillCommandCDBarTextName:SetTextColor(1, 1, 1)
	self.KillCommandCDBarTextName:SetFont(SharedMedia:Fetch("font", self.db.profile.beastmastery.barsfont), self.db.profile.beastmastery.fontsize)
	self.KillCommandCDBarTextName:SetPoint("RIGHT", self.KillCommandCDBar, "RIGHT", 0, 0)
	self.KillCommandCDBarTextName:SetText(HB.Text.KillCommand)
	self.KillCommandCDBarTextName:Show()
	-- Create KillCommandCDBar Number End
	-- Create FrenzyBar Begin
	if not HB.FramesCreated then self.FrenzyBar = CreateFrame("StatusBar", "FrenzyBar", self.BMFrame) end
	self.FrenzyBar:SetParent("HBBM")
	self.FrenzyBar:SetHeight(self.db.profile.beastmastery.barsheight)
	self.FrenzyBar:SetWidth(self.db.profile.beastmastery.barswidth)
	--self.FrenzyBar:SetFrameStrata("PARENT")
	self.FrenzyBar:SetStatusBarTexture(SharedMedia:Fetch("statusbar", self.db.profile.general.texture))
	self.FrenzyBar:SetStatusBarColor(HuntBars.db.profile.beastmastery.frenzycolor["r"], HuntBars.db.profile.beastmastery.frenzycolor["g"], HuntBars.db.profile.beastmastery.frenzycolor["b"])
	self.FrenzyBar:SetOrientation("HORIZONTAL")
	self.FrenzyBar:SetPoint("TOPLEFT", "HBBM", "TOPLEFT",
							0, (HB.Slots.Frenzy * (self.db.profile.beastmastery.barsheight + self.db.profile.beastmastery.barsdistance)))
	--self.FrenzyBar:Show()
	self.FrenzyBar:SetMinMaxValues(0, self.db.profile.beastmastery.frenzytime)
	-- Create FrenzyBar End
	-- Create FrenzyBar Number Begin
	if not HB.FramesCreated then
		self.FrenzyBarTextCD = self.FrenzyBar:CreateFontString("FrenzyBarTextCD", "PARENT", "GameFontNormal") end
	self.FrenzyBarTextCD:SetFont(SharedMedia:Fetch("font", self.db.profile.beastmastery.barsfont), self.db.profile.beastmastery.fontsize)
	self.FrenzyBarTextCD:SetTextColor(1, 1, 1)
	self.FrenzyBarTextCD:SetPoint("RIGHT", self.FrenzyBar, "RIGHT", 0, 0)
	self.FrenzyBarTextCD:Show()
	if not HB.FramesCreated then
		self.FrenzyBarTextStacks = self.FrenzyBar:CreateFontString("FrenzyBarTextStacks", "PARENT", "GameFontNormal") end
	self.FrenzyBarTextStacks:SetFont(SharedMedia:Fetch("font", self.db.profile.beastmastery.barsfont), self.db.profile.beastmastery.fontsize)
	self.FrenzyBarTextStacks:SetTextColor(1, 1, 1)
	self.FrenzyBarTextStacks:Show()
	-- Create FrenzyBar Number End
	-- Create FocusFireCDBar Begin
	if not HB.FramesCreated then self.FocusFireCDBar = CreateFrame("StatusBar", "FocusFireCDBar", self.BMFrame) end
	self.FocusFireCDBar:SetParent("HBBM")
	self.FocusFireCDBar:SetHeight(self.db.profile.beastmastery.barsheight)
	self.FocusFireCDBar:SetWidth(self.db.profile.beastmastery.barswidth)
	--self.FocusFireCDBar:SetFrameStrata("PARENT")
	self.FocusFireCDBar:SetStatusBarTexture(SharedMedia:Fetch("statusbar", self.db.profile.general.texture))
	self.FocusFireCDBar:SetStatusBarColor(HuntBars.db.profile.beastmastery.focusfirecolor["r"], HuntBars.db.profile.beastmastery.focusfirecolor["g"], HuntBars.db.profile.beastmastery.focusfirecolor["b"])
	self.FocusFireCDBar:SetOrientation("HORIZONTAL")
	self.FocusFireCDBar:SetPoint("TOPLEFT",	"HBBM", "TOPLEFT",0,
		HB.Slots.FFire * (self.db.profile.beastmastery.barsheight + self.db.profile.beastmastery.barsdistance))
	--[[Old(Half-sizeed) bar SetPoint calculation
	self.FocusFireCDBar:SetPoint("TOPLEFT",	"HBBM", "TOPLEFT",0,
	HB.Slots.FFire*(self.db.profile.beastmastery.barsheight+self.db.profile.beastmastery.barsdistance)+self.db.profile.beastmastery.barsdistance)
	--]]
	--self.FocusFireCDBar:Show()
	self.FocusFireCDBar:SetMinMaxValues(0, self.db.profile.beastmastery.focusfiretime)
	-- Create FocusFireCDBar End
	-- Create FocusFireCDBar Number Begin
	if not HB.FramesCreated then
		self.FocusFireCDBarTextValue = self.FocusFireCDBar:CreateFontString("FocusFireCDBarTextValue", "PARENT", "GameFontNormal") end
	self.FocusFireCDBarTextValue:SetFont(SharedMedia:Fetch("font", self.db.profile.beastmastery.barsfont), self.db.profile.beastmastery.fontsize)
	self.FocusFireCDBarTextValue:SetTextColor(1, 1, 1)
	self.FocusFireCDBarTextValue:SetPoint("LEFT", self.FocusFireCDBar, "LEFT", 5, 0)
	self.FocusFireCDBarTextValue:Show()
	if not HB.FramesCreated then
		self.FocusFireCDBarTextName = self.FocusFireCDBar:CreateFontString("FocusFireCDBarTextName", "PARENT", "GameFontNormal") end
	self.FocusFireCDBarTextName:SetFont(SharedMedia:Fetch("font", self.db.profile.beastmastery.barsfont), self.db.profile.beastmastery.fontsize)
	self.FocusFireCDBarTextName:SetTextColor(1, 1, 1)
	self.FocusFireCDBarTextName:SetPoint("RIGHT", self.FocusFireCDBar, "RIGHT", 0, 0)
	self.FocusFireCDBarTextName:SetText(HB.Text.FocusFire)
	self.FocusFireCDBarTextName:Show()
	-- Create FocusFireCDBar Number End
	
	if HuntBars.db.profile.beastmastery.kcpos > HuntBars.db.profile.beastmastery.amountbmbars then
		HuntBars.KillCommandCDBar:Hide()
	elseif HuntBars.db.profile.beastmastery.kcpos ~= 0 then
		HuntBars.KillCommandCDBar:Show()
	end
	if HuntBars.db.profile.beastmastery.frpos > HuntBars.db.profile.beastmastery.amountbmbars then
		HuntBars.FrenzyBar:Hide()
	elseif HuntBars.db.profile.beastmastery.frpos ~= 0 then
		HuntBars.FrenzyBar:Show()
	end
	if HuntBars.db.profile.beastmastery.ffpos > HuntBars.db.profile.beastmastery.amountbmbars then
		HuntBars.FocusFireCDBar:Hide()
	elseif HuntBars.db.profile.beastmastery.ffpos ~= 0 then
		HuntBars.FocusFireCDBar:Show()
	end

	-- BMFrame Moving Begin
	if not HB.FramesCreated then
		self.BMFrame:SetScript("OnMouseDown", function(frame, button)
			if (button == "LeftButton") and ((IsShiftKeyDown() and IsControlKeyDown()) or HB.ConfigMode == true) then
				frame:StartMoving()
			end
		end)
		self.BMFrame:SetScript("OnMouseUp", function(frame, button)
			if (button == "LeftButton") then
				frame:StopMovingOrSizing()
			end
		end)
	end
	-- BMFrame Moving End
	if HB.ConfigMode then self:DrawConfigMode() end -- Draws filled bars if ConfigMode is enabled
end

-- Draws/Updates Marksmanship bars frame (runs mainly on option change)
function HuntBars:DrawMarksBars()
	-- Create MainFrame Begin
	if not HB.FramesCreated then self.MarksFrame = CreateFrame("Frame", "HBMarksmaship", HB.BarsGeneralFrame) end
	self.MarksFrame:SetClampedToScreen(HuntBars.db.profile.general.clamped)
	if HB.ConfigMode then self.MarksFrame:EnableMouse(true)
		else self.MarksFrame:EnableMouse(not self.db.profile.general.clickthrough) end
	self.MarksFrame:SetHeight((HB.Slots.MarksTotal * self.db.profile.marksmanship.barsheight) +
							 ((HB.Slots.MarksTotal-1) * self.db.profile.marksmanship.barsdistance))
	self.MarksFrame:SetWidth(self.db.profile.marksmanship.barswidth)
	if not HB.FramesCreated then self.MarksFrame:SetPoint("CENTER", UIParent, "CENTER", 0,0) end
	self.MarksFrame:SetMovable(true)
	self.MarksFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background",
										edgeFile =nil, -- "Interface/Tooltips/UI-Tooltip-Border", 
										tile = true, tileSize = 16, edgeSize = 16,
										insets = { left = -2, right = -2, top = -2, bottom = -2 }})
	self.MarksFrame:SetBackdropColor(0,0,0,HuntBars.db.profile.general.backtransparency)
	-- Create MainFrame End
	if not HB.FramesCreated then self.MarksFocusEst = CreateFrame("StatusBar", "MarksFocusEst", self.MarksFrame) end	
	if not HB.FramesCreated then self.MarksFocusBar = CreateFrame("StatusBar", "MarksFocusBar", self.MarksFocusEst) end
	if not HB.FramesCreated then 
		self.MarksFocusBarText = self.MarksFocusBar:CreateFontString("MarksFocusBarText", "PARENT", "GameFontNormal")
	end
	if not HB.FramesCreated then self.MarksFocusChimera = CreateFrame("StatusBar", "MarksFocusChimera", self.MarksFocusBar) end
	self.MarksFocusBar:Hide()
	if self.db.profile.general.hidefocus == false then
	-- Create MarksFocusEst Begin
		self.MarksFocusEst:SetParent("HBMarksmaship")
		self.MarksFocusEst:SetHeight(self.db.profile.marksmanship.barsheight)
		self.MarksFocusEst:SetWidth(self.db.profile.marksmanship.barswidth)
		--self.MarksFocusEst:SetFrameStrata("PARENT")
		self.MarksFocusEst:SetStatusBarTexture(SharedMedia:Fetch("statusbar", self.db.profile.general.texture))
		self.MarksFocusEst:SetStatusBarColor(96/255, 96/255, 96/255, 1)
		self.MarksFocusEst:SetOrientation("HORIZONTAL")
		self.MarksFocusEst:SetPoint("TOPLEFT", "HBMarksmaship", "TOPLEFT",0,0)
		self.MarksFocusEst:SetMinMaxValues(0, 100)
		self.MarksFocusEst:Show()
	-- Create MarksFocusEst End
	-- Create MarksFocusBar Begin		
		self.MarksFocusBar:SetParent("MarksFocusEst")
		self.MarksFocusBar:SetHeight(self.db.profile.marksmanship.barsheight)
		self.MarksFocusBar:SetWidth(self.db.profile.marksmanship.barswidth)
		--self.MarksFocusBar:SetFrameStrata("PARENT")
		self.MarksFocusBar:SetStatusBarTexture(SharedMedia:Fetch("statusbar", self.db.profile.general.texture))
		self.MarksFocusBar:SetStatusBarColor(255/255, 125/255, 10/255)
		self.MarksFocusBar:SetOrientation("HORIZONTAL")
		self.MarksFocusBar:SetPoint("TOPLEFT", "MarksFocusEst", "TOPLEFT",0,0)
		self.MarksFocusBar:Show()
	-- Create MarksFocusBar End
	-- Create Chimera minimum focus amount Begin
		self.MarksFocusChimera:SetParent("MarksFocusBar")
		self.MarksFocusChimera:SetHeight(self.db.profile.marksmanship.barsheight)
		self.MarksFocusChimera:SetWidth(self.db.profile.marksmanship.barswidth)
		--self.MarksFocusChimera:SetFrameStrata("PARENT")
		self.MarksFocusChimera:SetStatusBarTexture("Interface\\AddOns\\HuntBars\\Images\\Flat.tga")
		self.MarksFocusChimera:SetStatusBarColor(96/255, 96/255, 96/255, 0.5)
		self.MarksFocusChimera:SetOrientation("HORIZONTAL")
		self.MarksFocusChimera:SetPoint("TOPLEFT", "MarksFocusBar", "TOPLEFT",0,0)
		self.MarksFocusChimera:SetMinMaxValues(0, 100)
		self.MarksFocusChimera:SetValue(44)
		self.MarksFocusChimera:Show()
	-- Create Chimera minimum focus amount End
	-- Create MarksFocusBar Number Begin
		self.MarksFocusBarText:SetFont(SharedMedia:Fetch("font", self.db.profile.marksmanship.barsfont), self.db.profile.marksmanship.fontsize)
		self.MarksFocusBarText:SetTextColor(1, 1, 1)
		self.MarksFocusBarText:SetPoint("CENTER", self.MarksFocusBar, "CENTER", 0, 0)
		self.MarksFocusBarText:Show()
	end
	-- Create MarksFocusBar Number End
	-- Create ChimeraCDBar Begin
	if not HB.FramesCreated then self.ChimeraCDBar = CreateFrame("StatusBar", "ChimeraCDBar", self.MarksFrame) end
	self.ChimeraCDBar:SetParent("HBMarksmaship")
	self.ChimeraCDBar:SetHeight(self.db.profile.marksmanship.barsheight)
	self.ChimeraCDBar:SetWidth(self.db.profile.marksmanship.barswidth)
	--self.ChimeraCDBar:SetFrameStrata("PARENT")
	self.ChimeraCDBar:SetStatusBarTexture(SharedMedia:Fetch("statusbar", self.db.profile.general.texture))
	self.ChimeraCDBar:SetStatusBarColor(HuntBars.db.profile.marksmanship.chimeracolor["r"], HuntBars.db.profile.marksmanship.chimeracolor["g"], HuntBars.db.profile.marksmanship.chimeracolor["b"])
	self.ChimeraCDBar:SetOrientation("HORIZONTAL")
	self.ChimeraCDBar:SetPoint("TOPLEFT", "HBMarksmaship", "TOPLEFT",
								0, HB.Slots.CS * (self.db.profile.marksmanship.barsheight + self.db.profile.marksmanship.barsdistance))
	--self.ChimeraCDBar:Show()
	self.ChimeraCDBar:SetMinMaxValues(0, HuntBars.db.profile.marksmanship.chimeratime)
	-- Create ChimeraCDBar End
	-- Create ChimeraCDBar Number Begin
	if not HB.FramesCreated then
		self.ChimeraCDBarTextValue = self.ChimeraCDBar:CreateFontString("ChimeraCDBarTextValue", "PARENT", "GameFontNormal") end
	self.ChimeraCDBarTextValue:SetFont(SharedMedia:Fetch("font", self.db.profile.marksmanship.barsfont), self.db.profile.marksmanship.fontsize)
	self.ChimeraCDBarTextValue:SetTextColor(1, 1, 1)
	self.ChimeraCDBarTextValue:SetPoint("LEFT", self.ChimeraCDBar, "LEFT", 5, 0)
	self.ChimeraCDBarTextValue:Show()
	if not HB.FramesCreated then
		self.ChimeraCDBarTextName = self.ChimeraCDBar:CreateFontString("ChimeraCDBarTextName", "PARENT", "GameFontNormal") end
	self.ChimeraCDBarTextName:SetFont(SharedMedia:Fetch("font", self.db.profile.marksmanship.barsfont), self.db.profile.marksmanship.fontsize)
	self.ChimeraCDBarTextName:SetTextColor(1, 1, 1)
	self.ChimeraCDBarTextName:SetPoint("RIGHT", self.ChimeraCDBar, "RIGHT", 0, 0)
	self.ChimeraCDBarTextName:SetText(HB.Text.Chimera)
	self.ChimeraCDBarTextName:Show()
	-- Create ChimeraCDBar Number End
	-- Create ImprovedSteadyBar Begin
	if not HB.FramesCreated then self.ImprovedSteadyBar = CreateFrame("StatusBar", "ImprovedSteadyBar", self.MarksFrame) end
	self.ImprovedSteadyBar:SetParent("HBMarksmaship")
	self.ImprovedSteadyBar:SetHeight(self.db.profile.marksmanship.barsheight)
	self.ImprovedSteadyBar:SetWidth(self.db.profile.marksmanship.barswidth)
	--self.ImprovedSteadyBar:SetFrameStrata("PARENT")
	self.ImprovedSteadyBar:SetStatusBarTexture(SharedMedia:Fetch("statusbar", self.db.profile.general.texture))
	self.ImprovedSteadyBar:SetStatusBarColor(HuntBars.db.profile.marksmanship.improvedsscolor["r"], HuntBars.db.profile.marksmanship.improvedsscolor["g"], HuntBars.db.profile.marksmanship.improvedsscolor["b"])
	self.ImprovedSteadyBar:SetOrientation("HORIZONTAL")
	self.ImprovedSteadyBar:SetPoint("TOPLEFT", "HBMarksmaship", "TOPLEFT",
									0, HB.Slots.ISS * (self.db.profile.marksmanship.barsheight+self.db.profile.marksmanship.barsdistance))
	--self.ImprovedSteadyBar:Show()
	self.ImprovedSteadyBar:SetMinMaxValues(0, HuntBars.db.profile.marksmanship.improvedsstime)
	-- Create ImprovedSteadyBar End
	-- Create ImprovedSteadyBar Number Begin
	if not HB.FramesCreated then
		self.ImprovedSteadyBarTextValue = self.ImprovedSteadyBar:CreateFontString("ImprovedSteadyBarTextValue", "PARENT", "GameFontNormal") end
	self.ImprovedSteadyBarTextValue:SetFont(SharedMedia:Fetch("font", self.db.profile.marksmanship.barsfont), self.db.profile.marksmanship.fontsize)
	self.ImprovedSteadyBarTextValue:SetTextColor(1, 1, 1)
	-- self.FocusText:SetJustifyH("LEFT")
	self.ImprovedSteadyBarTextValue:SetPoint("LEFT", self.ImprovedSteadyBar, "LEFT", 5, 0)
	self.ImprovedSteadyBarTextValue:Show()
	if not HB.FramesCreated then
		self.ImprovedSteadyBarTextName = self.ImprovedSteadyBar:CreateFontString("ImprovedSteadyBarTextName", "PARENT", "GameFontNormal") end
	self.ImprovedSteadyBarTextName:SetTextColor(1, 1, 1)
	self.ImprovedSteadyBarTextName:SetFont(SharedMedia:Fetch("font", self.db.profile.marksmanship.barsfont), self.db.profile.marksmanship.fontsize)
	self.ImprovedSteadyBarTextName:SetPoint("RIGHT", self.ImprovedSteadyBar, "RIGHT", 0, 0)
	self.ImprovedSteadyBarTextName:SetText(HB.Text.ImprovedSteady)
	self.ImprovedSteadyBarTextName:Show()
	-- Create ImprovedSteadyBar Number End
	-- Create ReadySetAimBar Begin
	if not HB.FramesCreated then self.ReadySetAimBar = CreateFrame("StatusBar", "ReadySetAimBar", self.MarksFrame) end
	self.ReadySetAimBar:SetParent("HBMarksmaship")
	self.ReadySetAimBar:SetHeight(self.db.profile.marksmanship.barsheight)
	self.ReadySetAimBar:SetWidth(self.db.profile.marksmanship.barswidth)
	--self.ReadySetAimBar:SetFrameStrata("PARENT")
	self.ReadySetAimBar:SetStatusBarTexture(SharedMedia:Fetch("statusbar", self.db.profile.general.texture))
	self.ReadySetAimBar:SetStatusBarColor(HuntBars.db.profile.marksmanship.readysetaimcolor["r"], HuntBars.db.profile.marksmanship.readysetaimcolor["g"], HuntBars.db.profile.marksmanship.readysetaimcolor["b"])
	self.ReadySetAimBar:SetOrientation("HORIZONTAL")
	self.ReadySetAimBar:SetPoint("TOPLEFT", "HBMarksmaship", "TOPLEFT",
								0, HB.Slots.RSA * (self.db.profile.marksmanship.barsheight + self.db.profile.marksmanship.barsdistance))
	--self.ReadySetAimBar:Show()
	self.ReadySetAimBar:SetMinMaxValues(0, self.db.profile.marksmanship.readysetaimtime)
	-- Create ReadySetAimBar End
	-- Create ReadySetAimBar Number Begin
	if not HB.FramesCreated then
		self.ReadySetAimBarTextCD = self.ReadySetAimBar:CreateFontString("ReadySetAimBarTextCD", "PARENT", "GameFontNormal") end
	self.ReadySetAimBarTextCD:SetFont(SharedMedia:Fetch("font", self.db.profile.marksmanship.barsfont), self.db.profile.marksmanship.fontsize)
	self.ReadySetAimBarTextCD:SetTextColor(1, 1, 1)
	self.ReadySetAimBarTextCD:SetPoint("RIGHT", self.ReadySetAimBar, "RIGHT", 0, 0)
	self.ReadySetAimBarTextCD:Show()
	if not HB.FramesCreated then
		self.ReadySetAimBarTextStacks = self.ReadySetAimBar:CreateFontString("ReadySetAimBarTextStacks", "PARENT", "GameFontNormal") end
	self.ReadySetAimBarTextStacks:SetFont(SharedMedia:Fetch("font", self.db.profile.marksmanship.barsfont), self.db.profile.marksmanship.fontsize)
	self.ReadySetAimBarTextStacks:SetTextColor(1, 1, 1)
	self.ReadySetAimBarTextStacks:Show()
	-- Create ReadySetAimBar Number End

	if HuntBars.db.profile.marksmanship.cspos > HuntBars.db.profile.marksmanship.amountmarksbars then
		HuntBars.ChimeraCDBar:Hide()
	elseif HuntBars.db.profile.marksmanship.cspos ~= 0 then
		HuntBars.ChimeraCDBar:Show()
	end
	if HuntBars.db.profile.marksmanship.isspos > HuntBars.db.profile.marksmanship.amountmarksbars then
		HuntBars.ImprovedSteadyBar:Hide()
	elseif HuntBars.db.profile.marksmanship.isspos ~= 0 then
		HuntBars.ImprovedSteadyBar:Show()
	end
	if HuntBars.db.profile.marksmanship.rsapos > HuntBars.db.profile.marksmanship.amountmarksbars then
		HuntBars.ReadySetAimBar:Hide()
	elseif HuntBars.db.profile.marksmanship.rsapos ~= 0 then
		HuntBars.ReadySetAimBar:Show()
	end

	-- MarksFrame Moving Begin
	if not HB.FramesCreated then
		self.MarksFrame:SetScript("OnMouseDown", function(frame, button)
			if (button == "LeftButton") and ((IsShiftKeyDown() and IsControlKeyDown()) or HB.ConfigMode == true) then
				frame:StartMoving()
			end
		end)
		self.MarksFrame:SetScript("OnMouseUp", function(frame, button)
			if (button == "LeftButton") then
				frame:StopMovingOrSizing()
			end
		end)
	end
	-- MarksFrame Moving End
	if HB.ConfigMode then self:DrawConfigMode() end -- Draws filled bars if ConfigMode is enabled
end

-- Draws/Updates Survival bars frame (runs mainly on option change)
function HuntBars:DrawSurvBars()
	-- Create MainFrame Begin
	if not HB.FramesCreated then self.SurvFrame = CreateFrame("Frame", "HBSurv", HB.BarsGeneralFrame) end
	self.SurvFrame:SetClampedToScreen(HuntBars.db.profile.general.clamped)
	if HB.ConfigMode then self.SurvFrame:EnableMouse(true)
		else self.SurvFrame:EnableMouse(not self.db.profile.general.clickthrough) end
	self.SurvFrame:SetHeight((HB.Slots.SurvTotal * self.db.profile.survival.barsheight) +
							((HB.Slots.SurvTotal - 1) * self.db.profile.survival.barsdistance))
	self.SurvFrame:SetWidth(self.db.profile.survival.barswidth)
	if not HB.FramesCreated then self.SurvFrame:SetPoint("CENTER", UIParent, "CENTER", 0,0) end
	self.SurvFrame:SetMovable(true)
	self.SurvFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background",
										edgeFile =nil, -- "Interface/Tooltips/UI-Tooltip-Border",
										tile = true, tileSize = 16, edgeSize = 16,
										insets = { left = -2, right = -2, top = -2, bottom = -2 }})
	self.SurvFrame:SetBackdropColor(0,0,0,HuntBars.db.profile.general.backtransparency)
	-- Create MainFrame End
	if not HB.FramesCreated then self.SurvFocusEst = CreateFrame("StatusBar", "SurvFocusEst", self.SurvFrame) end
	if not HB.FramesCreated then self.SurvFocusBar = CreateFrame("StatusBar", "SurvFocusBar", self.SurvFocusEst) end
	if not HB.FramesCreated then
		self.SurvFocusBarText = self.SurvFocusBar:CreateFontString("SurvFocusBarText", "PARENT", "GameFontNormal")
	end
	if not HB.FramesCreated then self.SurvFocusExpShot = CreateFrame("StatusBar", "SurvFocusExpShot", self.SurvFocusBar) end
	self.SurvFocusBar:Hide()
	if self.db.profile.general.hidefocus == false then
	-- Create SurvFocusEst Begin	
		self.SurvFocusEst:SetParent("HBSurv")
		self.SurvFocusEst:SetHeight(self.db.profile.survival.barsheight)
		self.SurvFocusEst:SetWidth(self.db.profile.survival.barswidth)
		--self.SurvFocusEst:SetFrameStrata("PARENT")
		self.SurvFocusEst:SetStatusBarTexture(SharedMedia:Fetch("statusbar", self.db.profile.general.texture))
		self.SurvFocusEst:SetStatusBarColor(96/255, 96/255, 96/255, 1)
		self.SurvFocusEst:SetOrientation("HORIZONTAL")
		self.SurvFocusEst:SetPoint("TOPLEFT", "HBSurv", "TOPLEFT",0,0)
		self.SurvFocusEst:SetMinMaxValues(0, 100)
		self.SurvFocusEst:Show()
	-- Create SurvFocusEst End
	-- Create SurvFocusBar Begin
		self.SurvFocusBar:SetParent("SurvFocusEst")
		self.SurvFocusBar:SetHeight(self.db.profile.survival.barsheight)
		self.SurvFocusBar:SetWidth(self.db.profile.survival.barswidth)
		--self.SurvFocusBar:SetFrameStrata("PARENT")
		self.SurvFocusBar:SetStatusBarTexture(SharedMedia:Fetch("statusbar", self.db.profile.general.texture))
		self.SurvFocusBar:SetStatusBarColor(255/255, 125/255, 10/255)
		self.SurvFocusBar:SetOrientation("HORIZONTAL")
		self.SurvFocusBar:SetPoint("TOPLEFT", "SurvFocusEst", "TOPLEFT", 0, 0)
		self.SurvFocusBar:Show()
	-- Create SurvFocusBar End
	-- Create Explosive Shot minimum focus amount Begin
		self.SurvFocusExpShot:SetParent("SurvFocusBar")
		self.SurvFocusExpShot:SetHeight(self.db.profile.survival.barsheight)
		self.SurvFocusExpShot:SetWidth(self.db.profile.survival.barswidth)
		--self.SurvFocusExpShot:SetFrameStrata("PARENT")
		self.SurvFocusExpShot:SetStatusBarTexture("Interface\\AddOns\\HuntBars\\Images\\Flat.tga")
		self.SurvFocusExpShot:SetStatusBarColor(96/255, 96/255, 96/255, 0.5)
		self.SurvFocusExpShot:SetOrientation("HORIZONTAL")
		self.SurvFocusExpShot:SetPoint("TOPLEFT", "SurvFocusBar", "TOPLEFT",0,0)
		self.SurvFocusExpShot:SetMinMaxValues(0, 100)
		self.SurvFocusExpShot:SetValue(44)
		self.SurvFocusExpShot:Show()
	-- Create Explosive Shot minimum focus amount End
	-- Create SurvFocusBar Number Begin

		self.SurvFocusBarText:SetFont(SharedMedia:Fetch("font", self.db.profile.survival.barsfont), self.db.profile.survival.fontsize)
		self.SurvFocusBarText:SetTextColor(1, 1, 1)
		-- self.FocusText:SetJustifyH("LEFT")
		self.SurvFocusBarText:SetPoint("CENTER", self.SurvFocusBar, "CENTER", 0, 0)
		self.SurvFocusBarText:Show()
	end
	-- Create SurvFocusBar Number End
	-- Create ExpShotCDBar Begin
	if not HB.FramesCreated then self.ExpShotCDBar = CreateFrame("StatusBar", "ExpShotCDBar", self.SurvFrame) end
	self.ExpShotCDBar:SetParent("HBSurv")
	self.ExpShotCDBar:SetHeight(self.db.profile.survival.barsheight)
	self.ExpShotCDBar:SetWidth(self.db.profile.survival.barswidth)
	--self.ExpShotCDBar:SetFrameStrata("PARENT")
	self.ExpShotCDBar:SetStatusBarTexture(SharedMedia:Fetch("statusbar", self.db.profile.general.texture))
	self.ExpShotCDBar:SetStatusBarColor(HuntBars.db.profile.survival.explosivecolor["r"], HuntBars.db.profile.survival.explosivecolor["g"], HuntBars.db.profile.survival.explosivecolor["b"])
	self.ExpShotCDBar:SetOrientation("HORIZONTAL")
	self.ExpShotCDBar:SetPoint("TOPLEFT", "HBSurv", "TOPLEFT",
								0, HB.Slots.ES * (self.db.profile.survival.barsheight + self.db.profile.survival.barsdistance))
	--self.ExpShotCDBar:Show()
	self.ExpShotCDBar:SetMinMaxValues(0, self.db.profile.survival.explosivetime)
	-- Create ExpShotCDBar End
	-- Create ExpShotCDBar Number Begin
	if not HB.FramesCreated then
		self.ExpShotCDBarTextValue = self.ExpShotCDBar:CreateFontString("ExpShotCDBarTextValue", "PARENT", "GameFontNormal") end
	self.ExpShotCDBarTextValue:SetFont(SharedMedia:Fetch("font", self.db.profile.survival.barsfont), self.db.profile.survival.fontsize)
	self.ExpShotCDBarTextValue:SetTextColor(1, 1, 1)
	self.ExpShotCDBarTextValue:SetPoint("LEFT", self.ExpShotCDBar, "LEFT", 5, 0)
	self.ExpShotCDBarTextValue:Show()
	if not HB.FramesCreated then
		self.ExpShotCDBarTextName = self.ExpShotCDBar:CreateFontString("ExpShotCDBarTextName", "PARENT", "GameFontNormal") end
	self.ExpShotCDBarTextName:SetFont(SharedMedia:Fetch("font", self.db.profile.survival.barsfont), self.db.profile.survival.fontsize)
	self.ExpShotCDBarTextName:SetTextColor(1, 1, 1)
	self.ExpShotCDBarTextName:SetPoint("RIGHT", self.ExpShotCDBar, "RIGHT", 0, 0)
	self.ExpShotCDBarTextName:SetText(HB.Text.ExplosiveShot)
	self.ExpShotCDBarTextName:Show()
	-- Create ExpShotCDBar Number End
	-- Create LocknLoadCDBar Begin
	if not HB.FramesCreated then self.LocknLoadCDBar = CreateFrame("StatusBar", "LocknLoadCDBar", self.SurvFrame) end
	self.LocknLoadCDBar:SetParent("HBSurv")
	self.LocknLoadCDBar:SetHeight(self.db.profile.survival.barsheight)
	self.LocknLoadCDBar:SetWidth(self.db.profile.survival.barswidth)
	--self.LocknLoadCDBar:SetFrameStrata("PARENT")
	self.LocknLoadCDBar:SetStatusBarTexture(SharedMedia:Fetch("statusbar", self.db.profile.general.texture))
	self.LocknLoadCDBar:SetStatusBarColor(HuntBars.db.profile.survival.locknloadcolor["r"], HuntBars.db.profile.survival.locknloadcolor["g"], HuntBars.db.profile.survival.locknloadcolor["b"])
	self.LocknLoadCDBar:SetOrientation("HORIZONTAL")
	self.LocknLoadCDBar:SetPoint("TOPLEFT",	"HBSurv", "TOPLEFT",0,
			HB.Slots.LnL * (self.db.profile.survival.barsheight + self.db.profile.survival.barsdistance))
	--[[Old(Half-sizeed) bar SetPoint calculation
	self.LocknLoadCDBar:SetPoint("TOPLEFT",	"HBSurv", "TOPLEFT",0,
			HB.Slots.LnL *(self.db.profile.survival.barsheight + self.db.profile.survival.barsdistance) + self.db.profile.survival.barsdistance)
	--]]
	--self.LocknLoadCDBar:Show()
	self.LocknLoadCDBar:SetMinMaxValues(0, self.db.profile.survival.locknloadtime)
	-- Create LocknLoadCDBar End
	-- Create LocknLoadCDBar Number Begin
	if not HB.FramesCreated then
		self.LocknLoadCDBarTextValue = self.LocknLoadCDBar:CreateFontString("LocknLoadCDBarTextValue", "PARENT", "GameFontNormal") end
	self.LocknLoadCDBarTextValue:SetFont(SharedMedia:Fetch("font", self.db.profile.survival.barsfont), self.db.profile.survival.fontsize)
	self.LocknLoadCDBarTextValue:SetTextColor(1, 1, 1)
	self.LocknLoadCDBarTextValue:SetPoint("LEFT", self.LocknLoadCDBar, "LEFT", 5, 0)
	self.LocknLoadCDBarTextValue:Show()
	if not HB.FramesCreated then
		self.LocknLoadCDBarTextName = self.LocknLoadCDBar:CreateFontString("LocknLoadCDBarTextName", "PARENT", "GameFontNormal") end
	self.LocknLoadCDBarTextName:SetFont(SharedMedia:Fetch("font", self.db.profile.survival.barsfont), self.db.profile.survival.fontsize)
	self.LocknLoadCDBarTextName:SetTextColor(1, 1, 1)
	self.LocknLoadCDBarTextName:SetPoint("RIGHT", self.LocknLoadCDBar, "RIGHT", 0, 0)
	self.LocknLoadCDBarTextName:SetText(HB.Text.LocknLoad)
	self.LocknLoadCDBarTextName:Show()
	-- Create LocknLoadCDBar Number End
	-- Create BlackArrowCDBar Begin
	if not HB.FramesCreated then
		self.BlackArrowCDBar = CreateFrame("StatusBar", "BlackArrowCDBar", self.SurvFrame) end
	self.BlackArrowCDBar:SetParent("HBSurv")
	self.BlackArrowCDBar:SetHeight(self.db.profile.survival.barsheight)
	self.BlackArrowCDBar:SetWidth(self.db.profile.survival.barswidth)
	--self.BlackArrowCDBar:SetFrameStrata("PARENT")
	self.BlackArrowCDBar:SetStatusBarTexture(SharedMedia:Fetch("statusbar", self.db.profile.general.texture))
	self.BlackArrowCDBar:SetStatusBarColor(HuntBars.db.profile.survival.blackarrowcolor["r"], HuntBars.db.profile.survival.blackarrowcolor["g"], HuntBars.db.profile.survival.blackarrowcolor["b"])
	self.BlackArrowCDBar:SetOrientation("HORIZONTAL")
	self.BlackArrowCDBar:SetPoint("TOPLEFT", "HBSurv", "TOPLEFT", 0,
			HB.Slots.BA *(self.db.profile.survival.barsheight + self.db.profile.survival.barsdistance))
	--self.BlackArrowCDBar:Show()
	self.BlackArrowCDBar:SetMinMaxValues(0, self.db.profile.survival.blackarrowtime)
	-- Create BlackArrowCDBar End
	-- Create BlackArrowCDBar Number Begin
	if not HB.FramesCreated then
		self.BlackArrowCDBarTextValue = self.BlackArrowCDBar:CreateFontString("BlackArrowCDBarTextValue", "PARENT", "GameFontNormal") end
	self.BlackArrowCDBarTextValue:SetFont(SharedMedia:Fetch("font", self.db.profile.survival.barsfont), self.db.profile.survival.fontsize)
	self.BlackArrowCDBarTextValue:SetTextColor(1, 1, 1)
	self.BlackArrowCDBarTextValue:SetPoint("LEFT", self.BlackArrowCDBar, "LEFT", 5, 0)
	self.BlackArrowCDBarTextValue:Show()
	if not HB.FramesCreated then
		self.BlackArrowCDBarTextName = self.BlackArrowCDBar:CreateFontString("BlackArrowCDBarTextName", "PARENT", "GameFontNormal") end
	self.BlackArrowCDBarTextName:SetFont(SharedMedia:Fetch("font", self.db.profile.survival.barsfont), self.db.profile.survival.fontsize)
	self.BlackArrowCDBarTextName:SetTextColor(1, 1, 1)
	self.BlackArrowCDBarTextName:SetPoint("RIGHT", self.BlackArrowCDBar, "RIGHT", 0, 0)
	self.BlackArrowCDBarTextName:SetText(HB.Text.BlackArrow)
	self.BlackArrowCDBarTextName:Show()
	-- Create BlackArrowCDBar Number End

	if HuntBars.db.profile.survival.espos > HuntBars.db.profile.survival.amountsurvbars then
		HuntBars.ExpShotCDBar:Hide()
	elseif HuntBars.db.profile.survival.espos ~= 0 then
		HuntBars.ExpShotCDBar:Show()
	end
	if HuntBars.db.profile.survival.lnlpos > HuntBars.db.profile.survival.amountsurvbars then
		HuntBars.LocknLoadCDBar:Hide()
	elseif HuntBars.db.profile.survival.lnlpos ~= 0 then
		HuntBars.LocknLoadCDBar:Show()
	end
	if HuntBars.db.profile.survival.bapos > HuntBars.db.profile.survival.amountsurvbars then
		HuntBars.BlackArrowCDBar:Hide()
	elseif HuntBars.db.profile.survival.bapos ~= 0 then
		HuntBars.BlackArrowCDBar:Show()
	end

	-- SurvFrame Moving Begin
	if not HB.FramesCreated then
		self.SurvFrame:SetScript("OnMouseDown", function(frame, button)
			if (button == "LeftButton") and ((IsShiftKeyDown() and IsControlKeyDown()) or HB.ConfigMode == true) then
				frame:StartMoving()
			end
		end)
		self.SurvFrame:SetScript("OnMouseUp", function(frame, button)
			if (button == "LeftButton") then
				frame:StopMovingOrSizing()
			end
		end)
	end
	-- SurvFrame Moving End
	if HB.ConfigMode then self:DrawConfigMode() end -- Draws filled bars if ConfigMode is enabled
	
end

-- Draws/Updates Extended mode bars frame (runs mainly on option change)
function HuntBars:DrawAdditBars()
	-- Create MainFrame Begin
	if not HB.FramesCreated then self.AdditFrame = CreateFrame("Frame", "HBAddit", HB.BarsGeneralFrame) end
	self.AdditFrame:SetClampedToScreen(HuntBars.db.profile.general.clamped)
	if HB.ConfigMode then self.AdditFrame:EnableMouse(true)
		else self.AdditFrame:EnableMouse(not self.db.profile.general.clickthrough) end
	self.AdditFrame:SetHeight(HB.Slots.AdditTotal*self.db.profile.addit.barsheight + (HB.Slots.AdditTotal - 1)*self.db.profile.addit.barsdistance)
	self.AdditFrame:SetWidth(self.db.profile.addit.barswidth)
	if not HB.FramesCreated then self.AdditFrame:SetPoint("CENTER", UIParent, "CENTER", 0,0) end
	self.AdditFrame:SetMovable(true)
	self.AdditFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background",
										edgeFile =nil, -- "Interface/Tooltips/UI-Tooltip-Border", 
										tile = true, tileSize = 16, edgeSize = 16,
										insets = { left = -2, right = -2, top = -2, bottom = -2 }})
	self.AdditFrame:SetBackdropColor(0,0,0,HuntBars.db.profile.general.backtransparency)
	-- Create MainFrame End
	-- Create Serpent Sting Bar Begin
	if not HB.FramesCreated then self.SerpentBar = CreateFrame("StatusBar", "SerpentBar", self.AdditFrame) end
	self.SerpentBar:SetParent("HBAddit")
	self.SerpentBar:SetHeight(self.db.profile.addit.barsheight)
	self.SerpentBar:SetWidth(self.db.profile.addit.barswidth)
	--self.SerpentBar:SetFrameStrata("PARENT")
	self.SerpentBar:SetStatusBarTexture(SharedMedia:Fetch("statusbar", self.db.profile.general.texture))
	self.SerpentBar:SetStatusBarColor(HuntBars.db.profile.addit.serpentcolor["r"],HuntBars.db.profile.addit.serpentcolor["g"],HuntBars.db.profile.addit.serpentcolor["b"])
	self.SerpentBar:SetOrientation("HORIZONTAL")
	self.SerpentBar:SetPoint("TOPLEFT", "HBAddit", "TOPLEFT",
									0, HB.Slots.SS * (self.db.profile.addit.barsheight+self.db.profile.addit.barsdistance))
	--self.SerpentBar:Show()
	self.SerpentBar:SetMinMaxValues(0, self.db.profile.addit.serpenttime)
	-- Create Serpent Sting Bar End
	-- Create Serpent Sting Number Begin
	if not HB.FramesCreated then
		self.SerpentBarTextValue = self.SerpentBar:CreateFontString("SerpentBarTextValue", "PARENT", "GameFontNormal") end
	self.SerpentBarTextValue:SetFont(SharedMedia:Fetch("font", self.db.profile.addit.barsfont), self.db.profile.addit.fontsize)
	self.SerpentBarTextValue:SetTextColor(1, 1, 1)
	-- self.FocusText:SetJustifyH("LEFT")
	self.SerpentBarTextValue:SetPoint("LEFT", self.SerpentBar, "LEFT", 5, 0)
	self.SerpentBarTextValue:Show()
	if not HB.FramesCreated then
		self.SerpentBarTextName = self.SerpentBar:CreateFontString("SerpentBarTextName", "PARENT", "GameFontNormal") end
	self.SerpentBarTextName:SetTextColor(1, 1, 1)
	self.SerpentBarTextName:SetFont(SharedMedia:Fetch("font", self.db.profile.addit.barsfont), self.db.profile.addit.fontsize)
	self.SerpentBarTextName:SetPoint("RIGHT", self.SerpentBar, "RIGHT", 0, 0)
	self.SerpentBarTextName:SetText(HB.Text.Serpent)
	self.SerpentBarTextName:Show()
	-- Create Serpent Sting Number End
	-- Create KillShot Bar Begin
	if not HB.FramesCreated then self.KillShotBar = CreateFrame("StatusBar", "KillShotBar", self.AdditFrame) end
	self.KillShotBar:SetParent("HBAddit")
	self.KillShotBar:SetHeight(self.db.profile.addit.barsheight)
	self.KillShotBar:SetWidth(self.db.profile.addit.barswidth)
	--self.KillShotBar:SetFrameStrata("PARENT")
	self.KillShotBar:SetStatusBarTexture(SharedMedia:Fetch("statusbar", self.db.profile.general.texture))
	self.KillShotBar:SetStatusBarColor(HuntBars.db.profile.addit.killshotcolor["r"], HuntBars.db.profile.addit.killshotcolor["g"], HuntBars.db.profile.addit.killshotcolor["b"])
	self.KillShotBar:SetOrientation("HORIZONTAL")
	self.KillShotBar:SetPoint("TOPLEFT", "HBAddit", "TOPLEFT",
								0, HB.Slots.KS * (self.db.profile.addit.barsheight + self.db.profile.addit.barsdistance))
	--self.KillShotBar:Show()
	self.KillShotBar:SetMinMaxValues(0, self.db.profile.addit.killshottime)
	-- Create KillShot Bar End
	-- Create KillShot Bar Number Begin
	if not HB.FramesCreated then
		self.KillShotBarTextValue = self.KillShotBar:CreateFontString("KillShotBarTextValue", "PARENT", "GameFontNormal") end
	self.KillShotBarTextValue:SetFont(SharedMedia:Fetch("font", self.db.profile.addit.barsfont), self.db.profile.addit.fontsize)
	self.KillShotBarTextValue:SetTextColor(1, 1, 1)
	self.KillShotBarTextValue:SetPoint("LEFT", self.KillShotBar, "LEFT", 5, 0)
	self.KillShotBarTextValue:Show()
	if not HB.FramesCreated then
		self.KillShotBarTextName = self.KillShotBar:CreateFontString("KillShotBarTextName", "PARENT", "GameFontNormal") end
	self.KillShotBarTextName:SetFont(SharedMedia:Fetch("font", self.db.profile.addit.barsfont), self.db.profile.addit.fontsize)
	self.KillShotBarTextName:SetTextColor(1, 1, 1)
	self.KillShotBarTextName:SetPoint("RIGHT", self.KillShotBar, "RIGHT", 0, 0)
	self.KillShotBarTextName:SetText(HB.Text.KillShot)
	self.KillShotBarTextName:Show()
	-- Create KillShot Bar Number End
	-- Create Rapid Fire Bar Begin
	if not HB.FramesCreated then self.RapidFireBar = CreateFrame("StatusBar", "RapidFireBar", self.AdditFrame) end
	self.RapidFireBar:SetParent("HBAddit")
	self.RapidFireBar:SetHeight(self.db.profile.addit.barsheight)
	self.RapidFireBar:SetWidth(self.db.profile.addit.barswidth)
	--self.RapidFireBar:SetFrameStrata("PARENT")
	self.RapidFireBar:SetStatusBarTexture(SharedMedia:Fetch("statusbar", self.db.profile.general.texture))
	-- The next line is commented because RF color is set inside OnUpdate function. This is so because RF
	-- changes between 2 colors based on its currently state - (1)the buff is active or (2)on cooldown.
	-- self.RapidFireBar:SetStatusBarColor(HuntBars.db.profile.addit.rapidfirecolor["r"], HuntBars.db.profile.addit.rapidfirecolor["g"], HuntBars.db.profile.addit.rapidfirecolor["b"])
	self.RapidFireBar:SetOrientation("HORIZONTAL")
	self.RapidFireBar:SetPoint("TOPLEFT", "HBAddit", "TOPLEFT",
								0, HB.Slots.RF * (self.db.profile.addit.barsheight + self.db.profile.addit.barsdistance))
	--self.RapidFireBar:Show()
	self.RapidFireBar:SetMinMaxValues(0, self.db.profile.addit.rapidfiretime)
	-- Create RapidFire Bar End
	-- Create RapidFire Bar Number Begin
	if not HB.FramesCreated then
		self.RapidFireBarTextValue = self.RapidFireBar:CreateFontString("RapidFireBarTextValue", "PARENT", "GameFontNormal") end
	self.RapidFireBarTextValue:SetFont(SharedMedia:Fetch("font", self.db.profile.addit.barsfont), self.db.profile.addit.fontsize)
	self.RapidFireBarTextValue:SetTextColor(1, 1, 1)
	self.RapidFireBarTextValue:SetPoint("LEFT", self.RapidFireBar, "LEFT", 5, 0)
	self.RapidFireBarTextValue:Show()
	if not HB.FramesCreated then
		self.RapidFireBarTextName = self.RapidFireBar:CreateFontString("RapidFireBarTextName", "PARENT", "GameFontNormal") end
	self.RapidFireBarTextName:SetFont(SharedMedia:Fetch("font", self.db.profile.addit.barsfont), self.db.profile.addit.fontsize)
	self.RapidFireBarTextName:SetTextColor(1, 1, 1)
	self.RapidFireBarTextName:SetPoint("RIGHT", self.RapidFireBar, "RIGHT", 0, 0)
	self.RapidFireBarTextName:SetText(HB.Text.RapidFire)
	self.RapidFireBarTextName:Show()
	-- Create RapidFire Bar Number End

	HuntBars:DrawCustomBars()

	if HuntBars.db.profile.addit.sspos > HuntBars.db.profile.addit.amountadditbars then
		HuntBars.SerpentBar:Hide()
	elseif HuntBars.db.profile.addit.sspos ~= 0 then
		HuntBars.SerpentBar:Show()
	end
	if HuntBars.db.profile.addit.kspos > HuntBars.db.profile.addit.amountadditbars then
		HuntBars.KillShotBar:Hide()
	elseif HuntBars.db.profile.addit.kspos ~= 0 then
		HuntBars.KillShotBar:Show()
	end
	if HuntBars.db.profile.addit.rfpos > HuntBars.db.profile.addit.amountadditbars then
		HuntBars.RapidFireBar:Hide()
	elseif HuntBars.db.profile.addit.rfpos ~= 0 then
		HuntBars.RapidFireBar:Show()
	end
	if HuntBars.db.profile.addit.cust1pos > HuntBars.db.profile.addit.amountadditbars then
		HuntBars.CustomBar1:Hide()
	elseif HuntBars.db.profile.addit.cust1pos ~= 0 then
		HuntBars.CustomBar1:Show()
	end
	if HuntBars.db.profile.addit.cust2pos > HuntBars.db.profile.addit.amountadditbars then
		HuntBars.CustomBar2:Hide()
	elseif HuntBars.db.profile.addit.cust2pos ~= 0 then
		HuntBars.CustomBar2:Show()
	end
	if HuntBars.db.profile.addit.cust3pos > HuntBars.db.profile.addit.amountadditbars then
		HuntBars.CustomBar3:Hide()
	elseif HuntBars.db.profile.addit.cust3pos ~= 0 then
		HuntBars.CustomBar3:Show()
	end

	-- AdditFrame Moving Begin
	if not HB.FramesCreated then
		self.AdditFrame:SetScript("OnMouseDown", function(frame, button)
			if (button == "LeftButton") and ((IsShiftKeyDown() and IsControlKeyDown()) or HB.ConfigMode == true) then
				frame:StartMoving()
			end
		end)
		self.AdditFrame:SetScript("OnMouseUp", function(frame, button)
			if (button == "LeftButton") then
				frame:StopMovingOrSizing()
			end
		end)
	end
	-- AdditFrame Moving End
	if HB.ConfigMode then self:DrawConfigMode() end -- Draws filled bars if ConfigMode is enabled
end

-- Draws/Updates Custom bars inside Extended mode frame (runs mainly on option change)
function HuntBars:DrawCustomBars()
	-- Create CustomBar1 Begin
	if not HB.FramesCreated then self.CustomBar1 = CreateFrame("StatusBar", "CustomBar1", self.AdditFrame) end
	self.CustomBar1:SetParent("HBAddit")
	self.CustomBar1:SetHeight(self.db.profile.addit.barsheight)
	self.CustomBar1:SetWidth(self.db.profile.addit.barswidth)
	--self.CustomBar1:SetFrameStrata("PARENT")
	self.CustomBar1:SetStatusBarTexture(SharedMedia:Fetch("statusbar", self.db.profile.general.texture))
	self.CustomBar1:SetStatusBarColor(HuntBars.db.profile.addit.cust1color["r"], HuntBars.db.profile.addit.cust1color["g"], HuntBars.db.profile.addit.cust1color["b"])
	self.CustomBar1:SetOrientation("HORIZONTAL")
	self.CustomBar1:SetPoint("TOPLEFT", "HBAddit", "TOPLEFT", 0, (HB.Slots.CUST1) * (self.db.profile.addit.barsheight + self.db.profile.addit.barsdistance))
	--self.CustomBar1:Show()
	self.CustomBar1:SetMinMaxValues(0, self.db.profile.addit.cust1time)
	-- Create CustomBar1 End
	-- Create CustomBar1 Number Begin
	if not HB.FramesCreated then
		self.CustomBar1TextValue = self.CustomBar1:CreateFontString("CustomBar1TextValue", "PARENT", "GameFontNormal") end
	self.CustomBar1TextValue:SetFont(SharedMedia:Fetch("font", self.db.profile.addit.barsfont), self.db.profile.addit.fontsize)
	self.CustomBar1TextValue:SetTextColor(1, 1, 1)
	self.CustomBar1TextValue:SetPoint("LEFT", self.CustomBar1, "LEFT", 5, 0)
	self.CustomBar1TextValue:Show()
	if not HB.FramesCreated then
		self.CustomBar1TextName = self.CustomBar1:CreateFontString("CustomBar1TextName", "PARENT", "GameFontNormal") end
	self.CustomBar1TextName:SetFont(SharedMedia:Fetch("font", self.db.profile.addit.barsfont), self.db.profile.addit.fontsize)
	self.CustomBar1TextName:SetTextColor(1, 1, 1)
	self.CustomBar1TextName:SetPoint("RIGHT", self.CustomBar1, "RIGHT", 0, 0)
	self.CustomBar1TextName:SetText(HB.Text.CustomBar1)
	self.CustomBar1TextName:Show()
	-- Create CustomBar1 Number End

	-- Create CustomBar2 Begin
	if not HB.FramesCreated then self.CustomBar2 = CreateFrame("StatusBar", "CustomBar2", self.AdditFrame) end
	self.CustomBar2:SetParent("HBAddit")
	self.CustomBar2:SetHeight(self.db.profile.addit.barsheight)
	self.CustomBar2:SetWidth(self.db.profile.addit.barswidth)
	--self.CustomBar2:SetFrameStrata("PARENT")
	self.CustomBar2:SetStatusBarTexture(SharedMedia:Fetch("statusbar", self.db.profile.general.texture))
	self.CustomBar2:SetStatusBarColor(HuntBars.db.profile.addit.cust2color["r"], HuntBars.db.profile.addit.cust2color["g"], HuntBars.db.profile.addit.cust2color["b"])
	self.CustomBar2:SetOrientation("HORIZONTAL")
	self.CustomBar2:SetPoint("TOPLEFT", "HBAddit", "TOPLEFT", 0, (HB.Slots.CUST2) * (self.db.profile.addit.barsheight + self.db.profile.addit.barsdistance))
	--self.CustomBar2:Show()
	self.CustomBar2:SetMinMaxValues(0, self.db.profile.addit.cust2time)
	-- Create CustomBar2 End
	-- Create CustomBar2 Number Begin
	if not HB.FramesCreated then
		self.CustomBar2TextValue = self.CustomBar2:CreateFontString("CustomBar2TextValue", "PARENT", "GameFontNormal") end
	self.CustomBar2TextValue:SetFont(SharedMedia:Fetch("font", self.db.profile.addit.barsfont), self.db.profile.addit.fontsize)
	self.CustomBar2TextValue:SetTextColor(1, 1, 1)
	self.CustomBar2TextValue:SetPoint("LEFT", self.CustomBar2, "LEFT", 5, 0)
	self.CustomBar2TextValue:Show()
	if not HB.FramesCreated then
		self.CustomBar2TextName = self.CustomBar2:CreateFontString("CustomBar2TextName", "PARENT", "GameFontNormal") end
	self.CustomBar2TextName:SetFont(SharedMedia:Fetch("font", self.db.profile.addit.barsfont), self.db.profile.addit.fontsize)
	self.CustomBar2TextName:SetTextColor(1, 1, 1)
	self.CustomBar2TextName:SetPoint("RIGHT", self.CustomBar2, "RIGHT", 0, 0)
	self.CustomBar2TextName:SetText(HB.Text.CustomBar2)
	self.CustomBar2TextName:Show()
	-- Create CustomBar2 Number End

	-- Create CustomBar3 Begin
	if not HB.FramesCreated then self.CustomBar3 = CreateFrame("StatusBar", "CustomBar3", self.AdditFrame) end
	self.CustomBar3:SetParent("HBAddit")
	self.CustomBar3:SetHeight(self.db.profile.addit.barsheight)
	self.CustomBar3:SetWidth(self.db.profile.addit.barswidth)
	--self.CustomBar3:SetFrameStrata("PARENT")
	self.CustomBar3:SetStatusBarTexture(SharedMedia:Fetch("statusbar", self.db.profile.general.texture))
	self.CustomBar3:SetStatusBarColor(HuntBars.db.profile.addit.cust3color["r"], HuntBars.db.profile.addit.cust3color["g"], HuntBars.db.profile.addit.cust3color["b"])
	self.CustomBar3:SetOrientation("HORIZONTAL")
	self.CustomBar3:SetPoint("TOPLEFT", "HBAddit", "TOPLEFT", 0, (HB.Slots.CUST3) * (self.db.profile.addit.barsheight + self.db.profile.addit.barsdistance))
	--self.CustomBar3:Show()
	self.CustomBar3:SetMinMaxValues(0, self.db.profile.addit.cust3time)
	-- Create CustomBar3 End
	-- Create CustomBar3 Number Begin
	if not HB.FramesCreated then
		self.CustomBar3TextValue = self.CustomBar3:CreateFontString("CustomBar3TextValue", "PARENT", "GameFontNormal") end
	self.CustomBar3TextValue:SetFont(SharedMedia:Fetch("font", self.db.profile.addit.barsfont), self.db.profile.addit.fontsize)
	self.CustomBar3TextValue:SetTextColor(1, 1, 1)
	self.CustomBar3TextValue:SetPoint("LEFT", self.CustomBar3, "LEFT", 5, 0)
	self.CustomBar3TextValue:Show()
	if not HB.FramesCreated then
		self.CustomBar3TextName = self.CustomBar3:CreateFontString("CustomBar3TextName", "PARENT", "GameFontNormal") end
	self.CustomBar3TextName:SetFont(SharedMedia:Fetch("font", self.db.profile.addit.barsfont), self.db.profile.addit.fontsize)
	self.CustomBar3TextName:SetTextColor(1, 1, 1)
	self.CustomBar3TextName:SetPoint("RIGHT", self.CustomBar3, "RIGHT", 0, 0)
	self.CustomBar3TextName:SetText(HB.Text.CustomBar3)
	self.CustomBar3TextName:Show()
	-- Create CustomBar3 Number End
end

-- "Shortcut" to Draw/Update all 3 specs, exteded mode and standalone focus
function HuntBars:DrawAllBars()
	self:Slots()
	self:DrawBMBars()
	self:DrawMarksBars()
	self:DrawSurvBars()
	self:DrawAdditBars()
	self:DrawSAFocusBar()
end




-- Estimates the amount of focus at the end of Steady/Corba Shot
function HuntBars:GetFocusRegen()
    local _,_,_,_,_,_, castTimeSC, _,_ = GetSpellInfo(56641)
	castTimeSC = castTimeSC / 1000
	local FocusRegen = 4.08 * (1 + GetCombatRatingBonus(19) / 100)
	HB.FocusGain = UnitPower("player") + (FocusRegen * castTimeSC) +9
	return HB.FocusGain
end

-- The actual "engine" of the addon - this function runs every game frame
function HuntBars:OnUpdate(elapsed)
	self.TimeSinceLastUpdate = (self.TimeSinceLastUpdate or 0) + elapsed;
	while (self.TimeSinceLastUpdate > HB.UpdateInterval) do
		if HuntBars.db.profile.general.focusonlymode == false and HB.ConfigMode == false then
			if HB.Spec == 1 then    -- Best Mastery Bars
				-- Draw current state of BMFocusBar Begin
				if HuntBars.db.profile.general.hidefocus == false then
					HuntBars.BMFocusBar:SetMinMaxValues(0, UnitPowerMax("player"))
					if UnitPower("player") >= 60 then
						HuntBars.BMFocusBar:SetStatusBarColor(255/255, 150/255, 10/255)
					else 
						HuntBars.BMFocusBar:SetStatusBarColor(255/255, 40/255, 10/255)
					end
					HuntBars.BMFocusBar:SetValue(UnitPower("player"))
					HuntBars.BMFocusBarText:SetText(UnitPower("player"))
				end
				-- Draw current state of BMFocusBar End
				-- Draw Estimated Focus Begin
				if HB.SteadyCobra == true and HB.FocusExtended == false then
					HuntBars.BMFocusEst:SetValue(HuntBars:GetFocusRegen())
					HB.FocusExtended = true
				elseif HB.FocusExtended == true and (HB.SteadyCobra == false or HB.FocusGain <= UnitPower("player")) then
					HB.FocusExtended = false
					HuntBars.BMFocusEst:SetValue(0)
					HuntBars.MarksFocusEst:SetValue(0)
					HuntBars.SurvFocusEst:SetValue(0)
				end
				-- Draw Estimated Focus End
				-- Draw current state of KillCommandCDBar Begin
				local startKillCommand, durationKillCommand, enabledKillCommand = GetSpellCooldown(34026)
				if (durationKillCommand > 1.5) or (durationKillCommand == 0) then
					HB_durConst = durationKillCommand
					HB_startConst = startKillCommand
				end
				if ((HB_startConst) + (HB_durConst) - GetTime()) >= 0 then
					HuntBars.KillCommandCDBar:SetValue(HB_startConst + HB_durConst - GetTime())
					HuntBars.KillCommandCDBarTextValue:SetText(string.format("%.1f", HB_startConst + HB_durConst - GetTime()))
				else
					HuntBars.KillCommandCDBar:SetValue(0)
					HuntBars.KillCommandCDBarTextValue:SetText(string.format("%.1f", 0.001))
				end
				-- Draw current state of KillCommandCDBar End
				-- Draw current state of FrenzyBar Begin
				local nameFrenzy, _, iconFrenzy, countFrenzy, _, durationFrenzy, expirationTimeFrenzy, unitCasterRFrenzy = UnitAura("pet",
																													  HB.SpellInfo.Frenzy,
																													 nil, "PLAYER|HELPFUL")
				if (nameFrenzy) and (expirationTimeFrenzy > GetTime()) and (countFrenzy < 5) then
					HuntBars.FrenzyBar:SetStatusBarColor(HuntBars.db.profile.beastmastery.frenzycolor["r"], HuntBars.db.profile.beastmastery.frenzycolor["g"], HuntBars.db.profile.beastmastery.frenzycolor["b"])
					HuntBars.FrenzyBar:SetValue(HuntBars.db.profile.beastmastery.frenzytime -
												(countFrenzy * (HuntBars.db.profile.beastmastery.frenzytime / 5)))
					HuntBars.FrenzyBarTextCD:SetText(string.format("%.1f", expirationTimeFrenzy - GetTime()))
					HuntBars.FrenzyBarTextStacks:SetPoint("LEFT", HuntBars.FrenzyBar, "LEFT", (HuntBars.db.profile.beastmastery.barswidth -
						((HuntBars.db.profile.beastmastery.barswidth / 5) * countFrenzy)) - (HuntBars.db.profile.beastmastery.barswidth / 20), 0)
					HuntBars.FrenzyBarTextStacks:SetText(countFrenzy)
				elseif (nameFrenzy) and (expirationTimeFrenzy > GetTime()) and (countFrenzy == 5) then
					HuntBars.FrenzyBar:SetStatusBarColor(HuntBars.db.profile.beastmastery.frenzyextracolor["r"], HuntBars.db.profile.beastmastery.frenzyextracolor["g"], HuntBars.db.profile.beastmastery.frenzyextracolor["b"])
					HuntBars.FrenzyBar:SetValue(expirationTimeFrenzy - GetTime())
					HuntBars.FrenzyBarTextCD:SetText(string.format("%.1f", expirationTimeFrenzy - GetTime()))
					HuntBars.FrenzyBarTextStacks:SetPoint("LEFT", HuntBars.FrenzyBar, "LEFT", 5, 0)
					HuntBars.FrenzyBarTextStacks:SetText(HB.Text.FocusFire5)
				elseif nameFrenzy == nil then
					HuntBars.FrenzyBar:SetStatusBarColor(HuntBars.db.profile.beastmastery.frenzycolor["r"], HuntBars.db.profile.beastmastery.frenzycolor["g"], HuntBars.db.profile.beastmastery.frenzycolor["b"])
					HuntBars.FrenzyBar:SetValue(HuntBars.db.profile.beastmastery.frenzytime)
					HuntBars.FrenzyBarTextCD:SetText(string.format("%.1f", 0.001))
					HuntBars.FrenzyBarTextStacks:SetPoint("LEFT", HuntBars.FrenzyBar, "LEFT", 5, 0)
					HuntBars.FrenzyBarTextStacks:SetText(HB.Text.noFrenzy)
				end
				-- Draw current state of FrenzyBar End
				-- Draw current state of FocusFireCDBar Begin
				local startFocusFire, durationFocusFire, enabledFocusFire = GetSpellCooldown(82692)
				if (durationFocusFire > 1.5) or (durationFocusFire == 0) then
					HB_durConst2 = durationFocusFire
					HB_startConst2 = startFocusFire
				end
				if ((HB_startConst2) + (HB_durConst2) - GetTime()) >= 0 then
					HuntBars.FocusFireCDBar:SetValue(HB_startConst2 + HB_durConst2 - GetTime())
					HuntBars.FocusFireCDBarTextValue:SetText(string.format("%.1f", HB_startConst2 + HB_durConst2 - GetTime()))
				else
					HuntBars.FocusFireCDBar:SetValue(0)
					HuntBars.FocusFireCDBarTextValue:SetText(string.format("%.1f", 0.001))
				end
				-- Draw current state of FocusFireCDBar End
			end
			if HB.Spec == 2 then    -- Marksmanship Bars
				-- Draw current state of MarksFocusBar Begin
				if HuntBars.db.profile.general.hidefocus == false then
					HuntBars.MarksFocusBar:SetMinMaxValues(0, UnitPowerMax("player"))
					if UnitPower("player") >= 64 then
						HuntBars.MarksFocusBar:SetStatusBarColor(255/255, 150/255, 10/255)
					else 
						HuntBars.MarksFocusBar:SetStatusBarColor(255/255, 40/255, 10/255)
					end
					HuntBars.MarksFocusBar:SetValue(UnitPower("player"))
					HuntBars.MarksFocusBarText:SetText(UnitPower("player"))
				end
				-- Draw current state of MarksFocusBar End
				-- Draw Estimated Focus Begin
				if HB.SteadyCobra == true and HB.FocusExtended == false then
					HuntBars.MarksFocusEst:SetValue(HuntBars:GetFocusRegen())
					HB.FocusExtended = true
				elseif HB.FocusExtended == true and (HB.SteadyCobra == false or HB.FocusGain <= UnitPower("player")) then
					HB.FocusExtended = false
					HuntBars.BMFocusEst:SetValue(0)
					HuntBars.MarksFocusEst:SetValue(0)
					HuntBars.SurvFocusEst:SetValue(0)
				end
				-- Draw Estimated Focus End
				-- Draw current state of ChimeraCDBar Begin
				local startChimera, durationChimera, enabledChimera = GetSpellCooldown(53209)
				if (durationChimera > 1.5) or (durationChimera == 0) then
					HB_durConst = durationChimera
					HB_startConst = startChimera
				end
				if ((HB_startConst) + (HB_durConst) - GetTime()) >= 0 then
					HuntBars.ChimeraCDBar:SetValue(HB_startConst + HB_durConst - GetTime())
					HuntBars.ChimeraCDBarTextValue:SetText(string.format("%.1f", HB_startConst + HB_durConst - GetTime()))
				else
					HuntBars.ChimeraCDBar:SetValue(0)
					HuntBars.ChimeraCDBarTextValue:SetText(string.format("%.1f", 0.001))
				end
				-- Draw current state of ChimeraCDBar End
				-- Draw current state of ImprovedSteadyBar Begin
				local nameISS, _,iconISS,countISS, _,durationISS,expirationTimeISS,unitCasterISS = UnitAura("player", HB.SpellInfo.ImprovedSteady,
																												  nil,"PLAYER|HELPFUL")
				if (nameISS ~= nil) and (expirationTimeISS > GetTime()) then
					HuntBars.ImprovedSteadyBar:SetValue(expirationTimeISS - GetTime())
					HuntBars.ImprovedSteadyBarTextValue:SetText(string.format("%.1f", expirationTimeISS - GetTime()))
				else
					HuntBars.ImprovedSteadyBar:SetValue(0)
					HuntBars.ImprovedSteadyBarTextValue:SetText(string.format("%.1f", 0.001))
				end
				-- Draw current state of ImprovedSteadyBar End
				-- Draw current state of ReadySetAimBar/Fire! Begin
				local nameFIRE, _, iconFIRE, countFIRE, _, durationFIRE, expirationTimeFIRE, unitCasterFIRE = UnitAura("player", HB.SpellInfo.Fire,
																														nil, "PLAYER|HELPFUL")
				local nameRSA, _, iconRSA, countRSA, _, durationRSA, expirationTimeRSA, unitCasterRSA = UnitAura("player", HB.SpellInfo.ReadySetAim,
																												  nil, "PLAYER|HELPFUL")
				if (nameRSA) and (expirationTimeRSA > GetTime()) then
					HuntBars.ReadySetAimBar:SetStatusBarColor(HuntBars.db.profile.marksmanship.readysetaimcolor["r"], HuntBars.db.profile.marksmanship.readysetaimcolor["g"], HuntBars.db.profile.marksmanship.readysetaimcolor["b"])
					HuntBars.ReadySetAimBar:SetValue(HuntBars.db.profile.marksmanship.readysetaimtime -
						(countRSA * (HuntBars.db.profile.marksmanship.readysetaimtime / 5)))
					HuntBars.ReadySetAimBarTextCD:SetText(string.format("%.1f", expirationTimeRSA - GetTime()))
					HuntBars.ReadySetAimBarTextStacks:SetPoint("LEFT", HuntBars.ReadySetAimBar, "LEFT", HuntBars.db.profile.marksmanship.barswidth - 
						((HuntBars.db.profile.marksmanship.barswidth / 5) * countRSA) - (HuntBars.db.profile.marksmanship.barswidth / 20), 0)
					HuntBars.ReadySetAimBarTextStacks:SetText(countRSA)
				elseif nameFIRE == nil then
					HuntBars.ReadySetAimBar:SetStatusBarColor(HuntBars.db.profile.marksmanship.readysetaimcolor["r"], HuntBars.db.profile.marksmanship.readysetaimcolor["g"], HuntBars.db.profile.marksmanship.readysetaimcolor["b"])
					HuntBars.ReadySetAimBar:SetValue(HuntBars.db.profile.marksmanship.readysetaimtime)
					HuntBars.ReadySetAimBarTextCD:SetText(string.format("%.1f", 0.001))
					HuntBars.ReadySetAimBarTextStacks:SetPoint("LEFT", HuntBars.ReadySetAimBar, "LEFT", 5, 0)
					HuntBars.ReadySetAimBarTextStacks:SetText(HB.Text.noReadySetAim)
				elseif nameFIRE then
					HuntBars.ReadySetAimBar:SetStatusBarColor(HuntBars.db.profile.marksmanship.readysetaimextracolor["r"], HuntBars.db.profile.marksmanship.readysetaimextracolor["g"], HuntBars.db.profile.marksmanship.readysetaimextracolor["b"])
					HuntBars.ReadySetAimBar:SetValue(expirationTimeFIRE - GetTime())
					HuntBars.ReadySetAimBarTextCD:SetText(string.format("%.1f", expirationTimeFIRE - GetTime()))
					HuntBars.ReadySetAimBarTextStacks:SetPoint("LEFT", HuntBars.ReadySetAimBar, "LEFT", 5, 0)
					HuntBars.ReadySetAimBarTextStacks:SetText(HB.Text.FireAimed)
				end
				-- Draw current state of ReadySetAimBar/Fire! End
			end
			if HB.Spec == 3 then    -- Survival Bars
				-- Draw current state of MarksFocusBar Begin
				if HuntBars.db.profile.general.hidefocus == false then
					HuntBars.SurvFocusBar:SetMinMaxValues(0, UnitPowerMax("player"))
					if UnitPower("player") >= 64 then
						HuntBars.SurvFocusBar:SetStatusBarColor(255/255, 150/255, 10/255)
					else 
						HuntBars.SurvFocusBar:SetStatusBarColor(255/255, 40/255, 10/255)
					end
					HuntBars.SurvFocusBar:SetValue(UnitPower("player"))
					HuntBars.SurvFocusBarText:SetText(UnitPower("player"))
				end
				-- Draw current state of MarksFocusBar End
				-- Draw Estimated Focus Begin
				if HB.SteadyCobra == true and HB.FocusExtended == false then
					HuntBars.SurvFocusEst:SetValue(HuntBars:GetFocusRegen())
					HB.FocusExtended = true
				elseif HB.FocusExtended == true and (HB.SteadyCobra == false or HB.FocusGain <= UnitPower("player")) then
					HB.FocusExtended = false
					HuntBars.BMFocusEst:SetValue(0)
					HuntBars.MarksFocusEst:SetValue(0)
					HuntBars.SurvFocusEst:SetValue(0)
				end
				-- Draw Estimated Focus End
				-- Draw current state of ExpShotCDBar Begin
				local startExpShot, durationExpShot, enabledExpShot = GetSpellCooldown(53301)
				local nameLL, _, iconLL, countLL, _, durationLL, expirationTimeLL, unitCasterLL = UnitAura("player", HB.SpellInfo.LocknLoad,
																											nil, "PLAYER|HELPFUL")
				local nameES, _, iconES, countES, _, durationES, expirationTimeES, unitCasterES = UnitAura("target", HB.SpellInfo.ExplosiveShot,
																											nil, "PLAYER|HARMFUL")
				if (durationExpShot > 1.5) or (DurationExpShot == 0) then
					HB_durConst = durationExpShot
					HB_startConst = startExpShot
				end			
				if nameES and ((startExpShot + durationExpShot - GetTime()) <= 1.5) then
					HuntBars.ExpShotCDBar:SetMinMaxValues(0, 6)
					HuntBars.ExpShotCDBar:SetStatusBarColor(HuntBars.db.profile.survival.explosiveextracolor["r"], HuntBars.db.profile.survival.explosiveextracolor["g"], HuntBars.db.profile.survival.explosiveextracolor["b"])
					HuntBars.ExpShotCDBar:SetValue(expirationTimeES - GetTime())
					HuntBars.ExpShotCDBarTextValue:SetText(string.format("%.1f", expirationTimeES - GetTime()))
				elseif nameLL and ((startExpShot + durationExpShot - GetTime()) <= 1.5) then
					HuntBars.ExpShotCDBar:SetMinMaxValues(0, 6)
					HuntBars.ExpShotCDBar:SetStatusBarColor(HuntBars.db.profile.survival.explosiveextracolor["r"], HuntBars.db.profile.survival.explosiveextracolor["g"], HuntBars.db.profile.survival.explosiveextracolor["b"])
					HuntBars.ExpShotCDBar:SetValue(6)
					HuntBars.ExpShotCDBarTextValue:SetText(HB.Text.procLocknLoad..countLL..HB.Text.NOW)
					--HuntBars.ExpShotCDBarTextName:Hide()
				elseif (HB_startConst + HB_durConst - GetTime()) >= 0 then
					HuntBars.ExpShotCDBar:SetMinMaxValues(0, HuntBars.db.profile.survival.explosivetime)
					HuntBars.ExpShotCDBar:SetStatusBarColor(HuntBars.db.profile.survival.explosivecolor["r"], HuntBars.db.profile.survival.explosivecolor["g"], HuntBars.db.profile.survival.explosivecolor["b"])
					HuntBars.ExpShotCDBar:SetValue(HB_startConst + HB_durConst - GetTime())
					HuntBars.ExpShotCDBarTextValue:SetText(string.format("%.1f", HB_startConst + HB_durConst - GetTime()))
				else
					HuntBars.ExpShotCDBar:SetMinMaxValues(0, HuntBars.db.profile.survival.explosivetime)
					HuntBars.ExpShotCDBar:SetStatusBarColor(HuntBars.db.profile.survival.explosiveextracolor["r"], HuntBars.db.profile.survival.explosiveextracolor["g"], HuntBars.db.profile.survival.explosiveextracolor["b"])
					HuntBars.ExpShotCDBar:SetValue(0)
					HuntBars.ExpShotCDBarTextValue:SetText(string.format("%.1f", 0.001))
				end
				-- Draw current state of ExpShotCDBar End
				-- Draw current state of LocknLoadCDBar Begin
				local startLocknLoad, durationLocknLoad, enabledLocknLoad = GetSpellCooldown(56453)
				if (durationLocknLoad > 1.5) or (durationLocknLoad == 0) then
					HB_durConst3 = durationLocknLoad
					HB_startConst3 = startLocknLoad
				end
				if nameLL then
					HuntBars.LocknLoadCDBar:SetValue(expirationTimeLL - GetTime())
					HuntBars.LocknLoadCDBarTextValue:SetText(string.format("%.1f", expirationTimeLL - GetTime()))
				elseif ((HB_startConst3) + (HB_durConst3) - GetTime()) >= 0 then
					HuntBars.LocknLoadCDBar:SetValue(HB_startConst3 + HB_durConst3 - GetTime())
					HuntBars.LocknLoadCDBarTextValue:SetText(string.format("%.1f", HB_startConst3 + HB_durConst3 - GetTime()))
				else
					HuntBars.LocknLoadCDBar:SetValue(0)
					HuntBars.LocknLoadCDBarTextValue:SetText(string.format("%.1f", 0.001))
				end
				-- Draw current state of LocknLoadCDBar End	
				-- Draw current state of BlackArrowCDBar Begin
				local startBlackArrow, durationBlackArrow, enabledBlackArrow = GetSpellCooldown(3674)
				if (durationBlackArrow > 1.5) or (durationBlackArrow ==0) then
					HB_durConst2 = durationBlackArrow
					HB_startConst2 = startBlackArrow
				end
				if ((HB_startConst2) + (HB_durConst2) - GetTime()) >= 0 then
					HuntBars.BlackArrowCDBar:SetValue(HB_startConst2 + HB_durConst2 - GetTime())
					HuntBars.BlackArrowCDBarTextValue:SetText(string.format("%.1f", HB_startConst2 + HB_durConst2 - GetTime()))
				else
					HuntBars.BlackArrowCDBar:SetValue(0)
					HuntBars.BlackArrowCDBarTextValue:SetText(string.format("%.1f", 0.001))
				end
				-- Draw current state of BlackArrowCDBar End
			end
			if HuntBars.db.profile.addit.additmode == true and HB.ConfigMode == false then    -- Extended mode/Additional Bars
				local nameSS, _,iconSS,countSS, _,durationSS,expirationTimeSS,unitCasterSS = UnitAura("target", HB.SpellInfo.SerpentSting,
																											nil,"PLAYER|HARMFUL")
				-- Draw current state of Serpent Sting Begin
				if (nameSS ~= nil) and (expirationTimeSS > GetTime()) then
					HuntBars.SerpentBar:SetValue(expirationTimeSS - GetTime())
					HuntBars.SerpentBarTextValue:SetText(string.format("%.1f", expirationTimeSS - GetTime()))
				else
					HuntBars.SerpentBar:SetValue(0)
					HuntBars.SerpentBarTextValue:SetText(string.format("%.1f", 0.001))
				end
				-- Draw current state of Serpent Sting End
				-- Draw current state of KillShotBar Begin
				local startKillShot, durationKillShot, enabledKillShot = GetSpellCooldown(53351)
				if (durationKillShot > 1.5) or (durationKillShot == 0) then
					HB_durConst4 = durationKillShot
					HB_startConst4 = startKillShot
				end
				if ((HB_startConst4) + (HB_durConst4) - GetTime()) >= 0 then
					HuntBars.KillShotBar:SetValue(HB_startConst4 + HB_durConst4 - GetTime())
					HuntBars.KillShotBarTextValue:SetText(string.format("%.1f", HB_startConst4 + HB_durConst4 - GetTime()))
				else
					HuntBars.KillShotBar:SetValue(0)
					HuntBars.KillShotBarTextValue:SetText(string.format("%.1f", 0.001))
				end
				-- Draw current state of KillShotBar End
				-- Draw current state of RapidFireBar Begin
				local nameRF, _,iconRF,countRF, _,durationRF,expirationTimeRF,unitCasterRF = UnitAura("player", HB.SpellInfo.RapidFire,
																												  nil,"PLAYER|HELPFUL")
				if (nameRF ~= nil) and (expirationTimeRF > GetTime()) then
					HuntBars.RapidFireBar:SetStatusBarColor(HuntBars.db.profile.addit.rapidfirecolor["r"], HuntBars.db.profile.addit.rapidfirecolor["g"], HuntBars.db.profile.addit.rapidfirecolor["b"])
					HuntBars.RapidFireBar:SetValue(expirationTimeRF - GetTime())
					HuntBars.RapidFireBarTextValue:SetText(string.format("%.1f", expirationTimeRF - GetTime()))
				else
					local startRapidFire, durationRapidFire, enabledRapidFire = GetSpellCooldown(3045)
					HuntBars.RapidFireBar:SetStatusBarColor(HuntBars.db.profile.addit.rapidfireextracolor["r"], HuntBars.db.profile.addit.rapidfireextracolor["g"], HuntBars.db.profile.addit.rapidfireextracolor["b"])
					if (durationRapidFire > 1.5) or (durationRapidFire == 0) then
						HB_durConst5 = durationRapidFire
						HB_startConst5 = startRapidFire
					end
					if ((HB_startConst5) + (HB_durConst5) - GetTime()) >= 0 then
						HuntBars.RapidFireBar:SetValue(HB_startConst5 + HB_durConst5 - GetTime())
						HuntBars.RapidFireBarTextValue:SetText(string.format("%.1f", HB_startConst5 + HB_durConst5 - GetTime()))
					else
						HuntBars.RapidFireBar:SetValue(0)
						HuntBars.RapidFireBarTextValue:SetText(string.format("%.1f", 0.001))
					end
				end
				-- Draw current state of RapidFireBar End
				HuntBars:CustomBar_OnUpdate()
			end
		end -- End of HuntBars.db.profile.general.focusonlymode=false clause
		if HuntBars.db.profile.general.focusonlymode == true and HB.ConfigMode == false then
			-- Draw current state of SAFocusBar Begin
			HuntBars.SAFocusBar:SetMinMaxValues(0, UnitPowerMax("player"))
			if HB.Spec == 1 then MainPlusArcane = 60 else MainPlusArcane = 64 end
			if UnitPower("player") >= MainPlusArcane then
				HuntBars.SAFocusBar:SetStatusBarColor(255/255, 150/255, 10/255)
			else 
				HuntBars.SAFocusBar:SetStatusBarColor(255/255, 40/255, 10/255)
			end
			HuntBars.SAFocusBar:SetValue(UnitPower("player"))
			HuntBars.SAFocusBarText:SetText(UnitPower("player"))
			-- Draw current state of SAFocusBar End
			-- Draw Estimated Focus Begin
			if HB.SteadyCobra == true and HB.FocusExtended == false then
				HuntBars.SAFocusEst:SetValue(HuntBars:GetFocusRegen())
				HB.FocusExtended = true
			elseif HB.FocusExtended == true and (HB.SteadyCobra == false or HB.FocusGain <= UnitPower("player")) then
				HB.FocusExtended = false
				HuntBars.SAFocusEst:SetValue(0)
			end
			-- Draw Estimated Focus End
		end -- End of HuntBars.db.profile.general.focusonlymode clause
		
		self.TimeSinceLastUpdate = self.TimeSinceLastUpdate - HB.UpdateInterval -- Resets self.TimeSinceLastUpdate with the
																				-- value remaining above HB.UpdateInterval
	end -- End of self.TimeSinceLastUpdate > HB.UpdateInterval while-loop
end

-- The "engine" part responsible for custom bars update, called from within function HuntBars:OnUpdate(elapsed)
function HuntBars:CustomBar_OnUpdate()
	-- Custom Bar 1 update Begin
	if HuntBars.db.profile.addit.c1ID then 
		if HuntBars.db.profile.addit.c1type == "cooldown" then
			-- Draw current state of CDBar Begin
			local startCust1, durationCust1, enabledCust1 = GetSpellCooldown(HuntBars.db.profile.addit.c1ID)
			if durationCust1 and ((durationCust1 > 1.5) or (durationCust1 == 0)) then
				HB_durConst6 = durationCust1
				HB_startConst6 = startCust1
			end
			if ((HB_startConst6) + (HB_durConst6) - GetTime()) >= 0 then
				HuntBars.CustomBar1:SetValue(HB_startConst6 + HB_durConst6 - GetTime())
				HuntBars.CustomBar1TextValue:SetText(string.format("%.1f", HB_startConst6 + HB_durConst6 - GetTime()))
			else
				HuntBars.CustomBar1:SetValue(0)
				HuntBars.CustomBar1TextValue:SetText(string.format("%.1f", 0.001))
			end
			-- Draw current state of CDBar End
		elseif HuntBars.db.profile.addit.c1type == "debuff" then
			-- Draw current state of DEBUFFBar Begin
			if HuntBars.db.profile.addit.cust1otherscast == true then HB.cust1filter = "HARMFUL" else HB.cust1filter = "PLAYER|HARMFUL" end
			local nameDEBUFF, _, iconDEBUFF, countDEBUFF, _, durationDEBUFF, expirationTimeDEBUFF, unitCasterDEBUFF = UnitAura("target", HuntBars.db.profile.addit.c1ID, nil, HB.cust1filter)
			if (nameDEBUFF ~= nil) and (expirationTimeDEBUFF > GetTime()) then
				HuntBars.CustomBar1:SetValue(expirationTimeDEBUFF - GetTime())
				HuntBars.CustomBar1TextValue:SetText(string.format("%.1f", expirationTimeDEBUFF - GetTime()))
			else
				HuntBars.CustomBar1:SetValue(0)
				HuntBars.CustomBar1TextValue:SetText(string.format("%.1f", 0.001))
			end
			-- Draw current state of DEBUFFBar End
		elseif HuntBars.db.profile.addit.c1type == "buff" then
			-- Draw current state of BUFFBar Begin
			if HuntBars.db.profile.addit.cust1otherscast == true then HB.cust1filter = "HELPFUL" else HB.cust1filter = "PLAYER||HELPFUL" end
			local nameBUFF, _, iconBUFF, countBUFF, _, durationBUFF, expirationTimeBUFF, unitCasterBUFF = UnitAura("player", HuntBars.db.profile.addit.c1ID, nil, HB.cust1filter)
			if (nameBUFF ~= nil) and (expirationTimeBUFF > GetTime()) then
				HuntBars.CustomBar1:SetValue(expirationTimeBUFF - GetTime())
				HuntBars.CustomBar1TextValue:SetText(string.format("%.1f", expirationTimeBUFF - GetTime()))
			else
				HuntBars.CustomBar1:SetValue(0)
				HuntBars.CustomBar1TextValue:SetText(string.format("%.1f", 0.001))
			end
			-- Draw current state of BUFFBar End
		end
	end
	-- Custom Bar 1 update End
	-- Custom Bar 2 update Begin
	if HuntBars.db.profile.addit.c2ID then 
		if HuntBars.db.profile.addit.c2type == "cooldown" then
			-- Draw current state of CDBar Begin
			local startCust2, durationCust2, enabledCust2 = GetSpellCooldown(HuntBars.db.profile.addit.c2ID)
			if durationCust2 and ((durationCust2 > 1.5) or (durationCust2 == 0)) then
				HB_durConst7 = durationCust2
				HB_startConst7 = startCust2
			end
			if ((HB_startConst7) + (HB_durConst7) - GetTime()) >= 0 then
				HuntBars.CustomBar2:SetValue(HB_startConst7 + HB_durConst7 - GetTime())
				HuntBars.CustomBar2TextValue:SetText(string.format("%.1f", HB_startConst7 + HB_durConst7 - GetTime()))
			else
				HuntBars.CustomBar2:SetValue(0)
				HuntBars.CustomBar2TextValue:SetText(string.format("%.1f", 0.001))
			end
			-- Draw current state of CDBar End
		elseif HuntBars.db.profile.addit.c2type == "debuff" then
			-- Draw current state of DEBUFFBar Begin
			if HuntBars.db.profile.addit.cust2otherscast == true then HB.cust2filter = "HARMFUL" else HB.cust2filter = "PLAYER|HARMFUL" end
			local nameDEBUFF, _, iconDEBUFF, countDEBUFF, _, durationDEBUFF, expirationTimeDEBUFF, unitCasterDEBUFF = UnitAura("target", HuntBars.db.profile.addit.c2ID, nil, HB.cust2filter)
			if (nameDEBUFF ~= nil) and (expirationTimeDEBUFF > GetTime()) then
				HuntBars.CustomBar2:SetValue(expirationTimeDEBUFF - GetTime())
				HuntBars.CustomBar2TextValue:SetText(string.format("%.1f", expirationTimeDEBUFF - GetTime()))
			else
				HuntBars.CustomBar2:SetValue(0)
				HuntBars.CustomBar2TextValue:SetText(string.format("%.1f", 0.001))
			end
			-- Draw current state of DEBUFFBar End
		elseif HuntBars.db.profile.addit.c2type == "buff" then
			-- Draw current state of BUFFBar Begin
			if HuntBars.db.profile.addit.cust2otherscast == true then HB.cust2filter = "HELPFUL" else HB.cust2filter = "PLAYER|HELPFUL" end
			local nameBUFF, _, iconBUFF, countBUFF, _, durationBUFF, expirationTimeBUFF, unitCasterBUFF = UnitAura("player", HuntBars.db.profile.addit.c2ID, nil, HB.cust2filter)
			if (nameBUFF ~= nil) and (expirationTimeBUFF > GetTime()) then
				HuntBars.CustomBar2:SetValue(expirationTimeBUFF - GetTime())
				HuntBars.CustomBar2TextValue:SetText(string.format("%.1f", expirationTimeBUFF - GetTime()))
			else
				HuntBars.CustomBar2:SetValue(0)
				HuntBars.CustomBar2TextValue:SetText(string.format("%.1f", 0.001))
			end
			-- Draw current state of BUFFBar End
		end
	end
	-- Custom Bar 2 update End
	-- Custom Bar 3 update Begin
	if HuntBars.db.profile.addit.c3ID then 
		if HuntBars.db.profile.addit.c3type == "cooldown" then
			-- Draw current state of CDBar Begin
			local startCust3, durationCust3, enabledCust3 = GetSpellCooldown(HuntBars.db.profile.addit.c3ID)
				if durationCust3 and ((durationCust3 > 1.5) or (durationCust3 == 0)) then
					HB_durConst8 = durationCust3
					HB_startConst8 = startCust3
				end
			if ((HB_startConst8) + (HB_durConst8) - GetTime()) >= 0 then
				HuntBars.CustomBar3:SetValue(HB_startConst8 + HB_durConst8 - GetTime())
				HuntBars.CustomBar3TextValue:SetText(string.format("%.1f", HB_startConst8 + HB_durConst8 - GetTime()))
			else
				HuntBars.CustomBar3:SetValue(0)
				HuntBars.CustomBar3TextValue:SetText(string.format("%.1f", 0.001))
			end
			-- Draw current state of CDBar End
		elseif HuntBars.db.profile.addit.c3type == "debuff" then
			-- Draw current state of DEBUFFBar Begin
			if HuntBars.db.profile.addit.cust3otherscast == true then HB.cust3filter = "HARMFUL" else HB.cust3filter = "PLAYER|HARMFUL" end
			local nameDEBUFF, _, iconDEBUFF, countDEBUFF, _, durationDEBUFF, expirationTimeDEBUFF, unitCasterDEBUFF = UnitAura("target", HuntBars.db.profile.addit.c3ID, nil, HB.cust3filter)
			if (nameDEBUFF ~= nil) and (expirationTimeDEBUFF > GetTime()) then
				HuntBars.CustomBar3:SetValue(expirationTimeDEBUFF - GetTime())
				HuntBars.CustomBar3TextValue:SetText(string.format("%.1f", expirationTimeDEBUFF - GetTime()))
			else
				HuntBars.CustomBar3:SetValue(0)
				HuntBars.CustomBar3TextValue:SetText(string.format("%.1f", 0.001))
			end
			-- Draw current state of DEBUFFBar End
		elseif HuntBars.db.profile.addit.c3type == "buff" then
			-- Draw current state of BUFFBar Begin
			if HuntBars.db.profile.addit.cust3otherscast == true then HB.cust3filter = "HELPFUL" else HB.cust3filter = "PLAYER||HELPFUL" end
			local nameBUFF, _, iconBUFF, countBUFF, _, durationBUFF, expirationTimeBUFF, unitCasterBUFF = UnitAura("player", HuntBars.db.profile.addit.c3ID, nil, HB.cust3filter)
			if (nameBUFF ~= nil) and (expirationTimeBUFF > GetTime()) then
				HuntBars.CustomBar3:SetValue(expirationTimeBUFF - GetTime())
				HuntBars.CustomBar3TextValue:SetText(string.format("%.1f", expirationTimeBUFF - GetTime()))
			else
				HuntBars.CustomBar3:SetValue(0)
				HuntBars.CustomBar3TextValue:SetText(string.format("%.1f", 0.001))
			end
			-- Draw current state of BUFFBar End
		end
	end
	-- Custom Bar 3 update End
end




-- Used to detect when Steady/Cobra Shot is fired/failed to draw/hide estimated focus
function HuntBars:COMBAT_LOG_EVENT_UNFILTERED(_, _,event,_,_,sourceName,_,_,_,desName,_,_,spellID,_,_,message)
	if (sourceName == UnitName("player")) and ((spellID == 56641) or (spellID == 77767)) and (event == "SPELL_CAST_START") then
		HB.SteadyCobra = true
	elseif (sourceName == UnitName("player")) and ((spellID == 56641) or (spellID == 77767)) and ((event == "SPELL_CAST_FAILED" or event == "SPELL_INTERRUPT") and message ~= SPELL_FAILED_SPELL_IN_PROGRESS) then
		HB.SteadyCobra = false	
		HB.FocusExtended = false
		HuntBars.BMFocusEst:SetValue(0)
		HuntBars.MarksFocusEst:SetValue(0)
		HuntBars.SurvFocusEst:SetValue(0)
	end
end

-- Used to detect when Steady/Cobra Shot is successful to hide estimated focus
function HuntBars:UNIT_SPELLCAST_SUCCEEDED(_, unit,_,_,_,spellID)
	if unit == "player" and ((spellID == 56641) or (spellID == 77767)) then
		HB.SteadyCobra = false
	end
	if unit == "player" and ((spellID ~= 56641) and (spellID ~= 77767) and (spellID ~= 75)) then
		HB.SteadyCobra = false
		--[[ Next 4 rows may be removed after testing if focus preview is ok without them!!!
		HB.FocusExtended = false
		HuntBars.BMFocusEst:SetValue(0)
		HuntBars.MarksFocusEst:SetValue(0)
		HuntBars.SurvFocusEst:SetValue(0)
		--]]
	end
end

-- Swaps bars when primary/secondary spec is changed
function HuntBars:PLAYER_TALENT_UPDATE()
	HuntBars:DrawAllBars()
    HB.Spec = GetPrimaryTalentTree()
	if not HB.ConfigMode then
		HuntBars.BMFrame:Hide()
		HuntBars.MarksFrame:Hide()
		HuntBars.SurvFrame:Hide()
		if HB.Spec == 1 then
			HuntBars.BMFrame:Show()
		elseif HB.Spec == 2 then
			HuntBars.MarksFrame:Show()
		elseif HB.Spec == 3 then
			HuntBars.SurvFrame:Show()
		end
	end
end

-- Hides the frames at the end of combat if "In Combat Only" is enabled
function HuntBars:PLAYER_REGEN_ENABLED()
	if self.db.profile.general.incombatonly == true and HB.ConfigMode == false then
		HBAddonGeneralFrame:Hide()
	end
end

-- Shows the frames at the beginning of combat if "In Combat Only" is enabled
function HuntBars:PLAYER_REGEN_DISABLED()
	if self.db.profile.general.incombatonly == true and HB.ConfigMode == false then
		HBAddonGeneralFrame:Show()
	end
end




-- Next 2 functions(OnInitialize and OnEnable) are the first ones executed at login. With them begins the addon logic.
-- Next function (OnInitialize) is run-once initial setting up (as opposed to OnEnable function that is executed at every addon enabling)
function HuntBars:OnInitialize()
	local LocalClass, UniversalClass = UnitClass("player")
	if (UniversalClass == "HUNTER") then
		-- Register Events
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
		self:RegisterEvent("PLAYER_TALENT_UPDATE")
		self:RegisterEvent("PLAYER_REGEN_ENABLED")
		self:RegisterEvent("PLAYER_REGEN_DISABLED")
		-- Register Ace Options
		self.db = LibStub("AceDB-3.0"):New("HuntBarsDB", HuntBarsDefaults)
		AceConfig:RegisterOptionsTable("HuntBars", HuntBarsOptions, {"huntbars", "hbars", "hbfe"})
		AceConfigDialog:AddToBlizOptions("HuntBars", nil, nil, "general")
		AceConfigDialog:AddToBlizOptions("HuntBars", "Beast Mastery", "HuntBars", "beastmastery")
		AceConfigDialog:AddToBlizOptions("HuntBars", "Marksmanship", "HuntBars", "marksmanship")
		AceConfigDialog:AddToBlizOptions("HuntBars", "Survival", "HuntBars", "survival")
		AceConfigDialog:AddToBlizOptions("HuntBars", "Extended/Focus", "HuntBars", "addit")
		-- Create LibDataBroker button
		ldbObj = LDB:NewDataObject("HuntBars", ldbObj)
		-- Draw frames/bars and register/initialize nonAce variables
		self:AssignSpellNames()
		self:DrawAllBars()
		HB.FramesCreated = true
		-- Read and apply frames shown/hidden states as they were set in options panel at logoff
		self:PLAYER_TALENT_UPDATE()
		if self.db.profile.general.incombatonly == true and not InCombatLockdown() then
			HBAddonGeneralFrame:Hide()
		else
			HBAddonGeneralFrame:Show()
		end
		if self.db.profile.addit.additmode == true then
			self.AdditFrame:Show()
		else
			self.AdditFrame:Hide()
		end
		if self.db.profile.general.focusonlymode == true then
			HB.BarsGeneralFrame:Hide()
			HB.SAFocusGeneralFrame:Show()
		else
			HB.BarsGeneralFrame:Show()
			HB.SAFocusGeneralFrame:Hide()
		end
		HB.BarsGeneralFrame:SetFrameStrata(HuntBars.db.profile.general.strata)
		HB.SAFocusGeneralFrame:SetFrameStrata(HuntBars.db.profile.general.strata)
		-- Read for already loaded LibShredMedia components
		SharedMedia.RegisterCallback(self, "LibSharedMedia_Registered", "DrawAllBars")
		-- Launch update-on-new-frame "engine"
		OnUpdateFrame:SetScript("OnUpdate", HuntBars.OnUpdate)
		-- In chat message 
		HuntBars:Print(L["Player class: "], LocalClass, L[". Addon loaded!"])
	else
		self:Print(L["Player class: "], LocalClass, L[". Addon requires Hunter class. Loading process skipped."])
	end
end

-- Ace function for addon enabling
function HuntBars:OnEnable()
	local LocalClass, UniversalClass = UnitClass("player")
	if UniversalClass ~= "HUNTER" then return end
	self:AssignSpellNames()
	self:DrawAllBars()
end

-- Ace function for addon disabling
function HuntBars:OnDisable()

end


-- End of huntbars.lua